'From Squeak 2.0 BETA of May 8, 1998 on 20 May 1998 at 3:07:29 am'!
"Change Set:		sw_wedRemovalsEtc
Date:			20 May 1998
Author:			Scott Wallace

Mostly method removals, but also a critical fix to the look-like (wearCostume:) feature, the odd cleanup elsewhere, and a couple of class comments"!

Player class
	instanceVariableNames: 'scripts slotInfo costumeDictionary '!

!ChangeSet methodsFor: 'fileIn/Out' stamp: 'sw 5/20/1998 02:59'!
fileOutPSFor: class on: stream 
	"Write out removals and initialization for this class."

	(methodChanges at: class name ifAbsent: [^ self]) associationsDo: [:mAssoc | 
		(#(remove addedThenRemoved) includes: mAssoc value)
			ifTrue:
				[stream nextChunkPut: class name,
					' removeSelector: ', mAssoc key storeString; cr]
			ifFalse:
				[(mAssoc key = #initialize and: [class isMeta]) ifTrue:
					[stream nextChunkPut: class soleInstance name, ' initialize'; cr]]]! !


!PartsViewer commentStamp: 'sw 5/20/1998 03:07' prior: 0!
The so-called Viewer -- a kind of browser and inspector for a singleton object.

scriptedPlayer - the player whom I am viewing
partsBank - a number representing which of several possible banks of parts is showing
scriptsBank - a number representing which of several possible banks of scripts is showing.!

!PasteUpMorph commentStamp: 'sw 5/20/1998 03:07' prior: 0!
A morph whose submorphs comprise a paste-up of rectangular subparts which "show through".

Facilities commonly needed on pages of graphical presentations and on simulation playfields, such as the painting of new objects, turtle trails, gradient fills, background paintings, parts-bin behavior, collision-detection, etc., are (or will be) provided.

This class is young and still under construction, and a number of its (many) instance variables are not yet fully deployed.!

!Player methodsFor: 'costume' stamp: 'sw 5/20/1998 02:29'!
costume: aMorph
	"Make aMorph be the receiver's current costume"
	| itsBounds |
	costume == aMorph ifTrue: [^ self].
	((costume isKindOf: SketchMorph) and: [(aMorph isKindOf: SketchMorph)])
		ifTrue:
			[^ costume wearCostume: aMorph].

	costume ifNotNil:
		[itsBounds _ costume bounds.
		costume owner replaceSubmorph: costume by: aMorph.
		aMorph position: itsBounds origin.
		aMorph actorState: costume actorState.
		aMorph setNameTo: costume externalName].
	aMorph costumee: self.
	self costumeDictionary at: aMorph formalCostumeName put: aMorph.
	costume _ aMorph.
	aMorph arrangeToStartStepping! !

!Player methodsFor: 'costume' stamp: 'sw 5/20/1998 02:32'!
wearCostumeOf: anotherPlayer
	"Put on a costume similar to the one currently worn by anotherPlayer"
	self costume: anotherPlayer costume fullCopy! !

!Player methodsFor: 'slots-user' stamp: 'sw 5/20/1998 01:40'!
removeSlotNamed: aSlotName
	(self okayToRemoveSlotNamed: aSlotName) ifFalse:
		[^ self inform: 'Sorry, ', aSlotName, ' is in
use in a script.'].

	self notYetImplemented! !


!ScriptEditorMorph methodsFor: 'buttons' stamp: 'sw 5/20/1998 01:33'!
destroyScript
	| aMenu reply |
	(playerScripted okayToDestroyScriptNamed: scriptName)
		ifFalse:
			[^ self inform: 'Sorry, this script is being called
from another script.'].

	(self isAnonymous not and: [submorphs size > 1]) ifTrue:
		[aMenu _ SelectionMenu selections: #('destroy it' 'oops, no, don''t destroy').
		reply _ aMenu startUpWithCaption: 'Do you really want to
destroy this script?'.
		(reply = 'destroy it') ifFalse: [^ self]].

	self actuallyDestroyScript! !


ActorState removeSelector: #acceptableNameFrom:!
EToyHolder removeSelector: #OLDinitializeScaffoldingContentsForReloadedEToy!
EToyHolder removeSelector: #rootModelClass!
EToyHolder removeSelector: #scaffoldingPaintingStrings!
EToyHolder removeSelector: #OLDscaffoldingTabInfo!
EToyHolder removeSelector: #scaffoldingBook:!
EToyHolder removeSelector: #scaffoldingHelpStrings!
EToyHolder removeSelector: #converttgpspm0:tspm0:!
EToyHolder removeSelector: #OLDinitializeScaffoldingContentsForFreshEToy!
EToyHolder removeSelector: #playfield:!
DriveACar removeSelector: #eToyTitle!
EToyHolder class removeSelector: #userStuffBook:!
EToyPlayer class removeSelector: #initializeAddedForms!
EToyPlayer class removeSelector: #openDriveACar!
EToySystem class removeSelector: #tileCaretColor!
EToySystem class removeSelector: #uniformTileBorderColor!
FindTheLight removeSelector: #eToyTitle!
Morph removeSelector: #onTicksSelector!
Morph removeSelector: #addLink:!
ButtonMorph removeSelector: #parts!
ButtonMorph removeSelector: #lastScriptEditor!
ButtonMorph removeSelector: #initScripts!
CompoundTileMorph removeSelector: #deleteFromLastVersAt:!
EToyPalette removeSelector: #updateAll!
EToyPalette removeSelector: #booleanSingletonTiles!
EToyPalette removeSelector: #labelForTilesPalette!
EToyPalette removeSelector: #otherTiles!
EToyPalette removeSelector: #arithmeticSingletonTiles!
EToyPalette removeSelector: #userStuffPalette!
EToyPalette removeSelector: #userStuffPalette:!
PartsViewer removeSelector: #setterButtonFor:type:!
PartsViewer removeSelector: #tearOffTileForPlayer!
PartsViewer removeSelector: #tileBinFor:!
PartsViewer removeSelector: #colorUnderPhraseFor:!
Player removeSelector: #possiblyDestroyScriptNamed:!
Player removeSelector: #addSlotNamed:withValue:!
Player removeSelector: #onClick!
Player removeSelector: #runScriptsForMouseUpIn:event:!
Player removeSelector: #possiblyDestroySlotNamed:!
Player removeSelector: #balloonText!
Player removeSelector: #addMethod!
Player removeSelector: #scratch!
Player class removeSelector: #proto!
Player class removeSelector: #newPrototype!
Presenter removeSelector: #addLeftHandButtonsTo:!
Presenter removeSelector: #addBalloonHelpForStopStepGoButtons!
Presenter removeSelector: #standardPalette:!
Presenter removeSelector: #standardPlayfield:!
Presenter removeSelector: #haloControlButton!
EToyPlayer removeSelector: #stopOrGoStillDown:with:!
ScriptEditorMorph removeSelector: #makeButtonForScript!
ScriptEditorMorph removeSelector: #firstTileRow!
ScriptEditorMorph removeSelector: #addYesNo!
ScriptEditorMorph removeSelector: #colorWhenStopped!
ScriptEditorMorph removeSelector: #goOuterScript!
ScriptEditorMorph removeSelector: #hasMultipleTiles:!
ScriptEditorMorph removeSelector: #makeButton!
ScriptInstantiation removeSelector: #runsOnTicks!
ScriptInstantiation removeSelector: #runOnClick!
SketchEditorMorph removeSelector: #initializeFor:inWorld:!
StandardScriptingSystem removeSelector: #userScriptsPerBank!
SystemBookWindow removeSelector: #paneMorphs!
TileMorph removeSelector: #slotRefType!
TileMorph removeSelector: #setSlotRef:in:actualObject:!
TileMorph removeSelector: #operatorReadoutString!
TileMorph removeSelector: #convertbosfcepbbttsloadus0:bosfcepbbttsloadustln0:!
TileMorph removeSelector: #operatorReadoutString:!
UpdatingRectangleMorph removeSelector: #getSelector!
UserScript removeSelector: #makeScriptEditorWithStatus:!
WorldMorph removeSelector: #windowLabel:!
EToyWorld removeSelector: #suggestedNamesFor:!
WorldMorph class removeSelector: #openBlank!
