'From Squeak 2.0 of May 22, 1998 on 27 May 1998 at 8:49:52 pm'!
"Change Set:		WindowRelabel-di
Date:			27 May 1998
Author:			Dan Ingalls

Install basic (via morph menu) facility for relabelling SystemWindows"!


!Browser methodsFor: 'message functions' stamp: 'di 5/27/1998 15:45'!
removeMessage
	"If a message is selected, create a Confirmer so the user can verify that 
	the currently selected message should be removed from the system. If so, 
	remove it.  If the Preference 'confirmMethodRemoves' is set to false, the 
	confirmer is bypassed."
	| messageName confirmation |

	messageListIndex = 0 ifTrue: [^ self].
	self okToChange ifFalse: [^ self].
	messageName _ self selectedMessageName.
	confirmation _ self selectedClassOrMetaClass confirmRemovalOf: messageName.
	confirmation == 3 ifTrue: [^ self].

	self selectedClassOrMetaClass removeSelector: self selectedMessageName.
	self messageListIndex: 0.
	self changed: #messageList.
	self setClassOrganizer.  "In case organization not cached"

	confirmation == 2 ifTrue:
		[Smalltalk browseAllCallsOn: messageName]
! !


!SystemWindow methodsFor: 'label' stamp: 'di 5/27/1998 15:32'!
relabel
	| newLabel |
	newLabel _ FillInTheBlank request: 'New label for this window'
						initialAnswer: labelString.
	newLabel isEmpty ifFalse: [self setLabel: newLabel]! !

!SystemWindow methodsFor: 'menu' stamp: 'di 5/27/1998 15:46'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'relabel' action: #relabel.! !


SystemWindow removeSelector: #addMenuItems:hand:!
