'From Squeak 2.0 of May 22, 1998 on 27 May 1998 at 7:04:27 pm'!
"Change Set:		MiscFixes-wod
Date:			27 May 1998
Author:			William O. Dargel     wdargel@shoshana.com

A few miscellaneous bug fixes. 

* ChangeSet fileOut -- use 'asFileName' rather than 'truncateTo: 27'. Allows preserving longer change set names on systems that support it.

* FileList fileAllIn -- open the file using 'readOnlyFileNamed:' rather than 'oldFileNamed:'. Allows the filing-in of read-only files.

* FileList updateFileList -- set the fileName to nil. Allows the file list menu to revert to the 'noFileSelectedMenu:'.

* Debugger selection -- two fixes unearthed from an old change set.

* Class comments -- ability to fileIn the form written by a changeList
"!


!ChangeSet methodsFor: 'fileIn/Out' stamp: 'wod 5/12/1998 18:27'!
fileOut
	"File out the receiver, to a file whose name is a function of the change-set name and of the date and the time."
	"wod 5/12/1998: use #asFileName rather than #truncateTo:"
	| file slips |
	Cursor write showWhile: [
		file _ FileStream newFileNamed:
			(self name, FileDirectory dot, Utilities dateTimeSuffix, FileDirectory dot, 'cs') asFileName.
		file header; timeStamp.
		self fileOutPreambleOn: file.
		self fileOutOn: file.
		self fileOutPostscriptOn: file.
		file trailer; close].

	Preferences suppressCheckForSlips ifTrue: [^ self].  "Can hard-code that pref if desired"

	slips _ self checkForSlips.
	(slips size > 0 and: [self confirm: 'Methods in this fileOut have halts
or references to the Transcript in them.
Would you like to browse them?'])
		ifTrue: [Smalltalk browseMessageList: slips
							name: 'References to #halt or Transcript']! !


!FileList methodsFor: 'file list menu' stamp: 'wod 5/24/1998 16:21'!
fileAllIn
	"File in all of the currently selected file, if any."
	"wod 5/24/1998: open the file read only."

	| ff |
	listIndex = 0 ifTrue: [^ self].
	ff _ directory readOnlyFileNamed: self fullName.
	(self fileNameSuffix sameAs: 'html') ifTrue: [ff _ ff asHtml].
	ff fileIn.
! !

!FileList methodsFor: 'private' stamp: 'wod 5/27/1998 17:47'!
updateFileList
	"Update my files list with file names in the current directory that match the pattern."
	"wod 5/27/1998: nil out the fileName."
	Cursor execute showWhile:
		[list _ (pattern includes: $*) | (pattern includes: $#)
			ifTrue: [self listForPattern: pattern]
			ifFalse: [
				pattern isEmpty
					ifTrue: [self listForPattern: '*']
					ifFalse: [self listForPattern: '*', pattern, '*']].
		listIndex _ 0.
		volListIndex _ volList size.
		fileName _ nil.
		contents _ ''.
		self changed: #volumeListIndex.
		self changed: #fileList].
! !

'From Squeak 1.31 of Feb 4, 1998 on 15 April 1998 at 6:26:23 pm'!

!Parser methodsFor: 'private' stamp: 'sn 9/19/97 19:31'!
previousTokenSize
    "Answer the size of the previous token. Bugfix for Strings."

    hereType == #number ifTrue: [^mark - prevMark].
    hereType == #string ifTrue: [^here size + 2].    "One for each
single quote"
    ^here size! !

!Parser methodsFor: 'scanning' stamp: 'sn 9/19/97 19:32'!
advance
    | this |
    prevMark _ hereMark.
    prevToken _ "Now means prev size"
        self previousTokenSize.
    this _ here.
    here _ token.
    hereType _ tokenType.
    hereMark _ mark.
    self scanToken.
    ^this! !

'From Squeak 2.0 BETA of May 8, 1998 on 22 May 1998 at 1:48:12 am'!

!ClassDescription methodsFor: 'fileIn/Out' stamp: 'wod 5/22/1998 01:47'!
commentStamp: changeStamp

    ^ self commentStamp: changeStamp prior: 0! !
