'From Squeak 2.0 of May 22, 1998 on 14 June 1998 at 1:14:05 pm'!
"Change Set:		MutatingDoitFix-di
Date:			14 June 1998
Author:			Dan Ingalls

In the course of doits and fileIns, a class may be mutated.  The mutation may invalidate methods that are in the process of being executed, if they are on the stack.  This file redefines a couple of methods that are usually on the stack, so that most mutations, even of currently executing classes, will not cause a problem."!


!ParagraphEditor methodsFor: 'typing support' stamp: 'di 6/14/1998 13:08'!
doneTyping
	beginTypeInBlock _ nil! !

!ParagraphEditor methodsFor: 'typing support' stamp: 'di 6/14/1998 13:08'!
readKeyboard
	"Key struck on the keyboard. Find out which one and, if special, carry 
	out the associated special action. Otherwise, add the character to the 
	stream of characters.  Undoer & Redoer: see closeTypeIn."

	| typeAhead char |
	typeAhead _ WriteStream on: (String new: 128).
	[sensor keyboardPressed] whileTrue: 
		[self deselect.
		 [sensor keyboardPressed] whileTrue: 
			[char _ sensor keyboardPeek.
			(self dispatchOnCharacter: char with: typeAhead) ifTrue:
				[self doneTyping.
				^self selectAndScroll; updateMarker].
			self openTypeIn].
		startBlock = stopBlock ifFalse: "save highlighted characters"
			[UndoSelection _ self selection]. 
		self zapSelectionWith: 
			(Text string: typeAhead contents emphasis: emphasisHere).
		typeAhead reset.
		startBlock _ stopBlock copy.
		sensor keyboardPressed ifFalse: 
			[self selectAndScroll.
			sensor keyboardPressed
				ifFalse: [self updateMarker]]]! !


!TextMorphEditor methodsFor: 'events' stamp: 'di 6/14/1998 13:12'!
mouseDown: evt 
	"An attempt to break up the old processRedButton code into threee phases"
	| clickPoint |
	oldInterval _ startBlock stringIndex to: stopBlock stringIndex - 1.
	clickPoint _ evt cursorPoint.
	(paragraph clickAt: clickPoint for: model controller: self) ifTrue: [^ self].
	self closeTypeIn.  "probably not necess"
	sensor leftShiftDown
		ifFalse:
			[stopBlock _ startBlock _ pivotBlock _
				paragraph characterBlockAtPoint: clickPoint]
		ifTrue:
			[(paragraph characterBlockAtPoint: clickPoint) <= startBlock
			ifTrue: [stopBlock _ startBlock.
					pivotBlock _ stopBlock]
			ifFalse: [startBlock _  stopBlock.
					pivotBlock _ startBlock]].
	self storeSelectionInParagraph! !

!TextMorphEditor methodsFor: 'events' stamp: 'di 6/14/1998 13:12'!
mouseMove: evt 
	"Change the selection in response to moue-down drag"
	| dragBlock |
	pivotBlock ifNil: [^ self].  "Patched during clickAt: repair"
	dragBlock _ paragraph characterBlockAtPoint: (evt cursorPoint).
	dragBlock > pivotBlock
		ifTrue: [stopBlock _ dragBlock.  startBlock _ pivotBlock]
		ifFalse: [startBlock _ dragBlock.  stopBlock _ pivotBlock].
	self storeSelectionInParagraph! !

!TextMorphEditor methodsFor: 'events' stamp: 'di 6/14/1998 13:12'!
mouseUp: evt
	"An attempt to break up the old processRedButton code into threee phases"
	oldInterval ifNil: [^ self].  "Patched during clickAt: repair"
	(startBlock = stopBlock 
		and: [oldInterval = (startBlock stringIndex to: startBlock stringIndex-1)])
		ifTrue: [self selectWord].
	self setEmphasisHere.
	(self isDisjointFrom: oldInterval) ifTrue:
		[otherInterval _ oldInterval].
	self storeSelectionInParagraph! !

!TextMorphEditor methodsFor: 'events' stamp: 'di 6/14/1998 13:11'!
readKeyboard
	super readKeyboard.
	self storeSelectionInParagraph! !

!TextMorphEditor methodsFor: 'mvc compatibility' stamp: 'di 6/14/1998 13:12'!
selectFrom: start to: stop
	"Select the specified characters inclusive."
	self selectInvisiblyFrom: start to: stop.
	self closeTypeIn.
	self storeSelectionInParagraph! !


!WorldMorph methodsFor: 'hands' stamp: 'di 6/14/1998 12:56'!
activeHand: aHandMorph
	activeHand _ aHandMorph! !

!WorldMorph methodsFor: 'interaction loop' stamp: 'di 6/14/1998 12:57'!
doOneCycle
	"Do one cycle of the interactive loop. This method is called repeatedly when the world is running."

	"process user input events"
	hands do: [:h |
		self activeHand: h.
		h processEvents.
		self activeHand: nil].

	self runStepMethods.
	self displayWorld.
! !


