'From Squeak 2.3 of January 14, 1999 on 22 April 1999 at 8:54:41 am'!
"Change Set:		wacomPrimFix-jhm
Date:			22 April 1999
Author:			John Maloney

Fixes off-by-one stack error in Wacom primitives."
!


!Interpreter methodsFor: 'other primitives' stamp: 'jm 4/22/1999 08:53'!
primitiveGetTabletParameters
	"Get information on the pen tablet attached to this machine. Fail if there is no tablet. If successful, the result is an array of integers; see the Smalltalk call on this primitive for its interpretation."

	| cursorIndex resultSize result |
	cursorIndex _ self stackIntegerValue: 0.
	successFlag ifTrue: [
		resultSize _ self tabletResultSize.
		result _ self instantiateClass: (self splObj: ClassBitmap) indexableSize: resultSize.
		self success: (self cCode: 'tabletGetParameters(cursorIndex, (int *) (result + 4))')].
	successFlag ifTrue: [
		self pop: 2.  "receiver, cursorIndex"
		self push: result].
! !

!Interpreter methodsFor: 'other primitives' stamp: 'jm 4/22/1999 08:52'!
primitiveReadTablet
	"Get the current state of the cursor of the pen tablet specified by my argument. Fail if there is no tablet. If successful, the result is an array of integers; see the Smalltalk call on this primitive for its interpretation."

	| cursorIndex resultSize result |
	cursorIndex _ self stackIntegerValue: 0.
	successFlag ifTrue: [
		resultSize _ self tabletResultSize.
		result _ self instantiateClass: (self splObj: ClassBitmap) indexableSize: resultSize.
		self success: (self cCode: 'tabletRead(cursorIndex, (int *) (result + 4))')].
	successFlag ifTrue: [
		self pop: 2.  "receiver, cursorIndex"
		self push: result].
! !


