'From Squeak 2.4b of April 23, 1999 on 10 June 1999 at 11:18 am'!
"Change Set:		removals-sw
Date:			10 June 1999
Author:			Scott Wallace

Removes classes PartsBinMorph, PartsViewer, TabTokenMorph, and PermanentRecordingControlsMorph.!


!Morph methodsFor: 'e-toy support' stamp: 'sw 3/2/1999 15:30'!
objectViewed
	^ (self outermostMorphThat: [:o | o isKindOf: Viewer orOf: ScriptEditorMorph]) objectViewed! !


!CategoryViewer methodsFor: 'support' stamp: 'sw 3/1/1999 11:55'!
booleanPhraseForRetrieverOfType: retrieverType retrieverOp: retrieverOp player: aPlayer
	| outerPhrase getterPhrase receiverTile  rel finalTile |
	rel _ (retrieverType == #number)
		ifTrue:		[#<]
		ifFalse:		[#=].
	outerPhrase _ PhraseTileMorph new setOperator: rel type: #boolean rcvrType: retrieverType argType: retrieverType.
	getterPhrase _  PhraseTileMorph new setOperator: retrieverOp type: retrieverType rcvrType: #player.
	getterPhrase submorphs last setSlotRefOperator: (Utilities inherentSelectorForGetter: retrieverOp).
	receiverTile _ (self tileForPlayer: aPlayer) bePossessive.
	receiverTile position: getterPhrase firstSubmorph position.
	getterPhrase firstSubmorph addMorph: receiverTile.

	outerPhrase firstSubmorph addMorph: getterPhrase.
	finalTile _ aPlayer tileForArgType: retrieverType.
	retrieverType == #number ifTrue: [finalTile addArrows].
	outerPhrase submorphs last addMorph: finalTile.
	^ outerPhrase! !

!CategoryViewer methodsFor: 'support' stamp: 'sw 3/1/1999 11:56'!
booleanPhraseFromPhrase: phrase

	|  retrieverOp retrieverTile |
	phrase isBoolean ifTrue: [^ phrase].
	scriptedPlayer costume isInWorld ifFalse: [^ Array new].
	((retrieverTile _ phrase submorphs last) isKindOf: TileMorph) ifFalse: [^ phrase].
	retrieverOp _ retrieverTile operatorOrExpression.

	(#(color number player) includes: phrase resultType) ifTrue:
		[^ self booleanPhraseForRetrieverOfType: phrase resultType retrieverOp: retrieverOp player: phrase actualObject].

	^ phrase! !

!CategoryViewer methodsFor: 'support' stamp: 'sw 3/1/1999 11:57'!
invisiblySetPlayer: aPlayer
	scriptedPlayer _ aPlayer! !


!PhraseTileMorph methodsFor: 'all' stamp: 'sw 3/1/1999 11:57'!
rowOfRightTypeFor: aLayoutMorph forActor: aPlayer
	| aTemporaryViewer aPhrase |
	aLayoutMorph demandsBoolean ifTrue:
		[self isBoolean ifTrue: [^ self].
		aTemporaryViewer _ CategoryViewer new invisiblySetPlayer: aPlayer.
		aPhrase _ aTemporaryViewer booleanPhraseFromPhrase: self.
		^ aPhrase].
	^ self! !


!Player methodsFor: 'misc' stamp: 'sw 3/1/1999 11:52'!
updateAllViewers
	"The receiver's structure has changed, so viewers on it need to be reconstituted."
	| aPresenter |
	(aPresenter _ self costume presenter) ifNil: [^ self].
	self allOpenViewers do:
		[:aViewer | aPresenter updateViewer: aViewer]! !

!Player methodsFor: 'misc' stamp: 'sw 3/1/1999 11:52'!
updateAllViewersAndForceToShow: aCategory
	"The receiver's structure has changed, so viewers on it need to be reconstituted."
	| aPresenter |
	(aPresenter _ self costume presenter) ifNil: [^ self].
	self allOpenViewers do:
		[:aViewer | aPresenter updateViewer: aViewer forceToShow: aCategory]! !


"Postscript:
"

PartsViewer allInstances do: [:m | m allMorphs do:
	[:n | n eventHandler ifNotNil: [n eventHandler: nil]]].
Smalltalk removeClassNamed: #PartsViewer.
Smalltalk removeClassNamed: #PartsBinMorph.
Smalltalk removeClassNamed: #TabTokenMorph.
Smalltalk removeClassNamed: #PermanentRecordingControlsMorph.
!

