'From Squeak 2.4c of May 10, 1999 on 21 June 1999 at 10:30:13 pm'!
"Change Set:		WaveEditTweaks
Date:			21 June 1999
Author:			Dan Ingalls

Adds a keyboard to the wave editor for trying out sounds at different pitches.

Also fixes a couple of bugs (thanks to JM) relating to keyboard events and looped frequency.
"!

AlignmentMorph subclass: #WaveEditor
	instanceVariableNames: 'graph samplingRate perceivedFrequency loopEnd loopLength loopCycles possibleLoopStarts keyboard '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Widgets'!

!PianoKeyboardMorph methodsFor: 'simple keyboard' stamp: 'jm 6/21/1999 21:42'!
mouseDownEvent: event noteMorph: noteMorph pitch: midiKey
	| pitch |
	event hand hasSubmorphs ifTrue: [^ self  "no response if drag something over me"].
	noteMorph color: playingKeyColor.
	pitch _ AbstractSound pitchForMIDIKey: midiKey + 23.
	soundPlaying ifNotNil: [soundPlaying stopGracefully].
	soundPlaying _ soundPrototype soundForPitch: pitch dur: 100.0 loudness: 0.3.
	SoundPlayer resumePlaying: soundPlaying quickStart: true.
! !


!WaveEditor methodsFor: 'initialization' stamp: 'di 6/21/1999 17:40'!
initialize

	super initialize.
	samplingRate _ SoundPlayer samplingRate.
	loopEnd _ loopLength _ 0.
	loopCycles _ 1.
	perceivedFrequency _ 0.  "zero means unknown"
	self extent: 5@5;
		orientation: #vertical;
		centering: #topLeft;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		inset: 3;
		color: Color lightGray;
		borderWidth: 2.
	graph _ GraphMorph new extent: 450@100.
	graph cursor: 0.
	graph cursorColorAtZeroCrossings: Color blue.
	self addControls.
	self addLoopPointControls.
	self addMorphBack: graph.
	self addMorphBack: (Morph newBounds: (0@0 extent: 0@3) color: Color transparent).
	self addMorphBack: (keyboard _ PianoKeyboardMorph new).
! !

!WaveEditor methodsFor: 'menu' stamp: 'jm 6/21/1999 22:11'!
makeLoopedSampledSound

	| data end snd basePitch |
	data _ graph data.
	((loopEnd = 0) or: [loopLength = 0])
		ifTrue: [  "save as unlooped"
			perceivedFrequency = 0
				ifTrue: [basePitch _ 100.0]
				ifFalse: [basePitch _ perceivedFrequency].
			snd _ LoopedSampledSound new
				unloopedSamples: data pitch: basePitch samplingRate: samplingRate]
		ifFalse: [
			end _ (loopEnd min: data size) max: 1.
			basePitch _ (samplingRate * loopCycles) / loopLength.
			snd _ LoopedSampledSound new
				samples: data loopEnd: end loopLength: loopLength
				pitch: basePitch samplingRate: samplingRate].
	snd addReleaseEnvelope.
	^ snd
! !

!WaveEditor methodsFor: 'menu' stamp: 'di 6/21/1999 17:58'!
saveInstrument

	| name |
	name _ FillInTheBlank request: 'Instrument name?'.
	name isEmpty ifTrue: [^ self].
	AbstractSound soundNamed: name put: self makeLoopedSampledSound.
! !

!WaveEditor methodsFor: 'other' stamp: 'di 6/21/1999 17:59'!
step

	keyboard soundPrototype: self makeLoopedSampledSound! !


