'From Squeak 2.4c of May 10, 1999 on 7 July 1999 at 3:37:17 pm'!
"Change Set:		threeUnrelated-sw
Date:			7 July 1999
Author:			Scott Wallace

ThumbnailMorph now correctly renders even when the object it represents is not in a world. This fixes a bug at least two years old.

Locations of the debug & authoring menus in the menu flap are swapped, in order to accommodate the two new items Ted just added to the changes menu.

When menus are stacked one upon the other, they are now centered within the stack.  (Anyone object?  I *think* this is nicer.)

Uniclasses no longer show up in change sets (fixes bug introduced in update 1242convMeth.

"!


!ChangeSet methodsFor: 'class changes' stamp: 'sw 7/7/1999 13:12'!
addClass: class 
	"Include indication that a new class was created."

	class wantsChangeSetLogging ifTrue:
		[self atClass: class add: #new.
		self addCoherency: class name]! !


!ThumbnailMorph methodsFor: 'as yet unclassified' stamp: 'sw 7/7/1999 12:44'!
drawOn: aCanvas
	"Draw a small view of a morph in another place. Guard against infinite recursion if that morph has a thumbnail of itself inside."

	| actualViewee diag viewedMorphBox myBox scale c shrunkForm |
	super drawOn: aCanvas.
	actualViewee _ self actualViewee.
	(actualViewee~~ nil and: [actualViewee isInWorld])
		ifTrue:
			[(RecursionDepth _ RecursionDepth + 1) > RecursionMax ifTrue: [^ self].
			(actualViewee isKindOf: SketchMorph)
				ifTrue:
					[diag _ actualViewee form extent r asInteger.
					viewedMorphBox _
						(actualViewee bounds center - (diag // 2)) extent: diag@diag]
				ifFalse:
					[viewedMorphBox _ actualViewee fullBounds].

			myBox _ self innerBounds.
			scale _ myBox width / (viewedMorphBox width max: viewedMorphBox
		height).
			c _ FormCanvas extent: viewedMorphBox extent depth: aCanvas depth.
			c translateBy: viewedMorphBox topLeft negated 
				"recursion happens here"
				during:[:tempCanvas| actualViewee fullDrawOn: tempCanvas].
			shrunkForm _ c form magnify: c form boundingBox by: scale smoothing: 1.
			lastFormShown _ shrunkForm.
			RecursionDepth _ RecursionDepth - 1]
		ifFalse:
			[lastFormShown ifNotNil: [shrunkForm _ lastFormShown]].


	shrunkForm ifNotNil:
		[aCanvas image: shrunkForm at: self center - shrunkForm boundingBox
center]
! !


!Utilities class methodsFor: 'flaps' stamp: 'sw 7/7/1999 14:50'!
menuFlap
	| aFlap aFlapTab aHolder verticalHolder aMenu |
	aFlap _ PasteUpMorph newSticky color: Color transparent; extent: self currentWorld width @ 264; borderWidth: 0; padding: 0.

	aFlapTab _ FlapTab new referent: aFlap.
	aFlapTab color: Color brown lighter.
	aFlapTab assumeString: 'Menus' font: ScriptingSystem fontForScriptorButtons orientation: #horizontal color: Color blue muchLighter.
	aFlapTab setToPopOutOnMouseOver: true.
	aFlapTab edgeToAdhereTo: #top; inboard: false.

	aFlapTab position: ((Display width - aFlapTab width) // 2) @ 0.
	aFlap setProperty: #flap toValue: true.
	aFlap color: (Color blue muchLighter alpha: 0.6).
	aFlap extent: self currentWorld width @ 267.
	aHolder _ AlignmentMorph newRow beSticky beTransparent.

	#(openMenu helpMenu windowsMenu (changesMenu debugMenu ) (playfieldMenu scriptingMenu )) do:
		[:elem |
			(elem isKindOf: Array)
				ifTrue:
					[verticalHolder _ AlignmentMorph newColumn beSticky beTransparent.
					verticalHolder hResizing: #shrinkWrap; inset: 0; centering: #center.
					elem do:
						[:aMenuSymbol |
							verticalHolder addMorphBack: ((aMenu _ self currentHand perform: aMenuSymbol) beSticky; stayUp: true).
							aMenu beSticky.
							aMenu borderWidth: 1.
							aMenu submorphs second delete].
					aHolder addMorphBack: verticalHolder]
				ifFalse:
					[aHolder addMorphBack: ((aMenu _ self currentHand perform: elem) beSticky; stayUp: true).
					aMenu submorphs second delete.
					aMenu beSticky.
					aMenu borderWidth: 1]].

	aFlap addMorphBack: aHolder.

	^ aFlapTab! !


"Postscript:
"
Utilities replaceMenuFlap.
!

