'From Squeak 2.4b of April 23, 1999 on 8 July 1999 at 6:05:48 pm'!
"Change Set:		WnldActorInfo
Date:			8 July 1999
Author:			Jeff Pierce

Adds the first version of the WonderlandActorData morph to display information about an actor.  Also integrates this morph into the WonderlandActorViewer (the Actor Info tab in the editor)."!

WonderlandMorph subclass: #WonderlandActorData
	instanceVariableNames: 'nameMorph positionMorph parentMorph '
	classVariableNames: ''
	poolDictionaries: 'WonderlandConstants '
	category: 'Wonderland-Morphs'!
Morph subclass: #WonderlandActorViewer
	instanceVariableNames: 'thumbnailMorph thumbnailCamera selectedActor dataMorph '
	classVariableNames: ''
	poolDictionaries: 'WonderlandConstants '
	category: 'Wonderland-Morphs'!

!WonderlandActorData reorganize!
('initialization' initialize)
('setting actor' setActor:)
!


!WonderlandActorData methodsFor: 'initialization' stamp: 'jsp 7/8/1999 17:59'!
initialize
	"Initialize this morph by setting up the various submorphs to be able to show data about a WonderlandActor"

	| aMorph |

	super initialize.
	self color: (Color r: 0.815 g: 0.972 b: 0.878).
	self bounds: (0@0 corner: 300@120).

	nameMorph _ TextMorph new.
	nameMorph contents: 'Name: (No actor selected)'.
	nameMorph topLeft: 10@10.
	self addMorph: nameMorph.

	parentMorph _ TextMorph new.
	parentMorph contents: 'Parent: '.
	parentMorph topLeft: 10@25.
	self addMorph: parentMorph.

	aMorph _ TextMorph new.
	aMorph contents: 'Position relative to parent'.
	aMorph topLeft: 10@55.
	self addMorph: aMorph.

	positionMorph _ TextMorph new.
	positionMorph contents: 'Right:    Up:    Forward: '.
	positionMorph topLeft: 10@70.
	self addMorph: positionMorph.

! !

!WonderlandActorData methodsFor: 'setting actor' stamp: 'jsp 7/8/1999 17:59'!
setActor: anActor
	"Set the actor whose data this morph should show and update the displayed data."

	| position |

	(anActor isNil)
		ifTrue: [
				nameMorph contents: 'Name: (No actor selected)'.
				parentMorph contents: 'Parent: '.	
				positionMorph contents: 'Right:    Up:    Forward: '.
				]

		ifFalse: [
				nameMorph contents: ('Name: ' , (anActor getName)).

				(anActor isKindOf: WonderlandActor)
					ifTrue: [
							parentMorph contents: ('Parent: ' , (anActor getParent getName)).

							position _ anActor getPosition.
							position at: 1 put: ((((position at: 1) * 1000) rounded / 1000.0) asString).
							position at: 2 put: ((((position at: 2) * 1000) rounded / 1000.0) asString).
							position at: 3 put: ((((position at: 3) * 1000) rounded / 1000.0) asString).
							positionMorph contents: ('Right: ', (position at: 1) , '  Up: ',
								(position at: 2) , '  Forward: ' , (position at: 3)).

							]
					ifFalse: [
							parentMorph contents: 'Parent: None'.	
							positionMorph contents: 'Right:    Up:    Forward: '.
							]

				].



! !


!WonderlandActorViewer methodsFor: 'initialization' stamp: 'jsp 7/8/1999 17:53'!
initialize
	"Initialize this morph"

	super initialize.

	self name: 'Actor Info'.
	self extent: 500@350.
	self color: (Color r: 0.815 g: 0.972 b: 0.878).

	dataMorph _ WonderlandActorData new.
	self addMorph: dataMorph.
	dataMorph topLeft: 200@10.
! !

!WonderlandActorViewer methodsFor: 'initialization' stamp: 'jsp 7/8/1999 15:58'!
initializeWith: aWonderland
	"Do the Wonderland specific setup for this viewer."

	thumbnailCamera _ WonderlandStillCamera createFor: aWonderland.
	thumbnailCamera turnBackgroundOff.

	thumbnailMorph _ thumbnailCamera getMorph.
	thumbnailMorph topLeft: 10@10.
	self addMorph: thumbnailMorph.
! !

!WonderlandActorViewer methodsFor: 'updating' stamp: 'jsp 7/8/1999 17:53'!
setSelectedActor: anActor
	"Update the actor viewer to reflect the information for this actor"

	selectedActor _ anActor.

	thumbnailCamera setFocusObject: anActor.
	dataMorph setActor: anActor.
! !


