'From Squeak 2.5 of August 6, 1999 [latest update: #1514] on 4 October 1999 at 8:24:22 am'!
"Change Set:		SundryFixes-di
Date:			4 October 1999
Author:			Dan Ingalls

Restores proper operation of roundTo: and amends its comment (reported by Andrew Greenberg).
Fixes a Interpreter>>printNameOfClass:count: for the third time (reported by Tom Morgan).
Fixes a bug in AcornFileDirectory root testing exposed by RISC OS4 (fixed by Tim Rowledge).
"!


!AcornFileDirectory methodsFor: 'file name utilities' stamp: 'TPR 10/1/1999 23:00'!
fullNameFor: fileName
	"Return a corrected, fully-qualified name for the given file name. If the given name is already a full path (i.e., it contains a $ or other root character), assume it is already a fully-qualified name. Otherwise, prefix it with the path to this directory. In either case, correct the local part of the file name."
	"Details: Note that path relative to a directory, such as '../../foo' are disallowed by this algorithm."

	| correctedLocalName prefix |
	FileDirectory splitName: fileName to:
		[:filePath :localName |
			correctedLocalName _ self checkName: localName fixErrors: true.
			filePath isEmpty
				ifTrue: [prefix _ pathName]  "path to this directory"
				ifFalse: ["filePath might be rooted or might be relative to my pathName"
					((filePath includes: $$ ) or:[filePath includes: $:])
						ifTrue:[prefix _ filePath]"path supplied with fileName"

						ifFalse:[prefix _ pathName, self pathNameDelimiter asString, filePath]"path to this directory plus path given in file name"]].  
	prefix isEmpty
		ifTrue: [^ correctedLocalName]
		ifFalse: [^ prefix, self pathNameDelimiter asString, correctedLocalName].
! !


!Interpreter methodsFor: 'debug support' stamp: 'di 10/4/1999 08:12'!
printNameOfClass: classOop count: cnt
	"Details: The count argument is used to avoid a possible infinite recursion if classOop is a corrupted object."

	cnt <= 0 ifTrue: [ ^ self print: 'bad class' ].
	(self sizeBitsOf: classOop) = 16r1C  "(Metaclass instSize+1 * 4)"
	ifTrue: [self printNameOfClass: (self fetchPointer: 5 "thisClass" ofObject: classOop) 
				count: cnt - 1.
			self print: ' class']
	ifFalse: [self printStringOf: (self fetchPointer: 6 "name" ofObject: classOop)]! !


!Number methodsFor: 'truncation and round off' stamp: 'di 10/4/1999 08:08'!
roundTo: quantum 
	"Answer the nearest number that is a multiple of quantum."

	^(self / quantum) rounded * quantum! !


Integer removeSelector: #roundTo:!
