'From Squeak 2.5 of August 6, 1999 [latest update: #1521] on 6 October 1999 at 3:25:28 pm'!
"Change Set:		windowMenuMisc-sw
Date:			6 October 1999
Author:			Scott Wallace

(1)  Adds an item to the window menu for workspaces, allowing you easily to save the contents of the workspace to a text file.

(2)  Adds items to the window menu for a Preferences window, allowing you to reset all preferences to initial values and to restore the default text-highlighting colors."!


!Preferences class methodsFor: 'misc' stamp: 'sw 10/6/1999 15:20'!
addModelItemsToWindowMenu: aMenu
	aMenu addLine.
	aMenu add: 'restore default preference settings' target: self action: #chooseInitialSettings.
	aMenu add: 'restore default text highlighting' target: self action: #initializeTextHighlightingParameters! !


!Workspace methodsFor: 'as yet unclassified' stamp: 'sw 10/6/1999 15:17'!
addModelItemsToWindowMenu: aMenu
	aMenu addLine.
	aMenu add: 'save contents to file...' target: self action: #saveContentsInFile ! !

!Workspace methodsFor: 'as yet unclassified' stamp: 'sw 10/6/1999 15:25'!
saveContentsInFile
	| fileName stringToSave labelToUse |
	stringToSave _ (self dependents detect: [:dep | dep isKindOf: PluggableTextMorph] ifNone: [^ self beep]) text string.
	stringToSave size == 0 ifTrue: [^ self inform: 'nothing to save.'].
	labelToUse _  (self dependents detect: [:dep | dep isKindOf: SystemWindow] ifNone: [^ self beep]) label.

	fileName _ FillInTheBlank request: 'File name? (".text" will be added to end)' 
			initialAnswer: labelToUse.
	fileName size == 0 ifTrue: [^ self beep].
	(fileName asLowercase endsWith: '.text') ifFalse: [fileName _ fileName,'.text'].

	(FileStream newFileNamed: fileName)
		nextPutAll: stringToSave; close! !


