'From Squeak 2.5 of August 6, 1999 [latest update: #1548] on 14 October 1999 at 9:13:27 pm'!
"Change Set:		buttons-bf
Date:			8 October 1999
Author:			Bert Freudenberg

Makes using ThreePhaseButtons as checkboxes or radiobuttons easier. Provides forms for both (square and round). Uses the new checkbox in version windows."!


!CodeHolder methodsFor: 'as yet unclassified' stamp: 'bf 10/8/1999 15:34'!
diffButton
	|  outerButton aButton |
	"Return a checkbox that lets the user decide whether diffs should be shown or not"
	outerButton _ AlignmentMorph newRow height: 24.
	outerButton color:  Color transparent.
	outerButton hResizing: #shrinkToFit; vResizing: #shrinkToFit.
	outerButton addMorph: (aButton _ UpdatingThreePhaseButtonMorph checkBox).
	aButton
		target: self;
		actionSelector: #toggleDiff;
		getSelector: #showDiffs.
	outerButton addMorphBack: (StringMorph contents: 'diffs') lock.
	outerButton setBalloonText: 'If checked, then code differences from the previous version, if any, will be shown.'.

	^ outerButton
! !


!ThreePhaseButtonMorph class methodsFor: 'instance creation' stamp: 'bf 10/8/1999 15:23'!
checkBox
	"Answer a button pre-initialized with checkbox images."
	| f |
	^self new
		onImage: (f _ ScriptingSystem formAtKey: 'CheckBoxOn');
		pressedImage: (ScriptingSystem formAtKey: 'CheckBoxPressed');
		offImage: (ScriptingSystem formAtKey: 'CheckBoxOff');
		extent: f extent + (2@0);
		yourself
! !

!ThreePhaseButtonMorph class methodsFor: 'instance creation' stamp: 'bf 10/8/1999 15:14'!
radioButton
	"Answer a button pre-initialized with radiobutton images."
	| f |
	^self new
		onImage: (f _ ScriptingSystem formAtKey: 'RadioButtonOn');
		pressedImage: (ScriptingSystem formAtKey: 'RadioButtonPressed');
		offImage: (ScriptingSystem formAtKey: 'RadioButtonOff');
		extent: f extent + (2@0);
		yourself
! !

!ThreePhaseButtonMorph class methodsFor: 'class initialization' stamp: 'bf 10/14/1999 21:06'!
initialize
	"ThreePhaseButtonMorph initialize"
	| extent inset |
	extent _ 12@12.
	inset _ 3.

	#('CheckBoxOff' 'CheckBoxOn' 'CheckBoxPressed') do: [:button |
		| f r |
		f _ ColorForm extent: extent depth: 1.
		f colors: {Color transparent. Color black}.
		f borderWidth: 1.
		r _ f boundingBox insetBy: inset.
		button = 'CheckBoxPressed' ifTrue: [f border: r width: 1].
		button = 'CheckBoxOn' ifTrue: [f fillBlack: r].
		ScriptingSystem saveForm: f atKey: button].

	#('RadioButtonOff' 'RadioButtonOn' 'RadioButtonPressed') do: [:button |
		| f r c |
		f _ ColorForm extent: extent depth: 1.
		f colors: {Color transparent. Color black}.
		r _ f boundingBox.
		c _ FormCanvas on: f.
		c frameOval: r color: Color black.
		r _ r insetBy: inset.
		button = 'RadioButtonPressed' ifTrue:
			[c frameOval: r color: Color black].
		button = 'RadioButtonOn' ifTrue:
			[c fillOval: r color: Color black].
		ScriptingSystem saveForm: f atKey: button]! !


!UpdatingThreePhaseButtonMorph methodsFor: 'as yet unclassified' stamp: 'bf 10/8/1999 15:08'!
doButtonAction
	"Since the action likely changes our state, do a step so we're updated immediately"
	super doButtonAction.
	self step
! !

!UpdatingThreePhaseButtonMorph methodsFor: 'as yet unclassified' stamp: 'bf 10/14/1999 21:11'!
mouseUp: evt
	"Since mouseUp likely changes our state, do a step so we're updated immediately"
	super mouseUp: evt.
	self step! !


ThreePhaseButtonMorph initialize!