'From Squeak2.7alpha of 1 November 1999 [latest update: #1592] on 23 November 1999 at 11:25:09 am'!
"Change Set:		ClickMoveClick-bf
Date:			23 November 1999
Author:			Bert Freudenberg

Allows non-permanent menus to be moved around without being dismissed or becoming permanent."!


!MenuItemMorph methodsFor: 'events' stamp: 'bf 11/23/1999 09:37'!
mouseUp: evt
	"Handle a mouse up event. Menu items get activated when the mouse is over them."

	| mouseInMe |
	mouseInMe _ self containsPoint: evt cursorPoint.
	self deselectItem.
	self isInMenu
		ifTrue:
			[(mouseInMe and: [self selector = #toggleStayUp:])
				ifFalse: [owner deleteIfPopUpFrom: self event: evt].
			subMenu ifNil:
				[mouseInMe ifTrue:
					[evt hand world displayWorld.
					owner invokeItem: self event: evt]]]
		ifFalse:  
			[self invokeWithEvent: evt]
			
			
! !


!MenuMorph methodsFor: 'control' stamp: 'bf 11/23/1999 11:11'!
deleteIfPopUpFrom: item event: evt
	"Remove this menu from the screen if stayUp is not true, but only if the user did move the mouse since invoking me. This allows for click-move-click selection style."

	stayUp ifFalse: 
		[((self hasProperty: #stayUpOnce) or: 
			[(evt cursorPoint dist: originalEvent cursorPoint) < 2]) ifTrue:
				[self removeProperty: #stayUpOnce.
				^evt hand newMouseFocus: item "Do tracking and delete on next click"]].
	self deleteIfPopUp.
! !

!MenuMorph methodsFor: 'control' stamp: 'bf 11/23/1999 11:17'!
justDroppedInto: aMorph event: anEvent
	"This menu was grabbed and moved. Save us from being deleted by the mouseUp event."
	stayUp ifFalse: [self setProperty: #stayUpOnce toValue: true].
	super justDroppedInto: aMorph event: anEvent! !