'From Squeak 2.1 of June 30, 1998 on 5 August 1998 at 6:31:40 pm'!
"Change Set:		texturesInPasteUps
Date:			5 August 1998
Author:			Scott Wallace

Makes textures available as background for any PasteUpMorph"!


!GrafPort methodsFor: 'all' stamp: 'sw 8/5/1998 12:10'!
fillRect: rect color: fillColor offset: aPoint

	fillColor class == InfiniteForm ifTrue: 
		[self fillColor: nil.
		fillColor displayOnPort: ((self clippedBy: (rect translateBy: aPoint)) colorMap: nil) at: aPoint.
		^ self].

	sourceForm _ nil.
	self fillColor: fillColor.
	destX _ rect left + aPoint x.
	destY _ rect top + aPoint y.
	sourceX _ 0.
	sourceY _ 0.
	width _ rect width.
	height _ rect height.
	self copyBits.
! !


!Morph methodsFor: 'jun98 additions' stamp: 'sw 7/21/1998 21:17'!
makeGraphPaper
	| smallGrid backColor lineColor |
	smallGrid _ Compiler evaluate: (FillInTheBlank request: 'Enter grid size' initialAnswer: '16').
	Utilities informUser: 'Choose a background color' during: [backColor _ Color fromUser].
	Utilities informUser: 'Choose a line color' during: [lineColor _ Color fromUser].
	self makeGraphPaperGrid: smallGrid background: backColor line: lineColor.! !

!Morph methodsFor: 'jun98 additions' stamp: 'sw 7/21/1998 21:19'!
makeGraphPaperGrid: smallGrid background: backColor line: lineColor

	| bigGrid gridForm |
	bigGrid _ 40 roundTo: smallGrid.
	gridForm _ Form extent: bigGrid asPoint depth: Display depth.
	gridForm fillWithColor: backColor.
	0 to: bigGrid by: smallGrid do: [:i |
		gridForm fill: (i@0 extent: 1@bigGrid) fillColor: lineColor.
		gridForm fill: (0@i extent: bigGrid@1) fillColor: lineColor].
	color _ InfiniteForm with: gridForm.
	self world fullRepaintNeeded.
	self changed: #newColor.  "propagate to view"
! !

!Morph methodsFor: 'jun98 additions' stamp: 'sw 7/21/1998 21:18'!
setStandardTexture
	| parms |
	parms _ self textureParameters.
	self makeGraphPaperGrid: parms first
		background: parms second
		line: parms third! !

!Morph methodsFor: 'jun98 additions' stamp: 'sw 7/21/1998 21:17'!
textureParameters
	"Answer a triplet giving the preferred grid size, background color, and line color.  The choices here are as suggested by Alan, 9/13/97"

	^ Array with: 16 with: Color lightYellow with: Color lightGreen lighter lighter! !


!PasteUpMorph methodsFor: 'menu & halo' stamp: 'sw 8/5/1998 18:25'!
addPlayfieldMenuItems: menu hand: aHandMorph
	| subMenu prefix hasPalette |
	subMenu _ MenuMorph new defaultTarget: self.
	subMenu add: 'save on file...' action: #saveOnFile.
	subMenu add: 'navigate to...' action: #navigateTo.
	subMenu add: 'round up strays' action: #roundUpStrays.
	subMenu addLine.

	#(	(autoLineLayout			'auto layout'			toggleAutoLineLayout)
		(resizeToFit				'resize-to-fit'			toggleResizeToFit)
		(indicateCursor			'showing cursor'		toggleIndicateCursor)
		(isPartsBin				'being a parts bin'		toggleIsPartsBin)
		(wantsMouseOverHalos	'mouse-over halos'		toggleMouseOverHalos))
	do:
		[:triplet |
			prefix _ (self perform: triplet first) ifTrue: ['stop '] ifFalse: ['start '].
			subMenu add:  (prefix, triplet second) action: triplet third].

	prefix _ (self hasProperty: #automaticPhraseExpansion) ifTrue: ['stop '] ifFalse: ['start '].
	subMenu add: (prefix, 'phrase expansion') action: #toggleAutomaticPhraseExpansion.

	prefix _ (self hasProperty: #alwaysShowThumbnail) ifTrue: ['stop '] ifFalse: ['start '].
	subMenu add: (prefix, 'showing thumbnails') action: #toggleAlwaysShowThumbnail.

	(self hasProperty: #alwaysShowThumbnail) ifTrue:
		[subMenu add: 'set thumbnail height...' action: #setThumbnailHeight].

	(hasPalette _ self standardPalette ~~ nil) ifTrue:
		[prefix _ self automaticViewing ifTrue: ['stop '] ifFalse: ['start '].
		subMenu add: (prefix, 'automatic viewing') action: #toggleAutomaticViewing].
	subMenu addLine.
	hasPalette ifTrue: [subMenu add: 'clear palette area' action: #clearPaletteArea].

	(self resizeToFit & self indicateCursor & self autoLineLayout) ifFalse:
		[subMenu add: 'behave like a Holder' action: #behaveLikeHolder].

	self backgroundSketch ifNotNil: [subMenu add: 'delete background painting' action: #deleteBackgroundPainting].
	presenter ifNil:
		[subMenu add: 'make detachable' action: #impartPrivatePresenter].

	subMenu addLine.
	subMenu add: 'use standard texture' action: #setStandardTexture.
	subMenu add: 'make graph paper...' action: #makeGraphPaper.
	subMenu addTitle: 'Playfield'.

	menu add: 'playfield options...' subMenu: subMenu.
! !


WorldMorph removeSelector: #setStandardTexture!
WorldMorph removeSelector: #textureParameters!
WorldMorph removeSelector: #makeGraphPaper!
WorldMorph removeSelector: #makeGraphPaperGrid:background:line:!
