'From Squeak2.8alpha of 4 February 2000 [latest update: #1873] on 26 February 2000 at 7:12:17 pm'!
"Change Set:		BrowseIt
Date:			11 February 2000
Author:			Steve Rees

Minor fix to browseIt on ParagraphEditor.

Previously ParagraphEditor assumed that a selection beginning with an uppercase letter represented a Class name and that a selection beginning with a lowercase letter was a method name.

Whilst the second assumption is valid, the first is not, since although conventionally method names begin with a lowercase letter they can also begin with an uppercase letter.

This changeset modifies the assumptions in ParagraphEditor>>browseIt so that if the selected name begins with an uppercase letter, but no entry is found in Smalltalk a search is done for implementing methods with that name."!


!ParagraphEditor methodsFor: 'menu messages' stamp: 'slr 2/11/2000 02:19'!
browseIt
	"Launch a browser for the current selection, if appropriate"

	| aSymbol anEntry brow |
	self lineSelectAndEmptyCheck: [^ self].
	(aSymbol _ self selectedSymbol) isNil ifTrue: [^ view flash].

	self terminateAndInitializeAround:
		[aSymbol first isUppercase
			ifTrue:
				[anEntry _ (Smalltalk
					at: aSymbol
					ifAbsent:
						[Smalltalk browseAllImplementorsOf: aSymbol.
						^ nil]).
				anEntry isNil ifTrue: [^ view flash].
				(anEntry isKindOf: Class)
					ifFalse:	[anEntry _ anEntry class].
				brow _ Preferences browseToolClass new.
				brow setClass: anEntry selector: nil.
				brow class
					openBrowserView: (brow openEditString: nil)
					label: 'System Browser']
			ifFalse:
				[Smalltalk browseAllImplementorsOf: aSymbol]]! !


