'From Squeak2.8alpha of 4 February 2000 [latest update: #1873] on 3 March 2000 at 7:34:16 pm'!
"Change Set:		ProgressMorph
Date:			1 March 2000
Author:			Michael Rueger

A progress indicator. You can provide a top and a sub label indicating the progress (see #label: and #subLabel:).  The progress value can either be set using absolute values between 0.0 - 1.0 using #done:, or by specifying the incremental progress with #incrDone:.

I made the sublabel smaller than the top label, removed the Current class var and added some menu commands to the FlashProgressMorph on which this morph is based. --sma"!

RectangleMorph subclass: #ProgressMorph
	instanceVariableNames: 'labelMorph subLabelMorph progress '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Widgets'!
ProgressMorph class
	instanceVariableNames: ''!

!FlashProgressMorph methodsFor: 'accessing' stamp: 'sma 3/3/2000 18:52'!
progressColor: aColor
	progressColor = aColor
		ifFalse:
			[progressColor _ aColor.
			self changed]! !

!FlashProgressMorph methodsFor: 'accessing' stamp: 'sma 3/3/2000 18:53'!
value: aModel
	value ifNotNil: [value removeDependent: self].
	value _ aModel.
	value ifNotNil: [value addDependent: self]! !

!FlashProgressMorph methodsFor: 'drawing' stamp: 'sma 3/3/2000 18:54'!
drawOn: aCanvas
	| width inner |
	super drawOn: aCanvas.
	inner _ self innerBounds.
	width _ (inner width * lastValue) truncated min: inner width.
	aCanvas fillRectangle: (inner origin extent: width @ inner height) color: progressColor.! !

!FlashProgressMorph methodsFor: 'initialize' stamp: 'sma 3/3/2000 18:55'!
initialize
	super initialize.
	progressColor _ Color green.
	self value: (ValueHolder new contents: 0.0).
	lastValue _ 0.0! !

!FlashProgressMorph methodsFor: 'menu' stamp: 'sma 3/3/2000 19:20'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu addList: #(
		('progress color...' changeProgressColor:)
		('progress value...' changeProgressValue:))! !

!FlashProgressMorph methodsFor: 'menu' stamp: 'sma 3/3/2000 19:21'!
changeProgressColor: evt
	| aHand |
	aHand _ evt ifNotNil: [evt hand] ifNil: [self primaryHand].
	aHand changeColorTarget: self selector: #progressColor: originalColor: self progressColor! !

!FlashProgressMorph methodsFor: 'menu' stamp: 'sma 3/3/2000 19:27'!
changeProgressValue: evt
	| answer |
	answer _ FillInTheBlank
		request: 'Enter new value (0 - 1.0)'
		initialAnswer: self value contents asString.
	answer isEmptyOrNil ifTrue: [^ self].
	self value contents: answer asNumber! !

!FlashProgressMorph methodsFor: 'updating' stamp: 'sma 3/3/2000 18:51'!
update: aSymbol 
	aSymbol == #contents
		ifTrue: 
			[lastValue _ value contents.
			self changed]! !


!ProgressMorph reorganize!
('accessing' done done: incrDone: label label: progress subLabel subLabel:)
('initialization' initLabelMorph initProgressMorph initSubLabelMorph initialize setupMorphs)
('private' fontOfPointSize: labelMorph subLabelMorph)
!


!ProgressMorph methodsFor: 'accessing' stamp: 'mir 2/14/2000 17:55'!
done
	^self progress value contents! !

!ProgressMorph methodsFor: 'accessing' stamp: 'sma 3/3/2000 19:05'!
done: amountDone
	self progress value contents: ((amountDone min: 1.0) max: 0.0)! !

!ProgressMorph methodsFor: 'accessing' stamp: 'sma 3/3/2000 19:05'!
incrDone: incrDone
	self done: self done + incrDone! !

!ProgressMorph methodsFor: 'accessing' stamp: 'mir 1/19/2000 13:28'!
label
	^self labelMorph contents! !

!ProgressMorph methodsFor: 'accessing' stamp: 'mir 1/19/2000 13:26'!
label: aString
	self labelMorph contents: aString! !

!ProgressMorph methodsFor: 'accessing' stamp: 'mir 1/19/2000 13:25'!
progress
	^progress ifNil: [self initProgressMorph]! !

!ProgressMorph methodsFor: 'accessing' stamp: 'mir 1/19/2000 13:27'!
subLabel
	^self subLabelMorph contents! !

!ProgressMorph methodsFor: 'accessing' stamp: 'mir 1/19/2000 13:27'!
subLabel: aString
	self subLabelMorph contents: aString! !

!ProgressMorph methodsFor: 'initialization' stamp: 'sma 3/3/2000 19:13'!
initLabelMorph
	^ labelMorph _ StringMorph contents: '' font: (self fontOfPointSize: 14)! !

!ProgressMorph methodsFor: 'initialization' stamp: 'mir 1/19/2000 13:16'!
initProgressMorph
	progress _ FlashProgressMorph new.
	progress borderWidth: 1.
	progress color: Color transparent.
	progress progressColor: Color gray.
	progress extent: (200 @ 15).
! !

!ProgressMorph methodsFor: 'initialization' stamp: 'sma 3/3/2000 19:13'!
initSubLabelMorph
	^ subLabelMorph _ StringMorph contents: '' font: (self fontOfPointSize: 12)! !

!ProgressMorph methodsFor: 'initialization' stamp: 'mir 1/19/2000 13:28'!
initialize
	super initialize.
	self setupMorphs! !

!ProgressMorph methodsFor: 'initialization' stamp: 'mir 1/19/2000 13:33'!
setupMorphs
	| container  |
	self initProgressMorph.
	container _ AlignmentMorph newColumn.
	container
		centering: #center;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		color: Color transparent.

	container addMorphBack: self labelMorph.
	container addMorphBack: self subLabelMorph.
	container addMorphBack: self progress.

	self addMorph: container.
	self borderWidth: 2.
	self borderColor: Color black.

	self extent: container extent.
	self color: Color veryLightGray.
	self align: self fullBounds center with: Display boundingBox center
! !

!ProgressMorph methodsFor: 'private' stamp: 'sma 3/3/2000 19:14'!
fontOfPointSize: size
	^ (TextConstants at: #ComicBold ifAbsent: [TextStyle default]) fontOfPointSize: size! !

!ProgressMorph methodsFor: 'private' stamp: 'mir 1/19/2000 13:25'!
labelMorph
	^labelMorph ifNil: [self initLabelMorph]! !

!ProgressMorph methodsFor: 'private' stamp: 'mir 1/19/2000 13:25'!
subLabelMorph
	^subLabelMorph ifNil: [self initSubLabelMorph]! !


!ProgressMorph class methodsFor: 'instance creation' stamp: 'mir 1/19/2000 13:07'!
label: aString
	^self new label: aString! !

!ProgressMorph class methodsFor: 'example' stamp: 'sma 3/3/2000 19:07'!
example
	"ProgressMorph example"

	| progress |
	progress _ ProgressMorph label: 'Test progress'.
	progress subLabel: 'this is the subheading'.
	progress openInWorld.
	[10 timesRepeat:
		[(Delay forMilliseconds: 200) wait.
		progress incrDone: 0.1].
	progress delete] fork! !


ProgressMorph removeSelector: #largeFont!
ProgressMorph class removeSelector: #current!
ProgressMorph class removeSelector: #current:!
ProgressMorph class removeSelector: #deleteCurrent!
