'From Squeak2.8alpha of 13 January 2000 [latest update: #1926] on 10 March 2000 at 5:15:34 pm'!
"Change Set:		avoidAnnoyance-sw
Date:			10 March 2000
Author:			Scott Wallace

Fixes the long-standing annoyance that when you attempted to remove a method whose only sender was itself, you still got the warning message about there being an outstanding sender."!


!Behavior methodsFor: 'accessing' stamp: 'sw 3/10/2000 16:55'!
confirmRemovalOf: aSelector
	"Determine if it is okay to remove the given selector.  Answer 1 if it should be removed, 2 if it should be removed followed by a senders browse, and 3 if it should not be removed."

	| count aMenu answer caption allCalls |
	allCalls _ Smalltalk allCallsOn: aSelector.
	(count _ allCalls size) == 0 ifTrue: [^ 1].  "no senders -- let the removal happen without warning"
	count == 1 ifTrue:
		[MessageSet parse: allCalls first toClassAndSelector:
			[:aClass :aSel |
				(aClass == self and: [aSel == aSelector]) ifTrue: [^ 1]]].   "only sender is itself"

	aMenu _ PopUpMenu labels: 'Remove it
Remove, then browse senders
Don''t remove, but show me those senders
Forget it -- do nothing -- sorry I asked'.

	caption _ 'This message has ', count printString, ' sender'.
	count > 1 ifTrue:
		[caption _ caption copyWith: $s].
	answer _ aMenu startUpWithCaption: caption.
	answer == 3 ifTrue:
		[Smalltalk browseMessageList: allCalls
			name: 'Senders of ', aSelector
			autoSelect: aSelector keywords first].
	answer == 0 ifTrue: [answer _ 3].  "If user didn't answer, treat it as cancel"
	^ answer min: 3! !


