'From Squeak2.8alpha of 12 January 2000 [latest update: #1973] on 25 March 2000 at 6:00:58 pm'!
"Change Set:		RoundingTweaks
Date:			25 March 2000
Author:			Dan Ingalls

Makes SystemWindows with rounded corners properly compute areasRemainingToFill:.

Also improves the result reported from this message, as it now only reports two strips with the four corners, rather than the entire window.

Most importantly, it fixes the general problem of canvas holes being filled with gray stipple when dragging with the Hand in 8-bit depth.
"!


!BorderedMorph methodsFor: 'drawing' stamp: 'di 3/25/2000 11:13'!
areasRemainingToFill: aRectangle
	(color isColor and: [color isTranslucent]) ifTrue: [^ Array with: aRectangle].
	self wantsRoundedCorners
	ifTrue: [(borderWidth > 0 and: [borderColor isColor and: [borderColor isTranslucent]])
				ifTrue: [^ aRectangle areasOutside: (self innerBounds intersect: self boundsWithinCorners)]
				ifFalse: [^ aRectangle areasOutside: self boundsWithinCorners]]
	ifFalse: [(borderWidth > 0 and: [borderColor isColor and: [borderColor isTranslucent]])
				ifTrue: [^ aRectangle areasOutside: self innerBounds]
				ifFalse: [^ aRectangle areasOutside: self bounds]]! !

!BorderedMorph methodsFor: 'drawing' stamp: 'di 3/25/2000 11:13'!
boundsWithinCorners

	^ CornerRounder rectWithinCornersOf: self bounds! !


!CornerRounder class methodsFor: 'all' stamp: 'di 3/25/2000 11:12'!
rectWithinCornersOf: aRectangle
	"Return a single sub-rectangle that lies entirely inside corners
	that are made by me.
	Used to identify large regions of window that do not need to be redrawn."

	^ aRectangle insetBy: 0@6! !


!SystemWindow methodsFor: 'drawing' stamp: 'di 3/25/2000 10:55'!
wantsRoundedCorners
	^ Preferences roundedWindowCorners or: [super wantsRoundedCorners]! !


!TranslucentColor methodsFor: 'conversions' stamp: 'di 3/25/2000 17:56'!
balancedPatternForDepth: depth
	"Return an appropriate bit pattern or stipple.  This will almost never be meaningful for tranlucentColors, except for the degenerate case of tranparency."

	alpha = 0 ifTrue: [^ Bitmap with: 0].
	^ super balancedPatternForDepth: depth! !


