'From Squeak2.8alpha of 13 January 2000 [latest update: #1989] on 13 April 2000 at 5:49:52 pm'!

!Project methodsFor: 'file in/out' stamp: 'tk 4/13/2000 15:23'!
installRemoteFrom: strm named: otherProjectName
	| projViewer is proj |
	"Find the current ProjectViewMorph, fetch the project, install in ProjectViewMorph without changing size, and jump into new project."

	projViewer _ self findProjectView: otherProjectName.
	projViewer 
		ifNotNil: [is _ strm asUnZippedStream fileInObjectAndCode.
			(is isKindOf: ImageSegment) ifTrue: [
				proj _ is arrayOfRoots detect: [:mm | mm class == Project] 
							ifNone: [nil].
				proj ifNotNil: [proj versionFrom: strm.
					projViewer project changeSet name: ChangeSet defaultName.
					proj changeSet name: otherProjectName.
					proj setParent: Project current.
					(projViewer owner isKindOf: SystemWindow) ifTrue: [
						projViewer owner model: proj].
					projViewer project: proj.
					^ proj enter]]]
		ifNil: [(SelectionMenu confirm: 'No old thumbnail found. Debug?') 
					ifTrue: [self halt]].
	"replace with a new one"
	ProjectViewMorph openFromFile: strm.
		"Later check rest of servers if fails.  Still have list here"! !

!Project methodsFor: 'file in/out' stamp: 'tk 4/13/2000 15:27'!
loadFromServer
	| servers pair resp strm |
	"If a newer version of me is on the server, load it."

	self == CurrentProject ifTrue: ["exit, then do the command"
		^ self armsLengthCommand: #loadFromServer].
	(servers _ self serverList) isEmpty 
		ifTrue: [^ self inform: 'This project thinks it has never been on a server'].
	pair _ self class mostRecent: self name onServer: servers first.
	pair first ifNil: [^ self inform: 'can''t find file on server for ', self name].
	(Base64MimeConverter decodeInteger: version unescapePercents) > pair second ifTrue: [
		^ self inform: 'That server has an older version of the project.'].
	version = (pair first findTokens: '|.') second 
		ifTrue: [resp _ (PopUpMenu labels: 'Reload anyway\Cancel' withCRs) startUpWithCaption: 
					'The only changes are the ones you made here.'.
				resp ~= 1 ifTrue: [^ nil]]
		ifFalse: [resp _ (PopUpMenu labels: 'Load it\Cancel' withCRs) startUpWithCaption: 
					'A newer version exists on the server.'.
				resp ~= 1 ifTrue: [^ nil]].
	"Find parent project, go there, zap old thumbnail"
	strm _ servers first oldFileNamed: pair first.
	parentProject installRemoteFrom: strm named: self name.
! !


!Project class methodsFor: 'squeaklet on server' stamp: 'tk 4/13/2000 17:49'!
fromUrl: urlString
	| serverFile pair pvm nn proj projViewer strm num triple |
	"Load the project, and make a thumbnail to it in the current project.  Replace the old one if necessary.
Project fromUrl: 'http://www.squeak.org/Squeak2.0/2.7segments/Squeak_Easy.pr.gz'.
"
	Smalltalk verifyMorphicAvailability ifFalse: [^ self].
	World ifNil: [^ self inform: 
			'Later, allow jumping from MVC to Morphic Projects.'].
	serverFile _ ServerFile new fullPath: urlString.
	(proj _ Project named: (nn _ (serverFile fileName findTokens: '|.') first))
		ifNotNil: ["it appeared" ^ proj enter].
	serverFile type == #http
		ifTrue: [num _ (triple _ serverFile fileName findTokens: '|.') size >= 3 
				ifTrue: [Base64MimeConverter decodeInteger: triple second unescapePercents]
				ifFalse: [0].
			pair _ Array with: serverFile fileName with: num]
		ifFalse: [pair _ self mostRecent: serverFile localName onServer: serverFile].
	pair first ifNil: ["If none, open a blank project"
		pvm _ ProjectViewMorph newMorphicProjectOn: nil.
		pvm _ pvm findA: ProjectViewMorph.
		(proj _ pvm project) changeSet name: nn.
		projViewer _ Project current findProjectView: nn.
		proj setParent: Project current.
		(projViewer owner isKindOf: SystemWindow) ifTrue: [
				projViewer owner model: proj].
		^ projViewer project: proj].

	"Find parent project, go there, zap old thumbnail"
	strm _ serverFile oldFileNamed: pair first encodeForHTTP.
	Project current installRemoteFrom: strm named: nn.

! !


!ServerDirectory methodsFor: 'file directory' stamp: 'tk 4/13/2000 15:51'!
fileNames
	"Return a collection of names for the files (but not directories) in this directory."
	"(ServerDirectory serverNamed: 'UIUCArchive') fileNames"

	(type == #ftp) | (type == #file) ifFalse: [
		^ self error: 'To see a directory, use file:// or ftp://'].
	^ (self entries select: [:entry | (entry at: 4) not])
		collect: [:entry | entry first]
! !


!ServerFile methodsFor: 'as yet unclassified' stamp: 'tk 4/13/2000 17:12'!
localName

	^ self fileName! !

