'From Squeak2.8alpha of 12 January 2000 [latest update: #2004] on 24 April 2000 at 2:03:53 pm'!
"Change Set:		FourTweaks
Date:			24 April 2000
Author:			Dan Ingalls

Changes the compilation of ifNotNil: for better code and more consistency with decompilation.

Changes interval>>valuesInclude: to avoid slow fraction computations.

Changes Symbol>>storeOn: to take advantage of the #'any chars' construct.

Changes the comment in SystemDictionary>>recompileAllFrom: because it used to omit classes.
"!


!Interval methodsFor: 'private' stamp: 'di 4/24/2000 13:56'!
valuesInclude: aNumber
	"Private - answer whether or not aNumber is one of the enumerated values in this interval."

	| val |
	val _ (aNumber - self first) asFloat / self increment.
	^ val fractionPart abs < (step * 1.0e-10)! !


!MessageNode methodsFor: 'macro transformations' stamp: 'di 4/24/2000 13:32'!
transformIfNil: encoder

	(self transformBoolean: encoder) ifFalse: [^ false].
	(MacroSelectors at: special) = #ifNotNil:
	ifTrue:
		[(self checkBlock: arguments first as: 'ifNotNil arg' from: encoder) ifFalse: [^ false].

		"Transform 'ifNotNil: [stuff]' to 'ifNil: [nil] ifNotNil: [stuff]'.
		Slightly better code and more consistent with decompilation."
		self noteSpecialSelector: #ifNil:ifNotNil:.
		selector _ SelectorNode new key: (MacroSelectors at: special) code: #macro.
		arguments _ {BlockNode withJust: NodeNil. arguments first}.
		(self transform: encoder) ifFalse: [self error: 'compiler logic error'].
		^ true]
	ifFalse:
		[^ self checkBlock: arguments first as: 'ifNil arg' from: encoder]
! !


!Symbol methodsFor: 'printing' stamp: 'di 4/24/2000 00:22'!
storeOn: aStream

	aStream nextPut: $#.
	self isLiteral
		ifTrue: [aStream nextPutAll: self]
		ifFalse: [super storeOn: aStream]! !


!SystemDictionary methodsFor: 'housekeeping' stamp: 'di 4/24/2000 14:02'!
recompileAllFrom: firstName 
	"Recompile all classes, starting with given name."

	Smalltalk forgetDoIts.
	self allClassesDo: 
		[:class | class name >= firstName
			ifTrue: 
				[Transcript show: class name; cr.
				class compileAll]]

	"Smalltalk recompileAllFrom: 'AAABodyShop'."
! !

