'From Squeak2.8alpha of 4 February 2000 [latest update: #2210] on 3 June 2000 at 8:09:27 pm'!
"Change Set:		113CategoryChgSpeedup-dvf
Date:			3 June 2000
Author:			Daniel Vainsencher

Used to be the time to change categories was dependant on the DB size. Now Celeste chooses whether to select the DB or to sort the category (fast for small categories ~< 800)."!


!IndexFile methodsFor: 'dictionary access' stamp: 'dvf 6/3/2000 16:56'!
keysCount
	^msgDictionary size! !


!MailDB methodsFor: 'categories' stamp: 'dvf 6/3/2000 15:06'!
messagesIn: categoryName 
	"Answer a collection of message ID's for the messages in the given 
	category, sorted in ascending time order.  If the category does not exist, 
	answer an empty collection. The pseudo-categories '.all.' and 
	'.unclassified.' are computed dynamically, which may take a little time."
	| msgList category |
	categoryName = '.unclassified.'
		ifTrue: 
			[Cursor execute showWhile: [msgList _ categoriesFile unclassifiedFrom: indexFile keys].
			^ msgList].
	categoryName = '.all.' ifTrue: [^ indexFile keys].
	"otherwise, it is a real category"
	category _ categoriesFile messagesIn: categoryName.
	^self sortedKeysForMessages: category.
	! !

!MailDB methodsFor: 'categories' stamp: 'dvf 6/3/2000 17:05'!
sortedKeysForMessages: aSet 
	"use a heuristic to choose method of obtaining sorted message list"
	^ aSet size * (aSet size log: 2) * 3 > indexFile keysCount
		ifTrue: [indexFile keys select: [:msgID | "indexFile keys is sorted"
				aSet includes: msgID]]
		ifFalse: [(aSet asArray
				mergeSortFrom: 1
				to: aSet size
				by: [:a :b | (self getTOCentry: a) time < (self getTOCentry: b) time]) asOrderedCollection]! !

