'From Squeak 2.1 of June 30, 1998 on 8 September 1998 at 9:40:27 pm'!
Stream subclass: #AttributedTextStream
	instanceVariableNames: 'characters attributeRuns currentAttributes attributesChanged '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Streams'!
!AttributedTextStream commentStamp: 'ls 9/8/1998 21:40' prior: 0!
a stream on Text's which keeps track of the last attribute put; new characters are added with those attributes.

instance vars:

	characters - a WriteStream of the characters in the stream
	attributeRuns - a RunArray with the attributes for the stream
	currentAttributes - the attributes to be used for new text
	attributesChanged - whether the attributes have changed since the last addition!


!AttributedTextStream methodsFor: 'retrieving the text' stamp: 'ls 6/27/1998 15:04'!
contents
	| ans |
	ans _ Text new: characters size.
	ans setString: characters contents  setRuns: attributeRuns.   "this is declared private, but it's exactly what I need, and it's declared as exactly what I want it to do...."
	^ans! !


!AttributedTextStream methodsFor: 'stream protocol' stamp: 'ls 6/27/1998 14:59'!
nextPut: aChar
	attributesChanged 
		ifTrue: [ 
			attributeRuns addLast: currentAttributes.
			attributesChanged _ false ]
		ifFalse: [
			attributeRuns  repeatLastIfEmpty: [ OrderedCollection new ] ].
	characters nextPut: aChar! !

!AttributedTextStream methodsFor: 'stream protocol' stamp: 'ls 6/27/1998 15:02'!
nextPutAll: aString
	"add an entire string with the same attributes"
	attributesChanged 
		ifTrue: [ attributeRuns addLast: currentAttributes times: aString size.
			attributesChanged _ false. ]
		ifFalse: [ attributeRuns repeatLast: aString size  ifEmpty: [ OrderedCollection new ] ].
	characters nextPutAll: aString.! !


!AttributedTextStream methodsFor: 'access' stamp: 'ls 6/27/1998 15:09'!
currentAttributes
	"return the current attributes"
	^currentAttributes! !

!AttributedTextStream methodsFor: 'access' stamp: 'ls 7/28/1998 02:08'!
currentAttributes: newAttributes
	"set the current attributes"
	attributesChanged _ currentAttributes ~= newAttributes.
	currentAttributes _ newAttributes.
! !


!AttributedTextStream methodsFor: 'private-initialization' stamp: 'ls 6/27/1998 15:08'!
initialize
	characters _ WriteStream on: String new.
	currentAttributes _ OrderedCollection new.
	attributesChanged _ true.
	attributeRuns _ RunArray new.
	! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

AttributedTextStream class
	instanceVariableNames: ''!

!AttributedTextStream class methodsFor: 'instance creation' stamp: 'ls 6/27/1998 15:07'!
new
	^super basicNew initialize! !
