'From Squeak2.9alpha of 12 June 2000 [latest update: #2449] on 11 July 2000 at 11:10:40 am'!
"Change Set:		FlashSync-ar
Date:			11 July 2000
Author:			Andreas Raab

Make flash players synchronize based on an instance property rather than a class property." !

FlashMorph subclass: #FlashSpriteMorph
	instanceVariableNames: 'playing maxFrames loadedFrames frameNumber stepTime damageRecorder sounds actions labels lastStepTime useTimeSync '
	classVariableNames: 'UseTimeSync '
	poolDictionaries: ''
	category: 'Balloon-MMFlash Morphs'!

!FlashSpriteMorph methodsFor: 'initialize' stamp: 'ar 7/11/2000 11:10'!
initialize
	super initialize.
	playing _ false.
	loadedFrames _ 0.
	maxFrames _ 1.
	frameNumber _ 1.
	sounds _ Dictionary new.
	actions _ Dictionary new.
	labels _ Dictionary new.
	stepTime _ 1.
	useTimeSync _ true.! !

!FlashSpriteMorph methodsFor: 'accessing' stamp: 'ar 7/11/2000 11:08'!
useTimeSync
	^useTimeSync ifNil:[true]! !

!FlashSpriteMorph methodsFor: 'accessing' stamp: 'ar 7/11/2000 11:08'!
useTimeSync: aBool
	useTimeSync _ aBool! !

!FlashSpriteMorph methodsFor: 'stepping' stamp: 'ar 7/11/2000 11:08'!
step
	| nowStepTime maxSteps |
	playing ifFalse:[^self].
	self useTimeSync ifTrue:[
		maxSteps _ 5.
		nowStepTime _ Time millisecondClockValue.
		[(lastStepTime + stepTime <= nowStepTime) and:[playing and:[maxSteps >= 0]]]
			whileTrue:[
				self stepForward.
				lastStepTime _ lastStepTime + stepTime.
				maxSteps _ maxSteps - 1.
			].
	] ifFalse:[self stepForward].
	damageRecorder _ nil. "Insurance"! !

!FlashSpriteMorph methodsFor: 'stepping' stamp: 'ar 7/11/2000 11:08'!
stepTime
	"If we're syncing with time step at double speed."
	^self useTimeSync
		ifTrue:[stepTime // 2]
		ifFalse:[stepTime]! !

!FlashSpriteMorph methodsFor: 'object fileIn' stamp: 'ar 7/11/2000 11:10'!
convertbosfcetcpmlfsdsall0: varDict bosfcetcpmlfsdsallu0: smartRefStrm
	"These variables are automatically stored into the new instance #('bounds' 'owner' 'submorphs' 'fullBounds' 'color' 'extension' 'transform' 'colorTransform' 'playing' 'maxFrames' 'loadedFrames' 'frameNumber' 'stepTime' 'damageRecorder' 'sounds' 'actions' 'labels' 'lastStepTime').
	This method is for additional changes. Use statements like (foo _ varDict at: 'foo')."

	"New variables: #('useTimeSync')  If a non-nil value is needed, please assign it."
	useTimeSync _ true.! !

FlashSpriteMorph class removeSelector: #initialize!
FlashSpriteMorph class removeSelector: #useTimeSync!
FlashSpriteMorph class removeSelector: #useTimeSync:!
FlashMorph subclass: #FlashSpriteMorph
	instanceVariableNames: 'playing maxFrames loadedFrames frameNumber stepTime damageRecorder sounds actions labels lastStepTime useTimeSync '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Balloon-MMFlash Morphs'!
