'From Squeak2.9alpha of 16 June 2000 [latest update: #2478] on 10 August 2000 at 9:21:22 am'!
"Change Set:		findTokens-tk
Date:			10 August 2000
Author:			Ted Kaehler

In the process of making the MethodFinder search for findTokens, I broke it thoroughly!!  Here is the fix.  findTokens: can accept a single character as the delimiter, without choking on an array of characters."!


!String methodsFor: 'accessing' stamp: 'tk 8/10/2000 09:14'!
findTokens: delimiters
	"Answer the collection of tokens that result from parsing self.  Return strings between the delimiters.  Any character in the Collection delimiters marks a border.  Several delimiters in a row are considered as just one separation.  Also, allow delimiters to be a single character."

	| tokens keyStart keyStop separators |

	tokens _ OrderedCollection new.
	separators _ delimiters class == Character 
		ifTrue: [Array with: delimiters]
		ifFalse: [delimiters].
	keyStop _ 1.
	[keyStop <= self size] whileTrue:
		[keyStart _ self skipDelimiters: separators startingAt: keyStop.
		keyStop _ self findDelimiters: separators startingAt: keyStart.
		keyStart < keyStop
			ifTrue: [tokens add: (self copyFrom: keyStart to: (keyStop - 1))]].
	^tokens! !

