'From Squeak2.9alpha of 26 July 2000 [latest update: #2497] on 16 August 2000 at 6:23:37 pm'!
"Change Set:		dismissScriptor-sw
Date:			16 August 2000
Author:			Scott Wallace

A couple of adjustments designed further to reduce confusion about dismissal/destruction of scripts by etoy users:

(1)  The user will no longer be able to drag a script into a trash-can in an ill-advised attempt to destroy the script.
(2)  If the user tries to dismiss a script editor via the halo, she is given a warning that this will be destructive (same pink x as the 'destroy script' control in the scriptor's header).

NB: A true undo involving pulling discarded scripts out of the trash to restore them is still some distance away.  Sorry!!"!


!Morph methodsFor: 'dropping/grabbing' stamp: 'sw 8/15/2000 16:58'!
willingToBeDiscarded
	^ true! !


!ScriptEditorMorph methodsFor: 'dropping/grabbing' stamp: 'sw 8/15/2000 17:07'!
dismissViaHalo
	"The user has clicked in the delete halo-handle.  This provides a hook in case some concomitant action should be taken, or if the particular morph is not one which should be put in the trash can, for example."

	self destroyScript! !

!ScriptEditorMorph methodsFor: 'dropping/grabbing' stamp: 'sw 8/15/2000 16:58'!
willingToBeDiscarded
	"Resist the drag-into-trash gesture"

	^ false! !


!TrashCanMorph methodsFor: 'event handling' stamp: 'sw 8/15/2000 16:59'!
mouseEnter: event
	"Present feedback for potential deletion."
	| hand firstSub |
	hand _ event hand.
	(((hand submorphCount > 0) and: [(firstSub _ hand submorphs first) ~~ self]) and:
			[firstSub willingToBeDiscarded])
		ifTrue: 
			[Preferences soundsEnabled ifTrue: [self class playMouseEnterSound].
			hand startDisplaySuppression.
			self world abandonAllHalos.
			self state: #pressed]
		ifFalse:
			[self showStampIn: hand]
! !

!TrashCanMorph methodsFor: 'dropping' stamp: 'sw 8/15/2000 17:03'!
wantsDroppedMorph: aMorph event: evt

	^ ((aMorph ~~ self) and: [aMorph ~~ Utilities scrapsBook]) and:
		[aMorph willingToBeDiscarded]! !

