'From Squeak2.9alpha of 16 June 2000 [latest update: #2596] on 11 September 2000 at 11:10:46 am'!

!Project methodsFor: 'release' stamp: 'tk 9/11/2000 11:10'!
okToChange
	"Answer whether the window in which the project is housed can be dismissed -- which is destructive. We never clobber a project without confirmation"

	| ok is list |
	self subProjects size  >0 ifTrue:
		[PopUpMenu notify: 
'The project ', self name printString, '
contains sub-projects.  You must remove these
explicitly before removing their parent.'.
		^ false].
	ok _ world isMorph not and: [world scheduledControllers size <= 1].
	ok ifFalse: [self isMorphic ifTrue: [
		self parent == CurrentProject 
			ifFalse: [^true]]].  "view from elsewhere.  just delete it."
	ok _ (self confirm:
'Really delete the project
', self name printString, '
and all its windows?').
		
	ok ifFalse: [^ false].

	"about to delete this project; clear previous links to it from other Projects:"
	ImageSegment allSubInstancesDo: [:seg |
		seg ifOutPointer: self thenAllObjectsDo: [:obj |
			(obj isKindOf: ProjectViewMorph) ifTrue: [
				obj deletingProject: self.  obj abandon].
			obj class == Project ifTrue: [obj deletingProject: self]]].
	Project allProjects do: [:p | p deletingProject: self].	"ones that are in"
	ProjectViewMorph allSubInstancesDo: [:p | 
		p deletingProject: self.
		p project == self ifTrue: [p abandon]].

	world isMorph 
		ifTrue: [world submorphs do:   "special release for wonderlands"
						[:m | (m isKindOf: WonderlandCameraMorph)
								and: [m getWonderland release]].
			"Remove Player classes and metaclasses owned by project"
			is _ ImageSegment new arrayOfRoots: (Array with: self).
			(list _ is rootsIncludingPlayers) ifNotNil: [
				list do: [:playerCls | 
					(playerCls respondsTo: #isMeta) ifTrue: [
						playerCls isMeta ifFalse: [
							playerCls removeFromSystemUnlogged]]]]].

	self removeChangeSetIfPossible.

	^ true
! !

