'From Squeak2.9alpha of 17 July 2000 [latest update: #2782] on 1 October 2000 at 12:33:01 pm'!
"Change Set:		projectGoof
Date:			1 October 2000
Author:			Bob Arning

- fix confusion in parsing project file name where version and suffix were interchanged
- fix an overlooked direct enumerator of Projects"!


!ChangeSet methodsFor: 'testing' stamp: 'RAA 10/1/2000 12:28'!
belongsToAProject

	Smalltalk at: #Project ifPresent:
		[:projClass | projClass allProjects do:
			[:proj | proj projectChangeSet == self ifTrue: [^ true]]].
	^ false! !


!Project class methodsFor: 'squeaklet on server' stamp: 'RAA 10/1/2000 12:31'!
parseProjectFileName: aString
"it was formerly possible to have periods in projct names and this messed up some parsing methods. Try to handle that more gracefully and allow for a change in scheme at a later time"

	| suffix baseName version versionAndSuffix |
	"answer an array with: 
		1 = basic project name
		2 = version string
		3 = suffix (pr)"
"----
Project parseProjectFileName: 'aa.bb.cc|vv.ss'
--degenerate forms--
Project parseProjectFileName: 'aa.bb.cc|.ss'
Project parseProjectFileName: 'aa.bb.cc|vv.'
Project parseProjectFileName: 'aa.bb.cc|.'
---"

	baseName _ version _ suffix _ ''.
	baseName _ aString copyUpToLast: $|.
	baseName = aString ifTrue: [
		(aString occurrencesOf: $.) > 1 ifTrue: [
			baseName _ aString copyUpToLast: $..
			suffix _ baseName allButFirst: baseName size + 1.
		].
	] ifFalse: [
		versionAndSuffix _ aString allButFirst: baseName size + 1.
		version _ versionAndSuffix copyUpTo: $..
		suffix _ versionAndSuffix allButFirst: version size + 1.
	].
	^{baseName. version. suffix}

! !

