'From Squeak2.9alpha of 17 July 2000 [latest update: #2786] on 2 October 2000 at 5:38:13 pm'!
"Change Set:		newScript3
Date:			2 October 2000
Author:			Bob Arning

- some fixes for positioning and sizing of flaps in pasteups that are not the world (i.e. that can be resized and positioned at other than 0@0)"!


!FlapTab methodsFor: 'positioning' stamp: 'RAA 10/2/2000 17:26'!
ownerChanged

	self fitOnScreen.
	self adaptToWorld.
! !

!FlapTab methodsFor: 'positioning' stamp: 'RAA 10/2/2000 17:35'!
spanWorld
	| container |

	container _ self pasteUpMorph ifNil: [self currentWorld].
	(self orientation == #vertical) ifTrue: [
		referent height: container height.
		referent width: (referent width min: container width - self width).
		referent top: container top.
	] ifFalse: [
		referent width: container width.
		referent height: (referent height min: container height - self height).
		referent left: container left.
	] ! !


!PasteUpMorph methodsFor: 'misc' stamp: 'RAA 10/2/2000 17:27'!
viewerFlapTabFor: aMorph
	"Open up a Viewer on aMorph in its own flap, creating it if necessary"
	| bottomMost aPlayer aFlapTab |
	bottomMost _ self top.
	aPlayer _ aMorph assuredPlayer.
	self flapTabs do:
		[:aTab | (aTab isKindOf: ViewerFlapTab)
			ifTrue:
				[bottomMost _ aTab bottom max: bottomMost.
				aTab scriptedPlayer == aPlayer
					ifTrue:
						[^ aTab]]].
	"Not found; make a new one"
	aFlapTab _ (
		Utilities newFlapTitled: aMorph externalName onEdge: #right inPasteUp: self
	) as: ViewerFlapTab.
	aFlapTab initializeFor: aPlayer topAt: bottomMost + 2.
	aFlapTab referent color: (Color green muchLighter alpha: 0.5).
	aFlapTab referent setProperty: #automaticPhraseExpansion toValue: true.
	self addMorphFront: aFlapTab.
	aFlapTab adaptToWorld: self.
	^ aFlapTab! !


!Presenter methodsFor: 'viewer' stamp: 'RAA 10/2/2000 17:27'!
viewMorph: aMorph
	| aPlayer aViewer aPalette aRect aPoint nominalHeight aFlapTab topItem flapLoc |
	Sensor leftShiftDown ifFalse:
		[((aPalette _ aMorph standardPalette) ~~ nil and: [aPalette isInWorld])
			ifTrue:	[^ aPalette viewMorph: aMorph]].

	aPlayer _ (topItem _ aMorph topRendererOrSelf) assuredPlayer.
	associatedMorph addMorph: (aViewer _ self nascentPartsViewer).

	"19 sept 2000 - allow flaps in any paste up"
	flapLoc _ associatedMorph "world".
	Preferences viewersInFlaps ifTrue:
		[aViewer setProperty: #noInteriorThumbnail toValue: true.
		aViewer initializeFor: aPlayer barHeight: 0.
		aViewer enforceTileColorPolicy.
		flapLoc hideViewerFlapsOtherThanFor: aPlayer.
		aFlapTab _ flapLoc viewerFlapTabFor: topItem.
		aFlapTab referent submorphs do: 
			[:m | (m isKindOf: Viewer) ifTrue: [m delete]].
		aFlapTab referent addMorph: aViewer beSticky.
		aViewer visible: true.
		aFlapTab applyThickness: aViewer width + 25.
		aFlapTab spanWorld.
		aFlapTab showFlap. 
		aViewer position: aFlapTab referent position.
		flapLoc startSteppingSubmorphsOf: aFlapTab.
		^ flapLoc startSteppingSubmorphsOf: aViewer].
		
	aViewer initializeFor: aPlayer barHeight: 6.
	aViewer enforceTileColorPolicy.
	Preferences automaticViewerPlacement ifTrue:
		[aPoint _ aMorph bounds right @ 
			(aMorph center y - ((nominalHeight _ aViewer initialHeightToAllow) // 2)).
		aRect _ (aPoint extent: (aViewer width @ nominalHeight)) translatedToBeWithin: flapLoc bounds.
		aViewer position: aRect topLeft.
		aViewer visible: true.
		flapLoc startSteppingSubmorphsOf: aViewer.
		"it's already in the world, somewhat coincidentally"
		^ self].
	aMorph primaryHand attachMorph: (aViewer visible: true)! !


!Utilities class methodsFor: 'flaps' stamp: 'RAA 10/2/2000 17:01'!
newFlapTitled: aString onEdge: anEdge

	^self newFlapTitled: aString onEdge: anEdge inPasteUp: self currentWorld
! !

!Utilities class methodsFor: 'flaps' stamp: 'RAA 10/2/2000 17:37'!
newFlapTitled: aString onEdge: anEdge inPasteUp: aPasteUpMorph
	| aFlap aFlapTab  orientation |

	aFlap _ PasteUpMorph newSticky.
	aFlapTab _ FlapTab new referent: aFlap.
	orientation _ (#(left right) includes: anEdge)
		ifTrue:	[#vertical]
		ifFalse:	[#horizontal].
	aFlapTab 
		assumeString: aString 
		font: Preferences standardFlapFont 
		orientation: orientation 
		color: Color veryLightGray.
	aFlapTab edgeToAdhereTo: anEdge; inboard: false.

	anEdge == #left ifTrue:
		[aFlapTab position: (aPasteUpMorph left @ aPasteUpMorph top).
		aFlap extent: (200 @ aPasteUpMorph height)].
	anEdge == #right ifTrue:
		[aFlapTab position: ((aPasteUpMorph right - aFlapTab width) @ aPasteUpMorph top).
		aFlap extent: (200 @ aPasteUpMorph height)].
	anEdge == #top ifTrue:
		[aFlapTab position: ((aPasteUpMorph left + 50) @ aPasteUpMorph top).
		aFlap extent: (aPasteUpMorph width @ 200)].
	anEdge == #bottom ifTrue:
		[aFlapTab position: ((aPasteUpMorph left + 50) @ (aPasteUpMorph bottom - aFlapTab height)).
		aFlap extent: (aPasteUpMorph width @ 200)].

	aFlap beFlap: true.
	aFlap color: (Color veryLightGray muchLighter).

	^ aFlapTab! !

