'From Squeak2.9alpha of 17 July 2000 [latest update: #2910] on 27 October 2000 at 11:17:25 am'!
"Change Set:		slimmerPVM
Date:			27 October 2000
Author:			Bob Arning

- reduce size of published projects with lots of ProjectViewMorphs. Also fixes some older undesirable behavior"!


!ProjectViewMorph methodsFor: 'drawing' stamp: 'RAA 10/27/2000 10:55'!
ensureImageReady

	project ifNil: [^ self].
	project isInMemory ifFalse: [^self].
	project class == DiskProxy ifTrue: [^self].
	project thumbnail ifNil: [
		image fill: image boundingBox rule: Form over 
			fillColor: project defaultBackgroundColor.
		^self
	].
	project thumbnail ~~ lastProjectThumbnail ifTrue: ["scale thumbnail to fit my bounds"
		lastProjectThumbnail _ project thumbnail.
		self updateImageFrom: lastProjectThumbnail.
		image borderWidth: 1
	].


! !

!ProjectViewMorph methodsFor: 'drawing' stamp: 'RAA 10/27/2000 10:50'!
updateImageFrom: sourceForm

	(WarpBlt current toForm: image)
		sourceForm: sourceForm;
		cellSize: 2;  "installs a colormap"
		combinationRule: Form over;
		copyQuad: (sourceForm boundingBox) innerCorners
		toRect: image boundingBox.
! !

!ProjectViewMorph methodsFor: 'events' stamp: 'RAA 10/27/2000 11:08'!
extent: aPoint
	"Set my image form to the given extent."

	| newExtent scaleP scale |

	((bounds extent = aPoint) and: [image depth = Display depth]) ifFalse: [
		lastProjectThumbnail ifNil: [ lastProjectThumbnail _ image ].
		scaleP _ aPoint / lastProjectThumbnail extent.
		scale _ scaleP "scaleP x asFloat max: scaleP y asFloat".
		newExtent _ (lastProjectThumbnail extent * scale) rounded.
		self image: (Form extent: newExtent depth: Display depth).
		self updateImageFrom: lastProjectThumbnail.
	].
	self updateNamePosition.! !

!ProjectViewMorph methodsFor: 'fileIn/out' stamp: 'RAA 10/27/2000 11:08'!
objectForDataStream: refStrm
	
	| copy |

	1 = 1 ifTrue: [^self].		"this didn't really work"

	copy _ self copy lastProjectThumbnail: nil.
	"refStrm replace: self with: copy."
	^copy
! !

!ProjectViewMorph methodsFor: 'fileIn/out' stamp: 'RAA 10/27/2000 10:55'!
releaseCachedState

	"see if we can reduce size of published file, but there may be problems"
	super releaseCachedState.
	lastProjectThumbnail _ image.
! !

