'From Squeak2.9alpha of 17 July 2000 [latest update: #2932] on 1 November 2000 at 11:26:24 pm'!
"Change Set:		8bitNebraska
Date:			1 November 2000
Author:			Bob Arning

- fix transmission of 8-bit forms in Nebraska (strange speckles)"!


!CanvasDecoder methodsFor: 'decoding' stamp: 'RAA 11/1/2000 23:23'!
drawImage: command
	| image point sourceRect rule cacheID cacheNew previousImage |

	image := self class decodeImage: (command at: 2).
	point := self class decodePoint: (command at: 3).
	sourceRect := self class decodeRectangle: (command at: 4).
	rule := self class decodeInteger: (command at: 5).
	command size >= 7 ifTrue: [
		false ifTrue: [self showSpaceUsed].		"debugging"
		cacheID _ self class decodeInteger: (command at: 6).
		cacheNew _ (self class decodeInteger: (command at: 7)) = 1.
		cacheID > 0 ifTrue: [
			CachedForms ifNil: [CachedForms _ Array new: 100].
			cacheNew ifTrue: [
				CachedForms at: cacheID put: image
			] ifFalse: [
				previousImage _ CachedForms at: cacheID.
				image ifNil: [
					image _ previousImage
				] ifNotNil: [
					(previousImage notNil and: [image depth > 8]) ifTrue: [
						image _ previousImage addDeltasFrom: image.
					].
					CachedForms at: cacheID put: image
				].
			].
		].
	].
	self drawCommand: [ :c |
		c image: image  at: point  sourceRect: sourceRect rule: rule
	]! !


!CanvasEncoder methodsFor: 'drawing' stamp: 'RAA 11/1/2000 23:21'!
image: aForm at: aPoint sourceRect: sourceRect rule: rule

	| cacheID cacheNew cacheReply formToSend cacheEntry destRect visRect aFormArea d2 |

	"first if we are only going to be able to draw a small part of the form,
	it may be faster just to send the part of the form that will actually show up"

	destRect _ aPoint extent: sourceRect extent.
	d2 _ (lastTransform invertBoundsRect: destRect) expandBy: 1.
	(d2 intersects: lastClipRect) ifFalse: [
		^NebraskaDebug at: #bigImageSkipped add: {lastClipRect. d2}.
	].
	aFormArea _ aForm boundingBox area.
	(aFormArea > 20000 and: [aForm isStatic not and: [lastTransform isPureTranslation]]) ifTrue: [
		visRect _ destRect intersect: lastClipRect.
		visRect area < (aFormArea // 20) ifTrue: [
			"NebraskaDebug 
				at: #bigImageReduced 
				add: {lastClipRect. aPoint. sourceRect extent. lastTransform}."
			formToSend _ aForm copy: (visRect translateBy: sourceRect origin - aPoint).
			^self 
				image: formToSend 
				at: visRect origin 
				sourceRect: formToSend boundingBox
				rule: rule
				cacheID: 0 		"no point in trying to cache this - it's a one-timer"
				newToCache: false.
		].
	].

	cacheID _ 0.
	cacheNew _ false.
	formToSend _ aForm.
	(aFormArea > 1000 and: [(cacheReply _ self testCache: aForm) notNil]) ifTrue: [
		cacheID _ cacheReply first.
		cacheEntry _ cacheReply third.
		(cacheNew _ cacheReply second) ifFalse: [
			formToSend _ aForm isStatic 
				ifTrue: [nil] 
				ifFalse: [aForm depth <= 8 ifTrue: [aForm] ifFalse: [aForm deltaFrom: cacheEntry fourth]].
		].
		cacheEntry at: 4 put: (aForm isStatic ifTrue: [aForm] ifFalse: [aForm deepCopy]).
	].
	self
		image: formToSend 
		at: aPoint 
		sourceRect: sourceRect 
		rule: rule 
		cacheID: cacheID 
		newToCache: cacheNew.

! !

