'From Squeak2.9alpha of 13 June 2000 [latest update: #2968] on 7 November 2000 at 3:19:59 pm'!
"Change Set:		WnldBackgrounds-ar
Date:			7 November 2000
Author:			Andreas Raab

Allows Wonderlands to use statically cached images 'under' the Wonderland as optimized backgrounds."!


!WonderlandCameraMorph methodsFor: 'drawing' stamp: 'ar 11/7/2000 15:16'!
areasRemainingToFill: aRectangle
	^(myCamera drawSceneBackground or:[self bgCacheValid])
		ifTrue:[aRectangle areasOutside: self bounds]
		ifFalse:[Array with: aRectangle]! !

!WonderlandCameraMorph methodsFor: 'drawing' stamp: 'ar 11/7/2000 15:16'!
bgCacheValid
	| bg |
	bg _ self valueOfProperty: #backgroundSnapshot ifAbsent:[^false].
	^bg extent = self extent and:[bg depth = Display depth]! !

!WonderlandCameraMorph methodsFor: 'drawing' stamp: 'ar 11/7/2000 15:15'!
drawOn: aCanvas 
	| bg |
	bg _ self valueOfProperty: #backgroundSnapshot.
	bg == nil ifFalse:[
		(bg extent = self extent or:[bg depth = Display depth]) ifFalse:[
			bg _ Display allocateForm: self extent.
			Display displayOn: bg at: bounds origin negated.
			self setProperty: #backgroundSnapshot toValue: bg.
		].
		aCanvas drawImage: bg at: bounds origin.
	].
	aCanvas asBalloonCanvas render: self.
	self outline ifNotNil: [self sketchOn: aCanvas].
	"*** hack ***"
	pickedPoint _ nil.! !

!WonderlandCameraMorph methodsFor: 'drawing' stamp: 'ar 11/7/2000 15:15'!
releaseCachedState
	| bg |
	bg _ self valueOfProperty: #backgroundSnapshot.
	bg == nil ifTrue:[^self].
	self setProperty: #backgroundSnapshot toValue: (Form extent: 1@1).
! !

!WonderlandCameraMorph methodsFor: 'menu' stamp: 'ar 11/7/2000 15:09'!
addCustomMenuItems: aCustomMenu hand: aHandMorph 
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu addUpdating: #snapshotBackgroundString action: #toggleSnapshotBackground.
	aCustomMenu addUpdating: #getDragAndDropState action: #toggleDragAndDropState.
	(myControls == nil)
		
		ifTrue:[aCustomMenu add: 'showCameraControls' action: #showCameraControls]
ifFalse:[aCustomMenu add: 'hideCameraControls' action: #deleteCameraControls]
		
	
! !

!WonderlandCameraMorph methodsFor: 'menu' stamp: 'ar 11/7/2000 15:08'!
snapshotBackgroundString
	^(self hasProperty: #backgroundSnapshot) 
		ifTrue:[^'<on>background snapshot'] 
		ifFalse:['<off>background snapshot'].! !

!WonderlandCameraMorph methodsFor: 'menu' stamp: 'ar 11/7/2000 15:09'!
toggleSnapshotBackground
	(self hasProperty: #backgroundSnapshot)
		ifTrue:[self removeProperty: #backgroundSnapshot]
		ifFalse:[self setProperty: #backgroundSnapshot toValue: (Form extent: 1@1)].! !

