'From Squeak2.9alpha of 17 July 2000 [latest update: #3001] on 11 November 2000 at 8:17:49 pm'!
"Change Set:		prettyThreads
Date:			11 November 2000
Author:			Bob Arning

- make InternalThreadNavigationMorph prettier"!


!InternalThreadNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/11/2000 19:20'!
addButtons

	self fewerButtonsMode ifTrue: [^self addButtonsAlan].
	self layoutInset: 2.
	self addARow: {
		self inAColumn: {(StringMorph contents: threadName asString) lock}.
	}.
	self addARow: {
		self inAColumn: {self buttonFirst}.
		self inAColumn: {self buttonPrevious}.
		self inAColumn: {self buttonForward}.
		self inAColumn: {self buttonLast}.
		self inAColumn: {self buttonForMenu}.
	}.

! !

!InternalThreadNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/11/2000 20:01'!
addButtonsAlan

	| marginPt i sz data images pageNumber proj f m b1 b2 dot arrowWidth arrowCenter vertices arrowHeight |

	self changeNoLayout.
	marginPt _ 4@4.
	i _ self currentIndex.
	sz _ 50@40.
	arrowWidth _ 14.
	arrowHeight _ 17.
	data _ {
		{i - 1. 'Previous:'. #previousPage. #rightCenter. arrowWidth negated}.
		{i + 1. 'Next:'. #nextPage. #leftCenter. arrowWidth}
	}.
	images _ data collect: [ :tuple |
		pageNumber _ tuple first.
		((pageNumber between: 1 and: listOfPages size) and: 
				[(proj _ Project named: (listOfPages at: pageNumber) first) notNil]) ifTrue: [
			f _ proj thumbnail scaledToSize: sz.
			arrowCenter _ f boundingBox perform: tuple fourth.
			vertices _ {
				arrowCenter - (0@arrowHeight).
				arrowCenter + (0@arrowHeight).
				arrowCenter + (tuple fifth @ 0).
			}.
			f getCanvas
				drawPolygon: vertices 
				color: Color orange 
				borderWidth: 0 
				borderColor: Color transparent.
			m _ ImageMorph new image: f.
			m setBalloonText: tuple second,' ',(listOfPages at: pageNumber) first.
			m on: #mouseUp send: tuple third to: self.
		] ifFalse: [
			f _ (Form extent: sz depth: 16) fillColor: Color lightGray.
			m _ ImageMorph new image: f.
		].
		m
	].
	b1 _ images first.
	b2 _ images second.
	dot _ EllipseMorph new extent: 16@16; color: Color orange lighter; borderWidth: 0.
	self addMorph: (b1 position: self position + marginPt).
	self addMorph: (b2 position: b1 topRight + (marginPt x @ 0)).
	self addMorph: dot.
	dot align: dot center with: b1 bounds rightCenter + ((marginPt x @ 0) // 2).
	dot setBalloonText: threadName,'
more commands'.
	dot on: #mouseUp send: #moreCommands to: self.

! !

!InternalThreadNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/11/2000 19:09'!
currentIndex

	| currentName |

	currentName _ CurrentProjectRefactoring currentProjectName.
	listOfPages withIndexDo: [ :each :index |
		each first = currentName ifTrue: [^currentIndex _ index]
	].
	^currentIndex ifNil: [1]
! !

!InternalThreadNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/11/2000 19:11'!
listOfPages: aCollection

	listOfPages _ aCollection.
	currentIndex _ nil.
	self currentIndex
! !


!InternalThreadNavigationMorph class methodsFor: 'as yet unclassified' stamp: 'RAA 11/11/2000 20:16'!
openThreadNamed: nameOfThread

	| coll nav |

	coll _ self knownThreads at: nameOfThread ifAbsent: [^self].
	nav _ World 
		submorphThat: [ :each | (each isKindOf: self) and: [each threadName = nameOfThread]]
		ifNone: [
			nav _ self basicNew.
			nav
				listOfPages: coll;
				threadName: nameOfThread;
				initialize;
				openInWorld;
				align: nav fullBounds bottomRight with: nav world bottomRight.
			^self
		].
	nav
		listOfPages: coll;
		threadName: nameOfThread;
		removeAllMorphs;
		addButtons.

! !

