'From Squeak2.9alpha of 12 June 2000 [latest update: #3005] on 13 November 2000 at 1:18:56 am'!
"Change Set:		OwnerTraversal2
Date:			13 November 2000
Author:			Dan Ingalls

Consolidates prior cleanup with preexisting methods so the basic set is
	<Morph>allOwnersDo: aBlock
		'Stops when owner == nil'
 	<Morph>withAllOwnersDo: aBlock
		'Does self as well as all owners' 
	<Morph>firstOwnerSuchThat: conditionBlock
		'Returns the morph or nil'
	<Morph>orOwnerSuchThat: conditionBlock
		Includes self and returns the morph or nil 
Removes the redundant ...SuchThat:do: variants.
"!


!Morph methodsFor: 'structure' stamp: 'di 11/13/2000 01:00'!
allOwners
	"Return the owners of the reciever"

	^ Array streamContents: [:strm | self allOwnersDo: [:m | strm nextPut: m]]! !

!Morph methodsFor: 'structure' stamp: 'di 11/13/2000 00:48'!
firstOwnerSuchThat: conditionBlock

	self allOwnersDo: [:m | (conditionBlock value: m) ifTrue: [^ m]].
	^ nil
! !

!Morph methodsFor: 'structure' stamp: 'di 11/13/2000 00:49'!
orOwnerSuchThat: conditionBlock

	(conditionBlock value: self) ifTrue: [^ self].
	self allOwnersDo: [:m | (conditionBlock value: m) ifTrue: [^ m]].
	^ nil

! !

!Morph methodsFor: 'structure' stamp: 'di 11/13/2000 00:50'!
outermostMorphThat: conditionBlock
	"Return the outermost containing morph for which aBlock is true, or nil if none"

	| outermost |
	self allOwnersDo: [:m | (conditionBlock value: m) ifTrue: [outermost _ m]].
	^ outermost! !

!Morph methodsFor: 'structure' stamp: 'di 11/13/2000 00:59'!
withAllOwners
	"Return the receiver and all its owners"

	^ Array streamContents: [:strm | self withAllOwnersDo: [:m | strm nextPut: m]]! !

!Morph methodsFor: 'parts bin' stamp: 'di 11/13/2000 00:49'!
inPartsBin

	self isPartsDonor ifTrue: [^ true].
	self allOwnersDo: [:m | m isPartsBin ifTrue: [^ true]].
	^ false
! !


!FlashSpriteMorph methodsFor: 'private' stamp: 'di 11/13/2000 00:51'!
getWebBrowser
	"Return a web browser if we're running in one"

	self withAllOwnersDo:
		[:morph | morph isWebBrowser ifTrue: [^ morph].
		(morph hasProperty: #webBrowserView) ifTrue: [^ morph model]].
	^ nil! !


!URLMorph methodsFor: 'private' stamp: 'di 11/13/2000 00:55'!
enclosingPage
	"Answer the inner-most SqueakPage contents that contains this morph, or nil if there isn't one."

	self allOwnersDo:
		[:m | (m isKindOf: PasteUpMorph)
			ifTrue: [(SqueakPageCache pageForMorph: m) ifNotNilDo: [:pg | ^ pg]]].
	^ nil
! !

Morph removeSelector: #allOwnersSuchThat:do:!
Morph removeSelector: #withOwnersSuchThat:do:!
