'From Squeak2.9alpha of 17 July 2000 [latest update: #3306] on 26 January 2001 at 9:19:01 am'!
"Change Set:		pvmMouseLeave
Date:			26 January 2001
Author:			Bob Arning

Remove rollover halo from ProjectViewMorph if the mouse left with the button down. Also, remove redundant set of state indicators (the old, one-pixel border)."!

ImageMorph subclass: #ProjectViewMorph
	instanceVariableNames: 'project lastProjectThumbnail currentBorderColor mouseDownTime '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Windows'!

!ProjectViewMorph methodsFor: 'copying' stamp: 'RAA 1/26/2001 09:15'!
veryDeepInner: deepCopier
	"Copy all of my instance variables.  Some need to be not copied at all, but shared.  See DeepCopier class comment."

	super veryDeepInner: deepCopier.
	project _ project.		"Weakly copied"
	lastProjectThumbnail _ lastProjectThumbnail veryDeepCopyWith: deepCopier.
	mouseDownTime _ nil.! !

!ProjectViewMorph methodsFor: 'drawing' stamp: 'RAA 1/26/2001 09:14'!
showBorderAs: aColor

	"image border: image boundingBox width: 1 fillColor: aColor.
	currentBorderColor _ aColor.
	self changed"
! !

!ProjectViewMorph methodsFor: 'events' stamp: 'RAA 1/26/2001 09:03'!
handlesMouseOverDragging: evt

	^ true! !

!ProjectViewMorph methodsFor: 'events' stamp: 'RAA 1/26/2001 09:14'!
initialize
	super initialize.
	"currentBorderColor _ Color gray."
	self addProjectNameMorphFiller.! !

!ProjectViewMorph methodsFor: 'events' stamp: 'RAA 1/26/2001 09:03'!
mouseDown: evt

	"Smalltalk at: #Q put: OrderedCollection new"
	"Q add: {Time millisecondClockValue / 1000.0. self. evt hand mouseFocus. thisContext longStack}."

	evt hand newMouseFocus: self.
	self removeProperty: #wasOpenedAsSubproject.
	self showMouseState: 2.
	mouseDownTime _ Time millisecondClockValue! !

!ProjectViewMorph methodsFor: 'events' stamp: 'RAA 1/26/2001 09:03'!
mouseLeaveDragging: evt

	self mouseLeave: evt

! !

!ProjectViewMorph methodsFor: 'events' stamp: 'RAA 1/26/2001 09:16'!
mouseStillDown: evt

	(self containsPoint: evt cursorPoint) ifFalse: [
		self showMouseState: 3.
		mouseDownTime _ nil.
		^self
	].
	self showMouseState: 2.
	mouseDownTime ifNil: [
		mouseDownTime _ Time millisecondClockValue.
		^self
	].
	((Time millisecondClockValue - mouseDownTime) > 1100) ifFalse: [^self].
				
	self showMenuForProjectView.

					! !

!ProjectViewMorph methodsFor: 'events' stamp: 'RAA 1/26/2001 09:16'!
showMouseState: anInteger

	anInteger = 1 ifTrue: [		"enter"
		self addMouseActionIndicatorsWidth: 10 color: (Color blue alpha: 0.3).
		"self showBorderAs: Color blue"
	].

	anInteger = 2 ifTrue: [		"down"
		self addMouseActionIndicatorsWidth: 15 color: (Color blue alpha: 0.7).
		"self showBorderAs: Color red."
	].

	anInteger = 3 ifTrue: [		"leave"
		self deleteAnyMouseActionIndicators.
		"self showBorderAs: Color gray"
	].

! !

!ProjectViewMorph methodsFor: 'object fileIn' stamp: 'RAA 1/26/2001 09:14'!
convertToCurrentVersion: varDict refStream: smartRefStrm
	
	"currentBorderColor ifNil: [currentBorderColor _ Color gray]."

	^super convertToCurrentVersion: varDict refStream: smartRefStrm.

! !

ProjectViewMorph removeSelector: #borderColor!
ImageMorph subclass: #ProjectViewMorph
	instanceVariableNames: 'project lastProjectThumbnail mouseDownTime '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Windows'!
