'From Squeak 2.2 of Sept 23, 1998 on 6 October 1998 at 1:49:29 pm'!
"Change Set:		sortedProjectList
Date:			6 October 1998
Author:			Scott Wallace

Makes the presentation of the full list of project names in the bottom part of the jump-to-project  menu be in case-blind alphabetical order"!


!Project class methodsFor: 'utilities' stamp: 'sw 10/6/1998 13:48'!
buildJumpToMenu: menu
	"Present a list of potential projects, excluding the current one"
	| prev |
	"First a FIFO list -- inelegantly, this may include repeats."
	(prev _ CurrentProject previousProject) ifNotNil:
		[1 to: 5 do:
			[:i | 
			prev ifNotNil: 
				[self addItem: prev name , ' (back ' , i printString , ')'
					toMenu: menu selection: '%back' , i printString.
				prev _ prev previousProject]].
		menu addLine].

	"Then the parent"
	CurrentProject isTopProject ifFalse: 
		[self addItem: CurrentProject parent name , ' (parent)' toMenu: menu selection: #parent.
		menu addLine].

	"Finally all the projects, other than the current one"
	(Project allNames asSortedCollection: [:n1 :n2 | n1 asLowercase < n2 asLowercase]) do: [:n | self addItem: n toMenu: menu selection: n].
	^ menu
! !


