'From Squeak3.1alpha of 4 February 2001 [latest update: #3714] on 24 February 2001 at 6:38:02 pm'!
"Change Set:		CleanseFix-ar
Date:			24 February 2001
Author:			Andreas Raab

Fixes a bug in #cleanseStepList which used Morph>>stopStepping when it determined that the Morph didn't belong to the current world. Of course, Morph>>stopStepping used 'self world' to find out where to stop stepping so nobody ever got removed."!


!WorldState methodsFor: 'stepping' stamp: 'ar 2/23/2001 21:14'!
cleanseStepListForWorld: aWorld
	"Remove morphs from the step list that are not in this World.  Often were in a flap that has moved on to another world."

	| deletions morphToStep |
	deletions _ nil.
	stepList do: [:entry |
		morphToStep _ entry receiver.
		morphToStep world == aWorld ifFalse:[
			deletions ifNil: [deletions _ OrderedCollection new].
			deletions addLast: entry]].

	deletions ifNotNil:[
		deletions do: [:entry|
			self stopStepping: entry receiver]].

	self alarms copy do:[:entry|
		morphToStep _ entry receiver.
		(morphToStep isMorph and:[morphToStep world == aWorld]) 
			ifFalse:[self removeAlarm: entry selector for: entry receiver]].! !

