'From Squeak3.1alpha of 5 February 2001 [latest update: #3830] on 14 March 2001 at 10:03:47 am'!
"Change Set:		CurveBoundsFix-nk
Date:			11 March 2001
Author:			Ned Konz

Curved lines were not computing their bounds correctly
if they didn't have an arrow at their first vertex.
This change set fixes the problem."!


!PolygonMorph methodsFor: 'private' stamp: 'RAA 3/14/2001 10:00'!
curveBounds

	| curveBounds pointAfterFirst pointBeforeLast |
	smoothCurve ifFalse: [^ (Rectangle encompassing: vertices) expandBy: borderWidth+1//2].

	"Compute the bounds from actual curve traversal, with leeway for borderWidth.
	Also note the next-to-first and next-to-last points for arrow directions."

	curveState _ nil.  "Force recomputation. Note: will be recreated in #coefficients"
	curveBounds _ vertices first corner: vertices last.
	pointAfterFirst _ nil.
	self lineSegmentsDo: [:p1 :p2 |
		pointAfterFirst ifNil: [
			pointAfterFirst _ p2 asIntegerPoint.
			curveBounds _ curveBounds encompass: p1 asIntegerPoint.
		].
		curveBounds _ curveBounds encompass: p2 asIntegerPoint.
		pointBeforeLast _ p1 asIntegerPoint.
	].

	curveState at: 2 put: pointAfterFirst.
	curveState at: 3 put: pointBeforeLast.
	^ curveBounds expandBy: borderWidth+1//2! !

