'From Squeak3.1alpha [latest update: #''Squeak3.1alpha'' of 5 February 2001 update 3892] on 3 April 2001 at 10:11:42 pm'!
"Change Set:		SystemWindowStepping
Date:			3 April 2001
Author:			Dan Ingalls

Simplifies the stepping logic for SystemWindows.

Most importantly it eliminates what had been a duplication of all the tests involved in smart updating.

Documents the current fact that inherited step behavior is suppressed for collapsed SystemWindows.
"!


!SystemWindow methodsFor: 'stepping' stamp: 'di 4/3/2001 22:01'!
step
	"If the receiver is not collapsed, step it, after first stepping the model."

	isCollapsed ifFalse:
		[model ifNotNil: [model stepIn: self].
		super step  "in case there is a Player who would like to be stepped"]

"Note that super-step will not get run for collapsed windows,
unless special provisions are made elsewhere."! !


!IRCMorph methodsFor: 'stepping' stamp: 'di 4/3/2001 21:57'!
step
	connection processIO.
	super step.! !


!PDAMorph methodsFor: 'as yet unclassified' stamp: 'di 4/3/2001 22:09'!
step

	self setLabel: model labelString.  "Super won't step if collapsed"
	super step.
	! !

SystemWindow removeSelector: #stepAt:!
