'From Squeak3.1alpha [latest update: #''Squeak3.1alpha'' of 5 February 2001 update 3945] on 23 April 2001 at 1:18:42 pm'!
"Change Set:		polygonSubmorphs
Date:			23 April 2001
Author:			Bob Arning

Fixes: If a PolygonMorph with another morph embedded in it is put into a GeeMail and then taken out, the embedded morph's position is messed up."!


!PolygonMorph methodsFor: 'private' stamp: 'RAA 4/23/2001 13:15'!
computeBounds
	| oldBounds delta excludeHandles |
	vertices ifNil: [^ self].

	self changed.
	oldBounds _ bounds.
	self releaseCachedState.
	bounds _ self curveBounds.
	self arrowForms do:
		[:f | bounds _ bounds merge: (f offset extent: f extent)].
	handles ifNotNil: [self updateHandles].

	"since we are directly updating bounds, see if any ordinary submorphs exist and move them accordingly"
	(oldBounds notNil and: [(delta _ bounds origin - oldBounds origin) ~= (0@0)]) ifTrue: [
		excludeHandles _ IdentitySet new.
		handles ifNotNil: [excludeHandles addAll: handles].
		self submorphsDo: [ :each |
			(excludeHandles includes: each) ifFalse: [
				each position: each position + delta
			].
		].
	].
	self layoutChanged.
	self changed.
! !

