'From Squeak3.1alpha of 5 February 2001 [latest update: #4110] on 31 May 2001 at 3:28:05 pm'!
"Change Set:		NebraskaTweaks
Date:			31 May 2001
Author:			Bob Arning

Some visual improvements for the NebraskaServerMorph"!

AlignmentMorphBob1 subclass: #NebraskaServerMorph
	instanceVariableNames: 'server slowCounter previousBacklog lastFullUpdateTime currentStatusString fullDisplay previousClients currentBacklogString '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Remote'!

!NebraskaServerMorph methodsFor: 'initialization' stamp: 'RAA 5/31/2001 15:07'!
initialize

	super initialize.
	fullDisplay _ false.
	color _ Color white.
	lastFullUpdateTime _ 0.
	self listDirection: #topToBottom;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
! !

!NebraskaServerMorph methodsFor: 'initialization' stamp: 'RAA 5/31/2001 15:13'!
rebuild

	| myServer toggle closeBox font |

	font _ StrikeFont familyName: #Palatino size: 14.
	self removeAllMorphs.
	self setColorsAndBorder.
	self updateCurrentStatusString.
	toggle _ SimpleHierarchicalListMorph new perform: (
		fullDisplay ifTrue: [#expandedForm] ifFalse: [#notExpandedForm]
	).
	closeBox _ SimpleButtonMorph new borderWidth: 0;
			label: 'X' font: Preferences standardButtonFont; color: Color transparent;
			actionSelector: #delete; target: self; extent: 14@14;
			setBalloonText: 'End Nebrasks session'.

	self addARow: {
		self inAColumn: {closeBox}.
		self inAColumn: {
			UpdatingStringMorph new
				useStringFormat;
				target:  self;
				font: font;
				getSelector: #currentStatusString;
				contents: self currentStatusString;
				stepTime: 2000;
				lock.
		}.
		self inAColumn: {
			toggle asMorph
				on: #mouseUp send: #toggleFull to: self;
				setBalloonText: 'Show more or less of Nebraska Status'
		}.
	}.
	myServer _ self server.
	(myServer isNil or: [fullDisplay not]) ifTrue: [
		^World startSteppingSubmorphsOf: self
	].
	"--- the expanded display ---"
	self addARow: {
		self inAColumn: {
			UpdatingStringMorph new
				useStringFormat;
				target:  self;
				font: font;
				getSelector: #currentBacklogString;
				contents: self currentBacklogString;
				stepTime: 2000;
				lock.
		}.
	}.

	self addARow: {
		self inAColumn: {
			(StringMorph contents: '--clients--') lock; font: font.
		}.
	}.

	myServer clients do: [ :each |
		self addARow: {
			UpdatingStringMorph new
				useStringFormat;
				target: each;
				font: font;
				getSelector: #currentStatusString;
				contents: each currentStatusString;
				stepTime: 2000;
				lock.
		}
	].
	World startSteppingSubmorphsOf: self.! !

!NebraskaServerMorph methodsFor: 'initialization' stamp: 'RAA 5/31/2001 14:54'!
setColorsAndBorder

	| worldColor c |
	((Preferences menuColorFromWorld and: [Display depth > 4]) and: 
						[(worldColor _ self currentWorld color) isColor]) ifTrue: [
		c _ worldColor luminance > 0.7 ifTrue: [
			worldColor mixed: 0.8 with: Color black
		] ifFalse: [
			worldColor mixed: 0.4 with: Color white
		].
	] ifFalse: [
		c _ Preferences menuColor.
	].
	self color: c.
	self borderColor: #raised.
	self borderWidth: Preferences menuBorderWidth.
	self useRoundedCorners.! !

!NebraskaServerMorph methodsFor: 'drawing' stamp: 'RAA 5/31/2001 15:03'!
updateCurrentStatusString

	self server ifNil:[
		currentStatusString _ '<Nebraska not active>'.
		currentBacklogString _ ''.
	] ifNotNil:[
		currentStatusString _ 
			' Nebraska: ', 
			self server numClients printString, 
			' clients'.
		currentBacklogString _ 'backlog: ',
				((previousBacklog _ self server backlog) // 1024) printString,'k'
	].
! !

!NebraskaServerMorph methodsFor: 'accessing' stamp: 'RAA 5/31/2001 15:03'!
currentBacklogString

	^currentBacklogString! !

