'From Squeak 2.2 of Sept 23, 1998 on 16 November 1998 at 3:07:30 am'!

!DynamicInterpreter class methodsFor: 'translation' stamp: 'ar 11/15/1998 23:58'!
translate: fileName doInlining: inlineFlag doAssertions: assertionFlag
	"Time millisecondsToRun: [
		DynamicInterpreter translate: 'translator.c' doInlining: false doAssertions: false.
		Smalltalk beep]"

	"Time millisecondsToRun: [
		DynamicInterpreter translate: 'translator.c' doInlining: false doAssertions: true.
		Smalltalk beep]"

	"Time millisecondsToRun: [
		DynamicInterpreter translate: 'translator.c' doInlining: true doAssertions: true.
		Smalltalk beep]"

	"Time millisecondsToRun: [
		DynamicInterpreter translate: 'translator.c' doInlining: true doAssertions: false.
		Smalltalk beep]"

	self	translate: fileName
		doInlining: inlineFlag
		doAssertions: assertionFlag
		fromClasses: (OrderedCollection new
				add: BitBltSimulation;
				add: ObjectMemory;
				add: DynamicInterpreterState;
				add: DynamicContextCache;
				add: DynamicTranslator;
				add: DynamicInterpreter;
				add: FFTPlugin;
				add: FloatArrayPlugin;
				add: Matrix2x3Plugin;
				add: BalloonEngineBase;
				add: BalloonEnginePlugin;
			yourself)! !


!FileList methodsFor: 'file list menu' stamp: 'ar 11/15/1998 23:57'!
itemsForFileEnding: suffix
	| labels lines selectors |
	labels _ OrderedCollection new.
	lines _ OrderedCollection new.
	selectors _ OrderedCollection new.
	(suffix = 'bmp') | (suffix = 'gif') | (suffix = 'jpg') | (suffix = 'form') | (suffix = '*') ifTrue:
		[labels addAll: #('open image in a window' 'read image into ImageImports').
		selectors addAll: #(openImageInWindow importImage)].
	(suffix = 'morph') | (suffix = 'morphs') | (suffix = '*') ifTrue:
		[labels add: 'load as morph'.
		selectors add: #openMorphFromFile].
	(suffix = 'mid') | (suffix = '*') ifTrue:
		[labels add: 'play midi file'.
		selectors add: #playMidiFile].
	(suffix = 'movie') | (suffix = '*') ifTrue:
		[labels add: 'open as movie'.
		selectors add: #openAsMovie].
	(suffix = 'st') | (suffix = 'cs') | (suffix = '*') ifTrue:
		[suffix = '*' ifTrue: [lines add: labels size].
		labels addAll: #('fileIn' 'file into new change set' 'browse changes' 'broadcast as update').
		lines add: labels size - 1.
		selectors addAll: #(fileInSelection fileIntoNewChangeSet browseChanges putUpdate)].
	(suffix = 'swf') | (suffix = '*') ifTrue:[
		labels add:'open as Flash'.
		selectors add: #openAsFlash].
	(suffix = 'ttf') | (suffix = '*') ifTrue:[
		labels add: 'open true type font'.
		selectors add: #openAsTTF].
	(suffix = '*') ifTrue:
		[labels addAll: #('generate HTML').
		lines add: labels size - 1.
		selectors addAll: #(renderFile)].
	^ Array with: labels with: lines with: selectors! !


!Interpreter class methodsFor: 'translation' stamp: 'ar 11/15/1998 23:56'!
translate: fileName doInlining: inlineFlag
	"Time millisecondsToRun: [
		Interpreter translate: 'interp.c' doInlining: true.
		Smalltalk beep]"
	| cg |
	BitBltSimulation initialize.
	Interpreter initialize.
	ObjectMemory initialize.
	cg _ CCodeGenerator new initialize.
	cg addClass: BitBltSimulation.
	cg addClass: Interpreter.
	cg addClass: ObjectMemory.
	BitBltSimulation declareCVarsIn: cg.
	Interpreter declareCVarsIn: cg.
	ObjectMemory declareCVarsIn: cg.
	{FFTPlugin. FloatArrayPlugin. Matrix2x3Plugin. 
	BalloonEngineBase. BalloonEnginePlugin} do:[:plugin|
		plugin initialize.
		cg addClass:plugin.
		plugin declareCVarsIn: cg].
	cg storeCodeOnFile: fileName doInlining: inlineFlag.! !


