'From Squeak3.1alpha of 28 February 2001 [latest update: #4168] on 25 June 2001 at 10:18 am'!
"Change Set:		scamperCeleste-sw
Date:			25 June 2001
Author:			Scott Wallace

Put a Scamper web browser and a Celeste email tool into the tools flap.  This became possible thanks to Lex Spoon's recent scamperStart and dbLessCeleste updates that allow Scamper to start up with a default local url and Celeste to survive even if there is no mail data base yet established."!


!Celeste class methodsFor: 'common build' stamp: 'sw 6/25/2001 10:16'!
newOpenableMorph
	"Answer window for a MailReader on a blank database."

	^ (self buildTopMorphicWindowTitled: self defaultWindowTitle model: (self onDatabase: nil)) applyModelExtent! !


!Flaps class methodsFor: 'predefined flaps' stamp: 'sw 6/25/2001 10:14'!
newToolsFlap
	"Answer a newly-created flap which adheres to the right edge of the screen and which holds prototypes of standard tools."

	|  aFlapTab aStrip |
	aStrip _ PartsBin newPartsBinWithOrientation: #topToBottom from:	#(
	(Browser 				prototypicalToolWindow		'Browser'			'A Browser is a tool that allows you to view all the code of all the classes in the system')
	(Transcript				openAsMorph				'Transcript'			'A Transcript is a window usable for logging and debugging; browse references to #Transcript for examples of how to write to it.')
	(Workspace				prototypicalToolWindow		'Workspace'			'A Work is a simple window for editing text.  You can later save the contents to a file if you desire.')
	(FileList					prototypicalToolWindow		'File List'			'A File List is a tool for browsing folders and files on disks and on ftp types.')
	(DualChangeSorter		prototypicalToolWindow		'Change Sorter'		'Shows two change sets side by side')
	(SelectorBrowser			prototypicalToolWindow		'Method Finder'		'A Method Finder is a tool for finding methods by name')
	(Preferences			preferencesControlPanel	'Preferences'			'Allows you to control numerous options')
	(Utilities				recentSubmissionsWindow	'Recent'				'A message browser that tracks the most recently-submitted methods')
	(ProcessBrowser			prototypicalToolWindow		'Processes'			'A Process Browser shows you all the running processes')
	(Preferences			annotationEditingWindow	'Annotations'		'Allows you to specify the annotations to be shown in the annotation panes of browsers, etc.')
	(Scamper				newOpenableMorph				'Scamper'			'A web browser')
	(Celeste					newOpenableMorph				'Celeste'				'Celeste -- an EMail reader')
	(PackagePaneBrowser	prototypicalToolWindow		'Packages'			'Package Browser:  like a System Browser, except that if has extra level of categorization in the top-left pane, such that class-categories are further organized into groups called "packages"')
	(ChangeSorter			prototypicalToolWindow		'Change Set'			'A tool that allows you to view and manipulate all the code changes in a single change set')

).

"	(Project					newMorphic					'Project'				'Creates a new project')"
 

	aFlapTab _ FlapTab new referent: aStrip beSticky.
	aFlapTab setNameTo: 'Tools'.
	aFlapTab assumeString: 'Tools' font: Preferences standardFlapFont orientation: #vertical color: Color orange lighter.
	aFlapTab edgeToAdhereTo: #right; inboard: false.
	aFlapTab setToPopOutOnDragOver: true.
	aFlapTab setToPopOutOnMouseOver: false.

	aStrip extent: (90 @ self currentWorld height).

	aFlapTab position: (self currentWorld width - aFlapTab width) @ ((Display height - aFlapTab height) // 2).
	aStrip beFlap: true.
	aStrip color: (Color orange muchLighter alpha: 0.8).
	aStrip vResizing: #spaceFill.
	
	^ aFlapTab

	"Flaps replaceToolsFlap"
! !


!Scamper class methodsFor: 'instance creation' stamp: 'sw 6/21/2001 17:54'!
newInstancePointingAt: aStringOrUrl
	"Answer a Scamper browser on specified url.
		Scamper newInstancePointingAt: 'www.squeak.org'
		Scamper newInstancePointingAt: 'file://C%3A/test.htm'
	"

	^ (self new
		jumpToUrl: aStringOrUrl asUrl) morphicWindow applyModelExtent! !

!Scamper class methodsFor: 'instance creation' stamp: 'sw 6/21/2001 17:52'!
newOpenableMorph
	"Answer a morph that bears the receiver, but don't blast it onto the screen"

	^ self newInstancePointingAt: StartUrl! !

"Postscript:"
Flaps replaceToolsFlap.!

