'From Squeak3.1alpha of 28 February 2001 [latest update: #4171] on 25 June 2001 at 1:35:29 pm'!
"Change Set:		magnified-sw
Date:			25 June 2001
Author:			Scott Wallace

Fixes a condition once seen in MagnifierMorph initialization, which could halt the creation of a 'Widgets' flap.
Makes Magnifiers launched from the Widgets flap be named 'Magnifier' rather than 'Screening'"!


!MagnifierMorph methodsFor: 'magnifying' stamp: 'sw 6/25/2001 11:43'!
magnifiedForm
	"Answer the magnified form"

	| srcRect form exclusion |
	lastPos _ self sourcePoint.
	srcRect _ self sourceRectFrom: lastPos.
	((srcRect intersects: self bounds) and: [RecursionLock == nil])
		ifTrue: [RecursionLock _ self.
				self isRound
					ifTrue: [exclusion _ owner]
					ifFalse: [exclusion _ self].
				form _ self currentWorld patchAt: srcRect without: exclusion andNothingAbove: false.
				RecursionLock _ nil]
		ifFalse: ["cheaper method if the source is not occluded"
				form _ Display copy: srcRect].
	"smooth if non-integer scale"
	^ form magnify: form boundingBox
		by: magnification
		smoothing: (magnification isInteger ifTrue: [1] ifFalse: [2])! !


!MagnifierMorph class methodsFor: 'instance creation' stamp: 'sw 6/25/2001 13:33'!
newRound
	"Answer a round Magnifier"

	| aMagnifier sm |
	aMagnifier _ self new.
	sm _ ScreeningMorph new position: aMagnifier position.
	sm addMorph: aMagnifier.
	sm addMorph: (EllipseMorph newBounds: aMagnifier bounds).
	sm setNameTo: 'Magnifier'.
	^ sm! !

