'From Squeak3.1alpha of 28 February 2001 [latest update: #4270] on 21 August 2001 at 10:52:36 pm'!
"Change Set:		RoundedCornerColors-ar
Date:			21 August 2001
Author:			Andreas Raab

Fixes a slight annoyance with rounded corners and inset borders. Also hands the query for the colors of the corners back to morph and simplifies corner rounder a bit."!


!CornerRounder methodsFor: 'all' stamp: 'ar 8/21/2001 22:45'!
tweakCornersOf: aMorph on: aCanvas borderWidth: w corners: cornerList
	"This variant has a cornerList argument, to allow some corners to be rounded and others not"
	| offset corner saveBits fourColors mask outBits shadowColor |
	shadowColor _ aCanvas shadowColor.
	aCanvas shadowColor: nil. "for tweaking it's essential"
	w > 0 ifTrue:[
			fourColors _ shadowColor 
				ifNil:[aMorph colorsAtCorners]
				ifNotNil:[Array new: 4 withAll: shadowColor]].
	mask _ Form extent: cornerMasks first extent depth: aCanvas depth.
	1 to: 4 do:[:i | 
		(cornerList includes: i) ifTrue:
			[corner _ aMorph bounds corners at: i.
			saveBits _ underBits at: i.
			i = 1 ifTrue: [offset _ 0@0].
			i = 2 ifTrue: [offset _ 0@saveBits height negated].
			i = 3 ifTrue: [offset _ saveBits extent negated].
			i = 4 ifTrue: [offset _ saveBits width negated@0].

			"Mask out corner area (painting saveBits won't clear if transparent)."
			mask copyBits: mask boundingBox from: (cornerMasks at: i) at: 0@0 clippingBox: mask boundingBox rule: Form over fillColor: nil map: (Bitmap with: 0 with: 16rFFFFFFFF).
			outBits _ aCanvas contentsOfArea: (corner + offset extent: mask extent).
			mask displayOn: outBits at: 0@0 rule: Form and.
			"Paint back corner bits."
			saveBits displayOn: outBits at: 0@0 rule: Form paint.
			"Paint back corner bits."
			aCanvas drawImage: outBits at: corner + offset.

			w > 0 ifTrue:
				["Paint over with border if any"
				aCanvas stencil: (cornerOverlays at: i) at: corner + offset
						color: (fourColors at: i)]]].
	aCanvas shadowColor: shadowColor. "restore shadow color"
! !


!Morph methodsFor: 'visual properties' stamp: 'ar 8/21/2001 22:44'!
colorsAtCorners
	"Return the colors to draw for a morph its corners are rounded"
	| c c14 c23 |
	c _ self borderColor.
	c == #raised ifTrue:[
		c _ self raisedColor.
		c14 _ c lighter. c23 _ c darker.
		^Array with: c14 with: c23 with: c23 with: c14].
	(c == #inset and: [owner notNil]) ifTrue:[
		c _ owner colorForInsets.
		c14 _ c lighter. c23 _ c darker.
		^Array with: c23 with: c14 with: c14 with: c23].
	^Array new: 4 withAll: c! !

