'From Squeak3.1alpha of 28 February 2001 [latest update: #4278] on 26 August 2001 at 5:04:24 pm'!
"Change Set:		StackInstVar-tk
Date:			26 August 2001
Author:			Ted Kaehler

When an object in a Stack such as a field is made to store separate data for each card, it left the field in Undeclared.  The inst var in the CardPlayer was created, so the Undeclared variable is just an annoyance.  This fix declared the inst var without putting the name unto Undeclared."!


!CardPlayer class methodsFor: 'user-defined inst vars' stamp: 'tk 8/26/2001 16:58'!
setNewInstVarNames: listOfStrings
	"Make listOfStrings be the new list of instance variable names for the receiver"

	| disappearing firstAppearing instVarString instVarList |
	instVarList _ self instVarNames asOrderedCollection.
	disappearing _ instVarList copy.
	disappearing removeAllFoundIn: listOfStrings.
	disappearing do:
		[:oldName | 	self removeAccessorsFor: oldName].
	firstAppearing _ listOfStrings copy.
	firstAppearing removeAllFoundIn: instVarList.
	instVarString _ String streamContents:
		[:aStream | listOfStrings do: [:aString | aStream nextPutAll: aString; nextPut: $ ]].

	superclass subclass: self name instanceVariableNames: instVarString 
		classVariableNames: '' poolDictionaries: '' category: self categoryForUniclasses.
	firstAppearing do:
		[:newName | self compileAccessorsFor: newName].
! !

