'From Squeak3.1alpha of 28 February 2001 [latest update: #4348] on 27 September 2001 at 4:02:32 pm'!
"Change Set:		propertyDefault-sw
Date:			27 September 2001
Author:			Scott Wallace

Adds Morph.valueOfProperty:default: which obtains the value of a property, and if it is found that the property does not exist, it creates one and gives it the value determined by evaluated the default-block argument.  This brings a convenient style already long in use for system parameters and project parameters to the general handling of morph properties"!


!Morph methodsFor: 'access properties' stamp: 'sw 9/25/2001 10:22'!
valueOfProperty: propName default: aBlock
	"If the receiver possesses a property of the given name, answer its value.  If not, then create a property of the given name, give it the value obtained by evaluating aBlock, then answer that value"

	self assureExtension.
	^ extension valueOfProperty: propName default: aBlock! !


!MorphExtension methodsFor: 'other properties' stamp: 'sw 9/25/2001 10:21'!
valueOfProperty: propName default: aBlock
	"If the receiver possesses a property of the given name, answer its value.  If not, then create a property of the given name, give it the value obtained by evaluating aBlock, then answer that value"

	| val |
	otherProperties == nil ifTrue: [otherProperties _ IdentityDictionary new].
	^ otherProperties at: propName ifAbsent:
		[self setProperty: propName toValue: (val _ aBlock value).
		val]! !

