'From Squeak3.2alpha of 2 October 2001 [latest update: #4442] on 20 October 2001 at 5:23:03 pm'!
"Change Set:		newMorph-sw
Date:			20 October 2001
Author:			Scott Wallace

Restores the 'from alphabetical list...' option to the non-classic variant of the 'new morph' menu.
Provides info such that the ScorePlayer appears in the Objects tool."!


!ScorePlayerMorph class methodsFor: 'as yet unclassified' stamp: 'sw 10/20/2001 17:17'!
descriptionForPartsBin
	^ self partName: 	'ScorePlayer'
		categories:		#('Multimedia')
		documentation:	' Mediates between a score such as a MIDIScore, a PianoRollScoreMorph, and the actual SoundPlayer synthesizer'! !


!TheWorldMenu methodsFor: 'construction' stamp: 'sw 10/20/2001 17:13'!
newMorph
	"The user requested 'new morph' from the world menu.  Put up a menu that allows many ways of obtaining new morphs.  If the preference #classicNewMorphMenu is true, the full form of yore is used; otherwise, a much shortened form is used."

	| menu subMenu catDict shortCat class |

	menu _ self menu: 'Add a new morph'.
	menu 
		add: 'from paste buffer' target: myHand action: #pasteMorph;
		add: 'from alphabetical list' subMenu: self alphabeticalMorphMenu;
		add: 'from a file...' target: self action: #readMorphFromAFile.
	menu addLine.
	menu add: 'grab rectangle from screen' target: myWorld action: #grabDrawingFromScreen:;
		add: 'grab with lasso from screen' target: myWorld action: #grabLassoFromScreen:;
		add: 'grab rubber band from screen' target: myWorld action: #grabRubberBandFromScreen:;
		add: 'grab flood area from screen' target: myWorld action: #grabFloodFromScreen:.
	menu addLine.
	menu add: 'make new drawing' target: myWorld action: #newDrawingFromMenu:;
		add: 'make link to project...' target: self action: #projectThumbnail.

	Preferences classicNewMorphMenu ifTrue:
		[menu addLine.

		catDict _ Dictionary new.
		SystemOrganization categories do:
			[:cat |
			((cat beginsWith: 'Morphic-')
					and: [(#('Morphic-Menus' 'Morphic-Support') includes: cat) not])
			ifTrue:
				[shortCat _ cat copyFrom: 'Morphic-' size+1 to: cat size.
				(SystemOrganization listAtCategoryNamed: cat) do:
					[:cName | class _ Smalltalk at: cName.
					((class inheritsFrom: Morph)
						and: [class includeInNewMorphMenu])
						ifTrue:
						[(catDict includesKey: shortCat) 
						ifTrue: [(catDict at: shortCat) addLast: class]
						ifFalse: [catDict at: shortCat put: (OrderedCollection with: class)]]]]].

		catDict keys asSortedCollection do:
			[:categ |
			subMenu _ MenuMorph new.
			((catDict at: categ) asSortedCollection: [:c1 :c2 | c1 name < c2 name]) do:
				[:cl | subMenu add: cl name
						target: self
						selector: #newMorphOfClass:event:
						argument: cl].
			menu add: categ subMenu: subMenu]].

	self doPopUp: menu.
! !

