'From Squeak3.2alpha of 3 October 2001 [latest update: #4451] on 29 October 2001 at 5:52:16 am'!
"Change Set:		keepTextFont-nk
Date:			20 October 2001
Author:			Ned Konz

When you use TextMorphs from the EToy system and you change their contents using the characters or numericValue slots, font changes get lost. This change set makes it so that if a TextMorph is all the same font, that font is used when the contents change, thereby keeping the appearance of the TextMorph uniform.

To use this, just select the entire Text of a TextMorph and apply font color, emphasis, or size changes as desired to the whole text.

Then you can change the characters or numericValue slots from EToys without changing the TextMorph's appearance."!


!TextMorph methodsFor: 'accessing' stamp: 'nk 10/20/2001 10:04'!
newContents: stringOrText 
	"Accept new text contents."
	| newText embeddedMorphs |
	"If my text is all the same font, use the font for my new contents"
	newText _ stringOrText isString ifTrue: [ | textSize |
		(text notNil
		  and: [ (textSize _ text size) > 0
		    and: [ (text runLengthFor: 1) = textSize ]]) ifTrue: [ | attribs |
			attribs _ text attributesAt: 1 forStyle: textStyle.
			Text string: stringOrText copy attributes: attribs.
		]
		ifFalse: [ Text fromString: stringOrText copy ]
	]
	ifFalse: [ stringOrText copy asText.	"should be veryDeepCopy?" ].

	text = newText ifTrue: [^ self].	"No substantive change"
	text ifNotNil: [(embeddedMorphs _ text embeddedMorphs)
			ifNotNil: 
				[self removeAllMorphsIn: embeddedMorphs.
				embeddedMorphs do: [:m | m delete]]].

	text _ newText.

	"add all morphs off the visible region; they'll be moved into the right 
	place when they become visible. (this can make the scrollable area too 
	large, though)"
	newText embeddedMorphs do: 
		[:m | 
		self addMorph: m.
		m position: -1000 @ 0].
	self releaseParagraph.
	"update the paragraph cache"
	self paragraph.
	"re-instantiate to set bounds"
	self world ifNotNil: [self world startSteppingSubmorphsOf: self]! !

