'From Squeak3.2alpha of 3 October 2001 [latest update: #4569] on 1 December 2001 at 4:53:58 pm'!
"Change Set:		activeListPane-sw
Date:			1 December 2001
Author:			Scott Wallace

Experimental!!  Puts up mild border feedback when a pluggable-list-morph has the keyboard focus.  The color used is the same as the text-highlight color; this establishes a modicum of consistency: when a *text* pane of a window has the keyboard focus, the feedback is the text-highlighting in that same text-highlight color.  This is an experimental add-on to Dan's lazyKeyboardFocus experiment, attempting to work around the problem that whenever the keyboard focus lazily remained in a list pane after the mouse left the pane, there was no user feedback designating which list pane would receive keystrokes -- sometimes a serious problem because the same command-key can mean radically different things depending on which pane gets the command."!


!PluggableListMorph methodsFor: 'drawing' stamp: 'sw 12/1/2001 16:40'!
drawOn: aCanvas
	"Draw the list on the canvas, and possibly also draw frame feedback"

	| colorToFillWith areaToFill next |

	super drawOn: aCanvas.
	self hasFocus ifTrue:
		[aCanvas frameRectangle: scroller bounds color: Preferences textHighlightColor].

	selectedMorph ifNil: [^self].
	colorToFillWith _ color.
	next _ self.
	[colorToFillWith isTransparent and: [(next _ next owner) notNil]] whileTrue: [
		colorToFillWith _ next color.
	].
	colorToFillWith _ colorToFillWith luminance < 0.5 ifTrue: [
		colorToFillWith muchLighter
	] ifFalse: [
		colorToFillWith darker
	].

	areaToFill _ ((scroller transformFrom: self) localBoundsToGlobal: selectedMorph bounds)
					intersect: scroller bounds.
	aCanvas fillRectangle: areaToFill color: colorToFillWith! !

!PluggableListMorph methodsFor: 'events' stamp: 'sw 12/1/2001 16:53'!
keyboardFocusChange: aBoolean
	"The message is sent to a morph when its keyboard focus change. The given argument indicates that the receiver is gaining (versus losing) the keyboard focus"

	self changed "to redraw border feedback"! !

