'From Squeak3.2gamma of 15 January 2002 [latest update: #4653] on 21 January 2002 at 11:15:59 pm'!
"Change Set:		AssureExistanceOfPath
Date:			21 January 2002
Author:			Chris Muller

A one-method fix to FileDirectory>>assureExistanceOfPath:, which did not previously account for platform-specific differences in case-sensitivity, causing it to take a path of logic that quickly leads to a primitive failure on Win32 machine (attempting to create a directory that already exists).  (Note: the spelling of these methods should be corrected to 'existence' after 3.2 is released. -dew)"
!


!FileDirectory methodsFor: 'file directory' stamp: 'cmm 1/21/2002 23:11'!
assureExistanceOfPath: localPath
	"Make sure the local directory exists. If necessary, create all parts inbetween"
	(self directoryExists: localPath) ifTrue:[^self]. "exists"
	"otherwise check parent first and then create local dir"
	self containingDirectory assureExistanceOfPath: self localName.
	self createDirectory: localPath.! !

nil!

