'From Squeak 2.3 beta of Nov 25, 1998 on 15 December 1998 at 11:00:16 pm'!
"Change Set:		EnableStoreIvarsPrim
Date:			15 December 1998
Author:			Dan Ingalls

This changeSet enables the compilation of quickMethods for storing instance variables, and converts all existing methods to this representation.
"!


!MethodNode methodsFor: 'code generation' stamp: 'di 12/15/1998 22:57'!
generate: trailer 
	"The receiver is the root of a parse tree. Answer a CompiledMethod. The 
	argument, trailer, is the references to the source code that is stored with 
	every CompiledMethod."
	| blkSize nLits stack strm nArgs offsets quickMethod |
	self generateIfQuick: 
		[:method | 
		1 to: trailer size do: [:i | method at: method size - trailer size + i put: (trailer at: i)].
		method cacheTempNames: self tempNames.
		^method].
	nArgs _ arguments size.
	blkSize _ block sizeForEvaluatedValue: encoder.
	encoder maxTemp > 31
		ifTrue: [^self error: 'Too many temporary variables'].	
	literals _ encoder allLiterals.
	(nLits _ literals size) > 255
		ifTrue: [^self error: 'Too many literals referenced'].
	method _ CompiledMethod	"Dummy to allocate right size"
				newBytes: blkSize
				nArgs: nArgs
				nTemps: encoder maxTemp
				nStack: 0
				nLits: nLits
				primitive: primitive.
	strm _ ReadWriteStream with: method.
	strm position: method initialPC - 1.
	stack _ ParseStack new init.
	block emitForEvaluatedValue: stack on: strm.
	stack position ~= 1 ifTrue: [^self error: 'Compiler stack discrepancy'].
	strm position ~= (method size - trailer size) 
		ifTrue: [^self error: 'Compiler code size discrepancy'].
	method needsFrameSize: stack size.
	1 to: nLits do: [:lit | method literalAt: lit put: (literals at: lit)].
	1 to: trailer size do: [:i | method at: method size - trailer size + i put: (trailer at: i)].
	nLits = 0 ifTrue:
		["Check for quick store instfields case"
		(offsets _ method storeOffsets) size > 0 ifTrue:
			[quickMethod _ CompiledMethod toStoreInstVars: offsets.
			quickMethod setSourcePointer: method sourcePointer.
			method _ quickMethod]].
	method cacheTempNames: self tempNames.
	^ method! !



