'From Squeak3.3alpha of 18 January 2002 [latest update: #4981] on 3 October 2002 at 9:22:57 pm'!
"Change Set:		menuTileRefix-sw
Date:			3 October 2002
Author:			Scott Wallace

Fixes for several bugs in MenuTile behavior:
 Quick click on an up/down arrow now has the desired effect.
 Bad correlation between item seen and item chosen after a submenu marker is fixed.
 Window-names and morph-names from the 'embed into' submenu no longer show up in the menu-choices pop-up.
 Click on menu wording on tile no longer makes text selection, but rather presents the popup."!


!MenuItemMorph methodsFor: 'accessing' stamp: 'sw 10/3/2002 20:50'!
allWordingsNotInSubMenus: verbotenSubmenuContentsList
	"Answer a collection of the wordings of all items and subitems, but omit the stay-up item, and also any items in any submenu whose tag is in verbotenSubmenuContentsList"

	self isStayUpItem ifTrue:[^ #()].
	subMenu ifNotNil:
		[^ (verbotenSubmenuContentsList includes: self contents asString)
			ifTrue:
				[#()]
			ifFalse:
				[subMenu allWordingsNotInSubMenus: verbotenSubmenuContentsList]].

	^ Array with: self contents asString! !


!MenuMorph methodsFor: 'accessing' stamp: 'sw 10/3/2002 20:34'!
allWordings
	"Answer a collection of the wordings of all items and subitems, omitting the window-list in the embed... branch and (unless a certain hard-coded preference is set) also omitting items from the debug menu"

	| verboten |
	verboten _ OrderedCollection with: 'embed into'.
	Preferences debugMenuItemsInvokableFromScripts 
		ifFalse:	[verboten add: 'debug...'].
	^ self allWordingsNotInSubMenus: verboten! !

!MenuMorph methodsFor: 'accessing' stamp: 'sw 10/3/2002 20:11'!
allWordingsNotInSubMenus: verbotenSubmenuContentsList
	"Answer a collection of the wordings of all items and subitems, but omit the stay-up item, and also any items in any submenu whose tag is in verbotenSubmenuContents"

	| aList |
	aList _ OrderedCollection new.
	self items do: [:anItem | aList addAll: (anItem allWordingsNotInSubMenus: verbotenSubmenuContentsList)].
	^ aList! !


!MenuTile methodsFor: 'initialization' stamp: 'sw 10/3/2002 02:16'!
initialize
	"Initialize the menu tile"

	super initialize.
	self addArrows; setLiteral: 'send to back'.
	self labelMorph useStringFormat; putSelector: nil! !

!MenuTile methodsFor: 'mouse' stamp: 'sw 10/3/2002 21:16'!
mouseDown: evt
	| aPoint aMenu reply |
	aPoint _ evt cursorPoint.
	nArrowTicks _ 0.
	((upArrow bounds containsPoint: aPoint) or: [downArrow bounds containsPoint: aPoint]) ifTrue: [^ self mouseStillDown: evt].
	aMenu _ SelectionMenu selections: (((self ownerThatIsA: PhraseTileMorph) associatedPlayer costume allMenuWordings) copyWithout: '').
	reply _ aMenu startUp.
	reply ifNotNil: [self literal: reply; layoutChanged]! !

MenuMorph removeSelector: #allWordingsNotInSubMenu:!
MenuItemMorph removeSelector: #allWordingsNotInSubMenu:!
