'From Squeak 2.3 beta of Nov 25, 1998 on 30 December 1998 at 2:52:41 pm'!

!FlashPlayerMorph methodsFor: 'initialize' stamp: 'ar 12/30/1998 14:47'!
makeControls

	| b r loopSwitch |
	b _ SimpleButtonMorph new
		target: self;
		borderColor: #raised;
		borderWidth: 2.
	r _ AlignmentMorph newRow.
	r hResizing: #shrinkWrap; vResizing: #shrinkWrap; extent: 5@5.
	r addMorphBack: (b fullCopy label: 'Rewind';		actionSelector: #rewind).
	r addMorphBack: (b fullCopy label: 'Play';			actionSelector: #startPlaying).
	r addMorphBack: (b fullCopy label: 'Pause';			actionSelector: #stopPlaying).
	r addMorphBack: (b fullCopy label: 'Next';			actionSelector: #stepForward).
	r addMorphBack: (b fullCopy label: 'Prev';			actionSelector: #stepBackward).
	loopSwitch _ SimpleSwitchMorph new
		borderWidth: 2;
		label: 'Loop';
		actionSelector: #loopFrames:;
		target: self;
		setSwitchState: self loopFrames.
	r addMorphBack: loopSwitch.
	loopSwitch _ SimpleSwitchMorph new
		borderWidth: 2;
		label: 'Defer';
		actionSelector: #toggleDeferred;
		target: self;
		setSwitchState: self deferred.
	r addMorphBack: loopSwitch.
	r addMorphBack: (b fullCopy label: 'Fastest'; 	actionSelector: #drawFastest).
	r addMorphBack: (b fullCopy label: 'Medium';	actionSelector: #drawMedium).
	r addMorphBack: (b fullCopy label: 'Nicest';		actionSelector: #drawNicest).
	r addMorphBack: (b fullCopy label: '+10';		actionSelector: #jump10).
	b target: self.
	^ self world activeHand attachMorph: r! !

!FlashPlayerMorph methodsFor: 'stepping' stamp: 'ar 12/30/1998 14:46'!
stepToFrame: frame
	| fullRect postDamage |
	frame = frameNumber ifTrue:[^self].
	frame > loadedFrames ifTrue:[^self].
	postDamage _ damageRecorder isNil.
	postDamage ifTrue:[damageRecorder _ FlashDamageRecorder new].
	frame = (frameNumber+1) ifTrue:[
		self stepToFrameForward: frame.
	] ifFalse:[
		activeMorphs _ activeMorphs select:[:any| false].
		submorphs do:[:m|
			(m isFlashMorph and:[m isFlashCharacter]) ifTrue:[
				m stepToFrame: frame.
				m visible ifTrue:[activeMorphs add: m].
			]].
	].
	frameNumber _ frame.
	(sounds at: frame ifAbsent:[#()]) do:[:sound| sound ifNotNil:[sound play]].
	self executeActionsAt: frame.
	(postDamage and:[owner notNil]) ifTrue:[
		damageRecorder updateIsNeeded ifTrue:[
			fullRect _ damageRecorder fullDamageRect: self localBounds.
			fullRect _ (self transform localBoundsToGlobal: fullRect).
			owner invalidRect: (fullRect insetBy: -1).
		].
	].
	postDamage ifTrue:[damageRecorder _ nil].! !

!FlashPlayerMorph methodsFor: 'menu' stamp: 'ar 12/30/1998 14:33'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'make controls' action: #makeControls.
	"aCustomMenu add:'Toggle deferring' action: #toggleDeferred."
	"aCustomMenu addLine.
	aCustomMenu add: 'make controls' action: #makeControls.
	aCustomMenu addLine.
	aCustomMenu add: 'Low Quality' action: #drawFastest.
	aCustomMenu add: 'Med Quality' action: #drawMedium.
	aCustomMenu add: 'High Quality' action: #drawNicest."
	"aCustomMenu add: 'make slider' action: #makeSlider."
	aCustomMenu addLine.! !

!FlashPlayerMorph methodsFor: 'menu' stamp: 'ar 12/30/1998 14:44'!
drawFastest
	self defaultAALevel: 1.
	self changed.! !

!FlashPlayerMorph methodsFor: 'menu' stamp: 'ar 12/30/1998 14:44'!
drawMedium
	self defaultAALevel: 2.
	self changed.! !

!FlashPlayerMorph methodsFor: 'menu' stamp: 'ar 12/30/1998 14:44'!
drawNicest
	self defaultAALevel: 4.
	self changed.! !


