'From Squeak 2.3 beta of Nov 25, 1998 on 13 January 1999 at 11:17:17 pm'!
"Change Set:		viewerButtonBorders-sw
Date:			13 January 1999
Author:			Scott Wallace

Fixes a problem that crept into Viewers with the changeover from transparency to translucency -- the problem was that the + button at the top of viewers and the  (detail) buttons at left of viewers developed borders around them, where formerly they had none.  This update eliminates that phenomenon."!


!StandardViewer methodsFor: 'all' stamp: 'sw 1/13/1999 23:15'!
addHeaderMorph
	| header aFont aButton aTextMorph nail wrpr costs |
	header _ AlignmentMorph newRow color: self color; centering: #center.
	aFont _ ScriptingSystem fontForScriptorButtons.
	header addMorph: (aButton _ SimpleButtonMorph new label: 'X' font: aFont).
	aButton target: self;
			color:  Color lightRed;
			actionSelector: #dismiss;
			setBalloonText: 'Delete'.
	header addTransparentSpacerOfSize: 4@1.

	header addMorphBack: (aButton _ SimpleButtonMorph new label: '+' font: aFont).
	aButton target: self; beTransparent; borderWidth: 0;
			actionSelector: #addCategoryViewer;
			setBalloonText: 'click here to add
another viewer'.
	header addTransparentSpacerOfSize: 4@1.

	(((costs _ scriptedPlayer costumes) size > 1) or: [costs size == 1 and: [costs first ~~ scriptedPlayer costume]]) ifTrue:
		[header addUpDownArrowsFor: self.
		(wrpr _ header submorphs last) submorphs second setBalloonText: 'switch to previous costume'.	
		wrpr submorphs first  setBalloonText: 'switch to next costume'].	

	nail _ ThumbnailMorph new objectToView: scriptedPlayer viewSelector: #costume.
	nail on: #mouseDown send: #thumbnailMenuEvt:forMorph: to: scriptedPlayer.
	header addMorphBack: nail.
	nail setBalloonText: 'click here to get a menu
to specify new costume,
tear off a tile, etc..'.	

	header addTransparentSpacerOfSize: 5@5.

"	aButton _ SimpleButtonMorph new target: self; actionSelector: #newEmptyScript; label: 'S' font: (aFont _ StrikeFont familyName: #ComicBold size: 16);  color: Color transparent; borderWidth: 0; actWhen: #buttonDown.
	aButton setBalloonText: 'drag from here to
create a new script
for this object'.	
	header addMorphBack: aButton.
	header addTransparentSpacerOfSize: 8@5.

	aButton _ SimpleButtonMorph new target: scriptedPlayer; actionSelector: #addInstanceVariable; label: 'I' font: aFont;  color: Color transparent; borderWidth: 0; actWhen: #buttonUp.
	aButton setBalloonText: 'click here to add
an instance variable
to this object.'.
	header addMorphBack: aButton.

	header addTransparentSpacerOfSize: 5@5."

	scriptedPlayer assureExternalName.
	aTextMorph _ UpdatingStringMorph new
		useStringFormat;
		target:  scriptedPlayer;
		getSelector: #getName;
		putSelector: #setName:;
		setNameTo: 'name';
		font: ScriptingSystem fontForNameEditingInScriptor.
	aTextMorph setProperty: #okToTextEdit toValue: true.
	aTextMorph step.
	header  addMorphBack: aTextMorph.
	aTextMorph setBalloonText: 'Click here to edit the player''s name
use backspace to delete unwanted characters'.	

	header beSticky.
	self addMorph: header! !


!ViewerRow methodsFor: 'all' stamp: 'sw 1/13/1999 23:11'!
addDetailButton
	| aButton |
	aButton _ SimpleButtonMorph new
		target: self;
		actionSelector: #detail;
		beTransparent;
		borderWidth: 0;
		setBalloonText: 'detail';
		label: ''.
	self addMorphFront: aButton! !


