'From Squeak 2.3 of January 14, 1999 on 15 January 1999 at 5:53:14 pm'!
"Change Set:		SystemStartupList
Date:			15 January 1999
Author:			Andreas Raab

Adds two globals:
	SystemStartupList - an OrderedCollection of classes that want to receive a #startUp message on system startup.
	SystemShutdownList - an OrderedCollection of classes that want to receiver #shutDown on system shutdown.

The lists are processed in order so one can assure the startUp of a dependent class by adding it before or after this class."

Smalltalk at:#SystemShutdownList put: OrderedCollection new.
Smalltalk at:#SystemStartupList put: OrderedCollection new.!


!SystemDictionary methodsFor: 'snapshot and quit' stamp: 'ar 1/15/1999 17:19'!
processShutDownList
	"Call the shutDown method on each object that needs to gracefully shut itself down before a snapshot."

	Smalltalk at: #MailDB ifPresent: [:mailDB |
		mailDB allInstancesDo: [:db | db saveDB]].  "snapshot all mail databases to disk"
	Smalltalk at: #PWS ifPresent: [:pws | pws stopServer].
	Smalltalk at: #Password ifPresent: [:password | password shutDown].
	Smalltalk at: #HttpUrl ifPresent: [:urlClass | urlClass shutDown].
	self shutDownSound.
	SystemShutdownList do:[:class| class shutDown].
	Delay shutDown.
	Smalltalk shutDown.
	Color shutDown.
	StrikeFont shutDown.
	Smalltalk isMorphic ifFalse: [ControlManager shutDown].
	Form shutDown.
	DisplayScreen shutDown.
! !

!SystemDictionary methodsFor: 'snapshot and quit' stamp: 'ar 1/15/1999 17:18'!
processStartUpList
	"Call the startUp method on each object that needs to gracefully restart itself after a snapshot."

	DisplayScreen startUp.
	FileDirectory startUp.
	CrLfFileStream startUp.
	Cursor startUp.
	Smalltalk installLowSpaceWatcher.
	InputSensor startUp.
	ProcessorScheduler startUp.
	Delay startUp.
	Smalltalk startUp.
	"Process the global startup list"
	SystemStartupList do:[:class| class startUp].
	Smalltalk isMorphic
		ifTrue: [World fullRepaintNeeded]
		ifFalse: [ControlManager startUp].
! !


