'From Squeak 2.3 of January 14, 1999 on 1 February 1999 at 10:38:15 am'!
"Change Set:		PolygonDrawFix
Date:			1 February 1999
Author:			Leandro Caniglia

Fixes Polygon drawOn: so to take into account that borderColor could be #raised or #inset.
"!


!PolygonMorph methodsFor: 'drawing' stamp: 'LC 1/28/1999 22:38'!
drawOn: aCanvas 
	"Display the receiver, a spline curve, approximated by straight line  
	segments."
	| lineColor bevel topLeftColor bottomRightColor bigClipRect brush p1i p2i |
	vertices size < 1 ifTrue: [self error: 'a polygon must have at least one point'].
	closed & color isTransparent not
		ifTrue: [aCanvas
				stencil: self filledForm
				at: bounds topLeft - 1
				color: color].
	lineColor _ borderColor.
	bevel _ false.
	"Border colors for bevelled effects depend on CW ordering of vertices"
	borderColor == #raised
		ifTrue: 
			[topLeftColor _ color lighter.
			bottomRightColor _ color darker.
			bevel _ true].
	borderColor == #inset
		ifTrue: 
			[topLeftColor _ owner colorForInsets darker.
			bottomRightColor _ owner colorForInsets lighter.
			bevel _ true].
	bigClipRect _ aCanvas clipRect expandBy: self borderWidth + 1 // 2.
	brush _ nil.
	self
		lineSegmentsDo: 
			[:p1 :p2 | 
			p1i _ p1 asIntegerPoint.
			p2i _ p2 asIntegerPoint.
			(closed or: ["bigClipRect intersects: (p1i rect: p2i) optimized:"
				((p1i min: p2i)
					max: bigClipRect origin)
					<= ((p1i max: p2i)
							min: bigClipRect corner)])
				ifTrue: 
					[bevel
						ifTrue: [(p1i quadrantOf: p2i)
								> 2
								ifTrue: [lineColor _ topLeftColor]
								ifFalse: [lineColor _ bottomRightColor]].
					(borderWidth > 3 and: [borderColor isColor])
						ifTrue: 
							[brush == nil ifTrue: [brush _ (ColorForm dotOfSize: borderWidth)
											colors: (Array with: Color transparent with: borderColor)].
							aCanvas
								line: p1i
								to: p2i
								brushForm: brush]
						ifFalse: [aCanvas
								line: p1i
								to: p2i
								width: borderWidth
								color: lineColor]]].
	lineColor isColor ifFalse: [lineColor _ topLeftColor].
	self arrowForms do: [:f | aCanvas
			stencil: f
			at: f offset
			color: lineColor]! !


