'From Squeak 2.3 of January 14, 1999 on 2 February 1999 at 7:49:03 pm'!
"Change Set:		CursorMask
Date:			2 February 1999
Author:			Bert Freudenberg

Fixes a bug in CursorWithMask class>>#derivedFrom: that let primitiveBeCursor fail because of an offset less than -16@-16. Also, makes the generated cursor prettier by centering it on its mask."!


!Cursor methodsFor: 'testing' stamp: 'bf 2/2/1999 19:34'!
hasMask
	^false! !

!Cursor methodsFor: 'converting' stamp: 'bf 2/2/1999 19:32'!
withMask
	^CursorWithMask derivedFrom: self! !


!Cursor class methodsFor: 'class initialization' stamp: 'bf 2/2/1999 19:33'!
makeCursorsWithMask
	"Cursor initialize;makeCursorsWithMask"

	self classPool associationsDo: [:var |
		var value hasMask
			ifFalse: [var value: var value withMask]] ! !


!CursorWithMask methodsFor: 'all' stamp: 'bf 2/2/1999 19:34'!
hasMask
	^true! !

!CursorWithMask methodsFor: 'all' stamp: 'bf 2/2/1999 19:30'!
storeOn: aStream base: anInteger

	aStream nextPut: $(.
	super storeOn: aStream base: anInteger.
	aStream nextPutAll: ' setMaskForm: '.
	maskForm storeOn: aStream base: anInteger.
	aStream nextPut: $)! !

!CursorWithMask methodsFor: 'all' stamp: 'bf 2/2/1999 19:31'!
withMask
	^self! !


!CursorWithMask class methodsFor: 'as yet unclassified' stamp: 'bf 2/2/1999 19:26'!
derivedFrom: aForm      "Cursor initNormalWithMask.  Cursor normal show"
	"aForm is presumably a cursor"
	| cursor mask |
	cursor _ self new.
	cursor copy: (1@1 extent: 16@16) from: 0@0 in: aForm rule: Form over.
	mask _ Form extent: 16@16.
	(1@1) eightNeighbors do:
		[:p | mask copy: (p extent: 16@16) from: 0@0 in: aForm rule: Form under].
	cursor setMaskForm: mask.
	cursor offset: ((aForm offset - (1@1)) max: (-16@-16)).
	^ cursor! !


"Postscript:
Add masks to common cursors"
Cursor initialize; makeCursorsWithMask!
