'From Squeak 2.3 beta of Nov 25, 1998 on 23 February 1999 at 11:21 pm'!
"Change Set:		ProjZoomTweak-di
Date:			23 February 1999
Author:			Dan Ingalls

Changes the Project zooming code so as to only show zoom if there is room for the both displays plus a megabyte of free space (used to be 200k).  Also releases the second copy of the display before starting the scheduling process for the new world.
"!


!Project methodsFor: 'menu messages' stamp: 'di 2/23/1999 23:07'!
enter: returningFlag
	"Install my ChangeSet, Transcript, and scheduled views as current globals. If returningFlag is true, we are return to the project from whence the current project was entered; don't change its previousProject link in this case."

	| newDisplay entering vanishingPoint showZoom priorProject |
	self == CurrentProject ifTrue: [^ self].
	Smalltalk at: #ScorePlayer ifPresent: [:playerClass |
		playerClass allInstancesDo: [:player | player pause]].
	returningFlag ifFalse: [
		"record link to previous project unless we're returning via that link"
		previousProject _ CurrentProject].
	priorProject _ CurrentProject.

	"Same code runs for enter and exit; test which for zoom"
	entering _ self ~~ CurrentProject parent.
	displayDepth == nil ifTrue: [displayDepth _ Display depth].
	CurrentProject makeThumbnail.
	CurrentProject saveState.
	CurrentProject _ self.
	Smalltalk newChanges: changeSet.
	TranscriptStream newTranscript: transcript.
	showZoom _ Preferences showProjectZoom
		and: ["Only show zoom if there is room for the both displays plus a megabyte"
			Smalltalk garbageCollectMost > (Display boundingBox area*displayDepth//8+1000000)].
	Display replacedBy:
			(showZoom
				ifTrue: [newDisplay _ DisplayScreen extent: Display extent
													depth: displayDepth]
				ifFalse: [Display newDepthNoRestore: displayDepth])
		do: [world isMorph
				ifTrue: [World _ world.  "Signifies Morphic"
						world install]
				ifFalse: [World _ nil.  "Signifies MVC"
						Smalltalk at: #ScheduledControllers put: world.
						ScheduledControllers restore]].
	showZoom
		ifTrue: ["Show animated zoom to new display"
				entering
					ifTrue: [vanishingPoint _ Sensor cursorPoint]
					ifFalse: [vanishingPoint _ self viewLocFor: priorProject].
				Display zoomIn: entering orOutTo: newDisplay at: 0@0
							vanishingPoint: vanishingPoint.
				displayDepth ~= Display depth ifTrue:
					[Display newDepthNoRestore: displayDepth.
					newDisplay displayOn: Display at: 0@0].
				newDisplay _ nil "release space before starting the new world"].
	world isMorph
		ifTrue: [self spawnNewProcessAndTerminateOld: true]
		ifFalse: [world searchForActiveController]! !


