'From Squeak 2.3 beta of Nov 25, 1998 on 3 March 1999 at 10:06 am'!
"Change Set:		ProjEnterTweak
Date:			3 March 1999
Author:			Dain Ingalls

This is a necessary repair for the previous update because of a number of places where references to the global Display get saved.  This causes new state to be stored into Display, instead of actually reassigning the global, during project changes.

The postscript should fix up any old refs left by the prior change set.
"!


!DisplayScreen methodsFor: 'private' stamp: 'di 3/3/1999 10:00'!
copyFrom: aForm
	"Take on all state of aForm, with complete sharing"

	super copyFrom: aForm.
	clippingBox _ super boundingBox! !


!Project methodsFor: 'menu messages' stamp: 'di 3/3/1999 10:00'!
enter: returningFlag
	"Install my ChangeSet, Transcript, and scheduled views as current globals. If returningFlag is true, we are return to the project from whence the current project was entered; don't change its previousProject link in this case."

	| newDisplay entering vanishingPoint showZoom priorProject |
	self == CurrentProject ifTrue: [^ self].
	Smalltalk at: #ScorePlayer ifPresent: [:playerClass |
		playerClass allInstancesDo: [:player | player pause]].

	returningFlag
		ifTrue:
			[nextProject _ CurrentProject]
		ifFalse:
			["record link to previous project unless we're returning via that link"
			previousProject _ CurrentProject].
	priorProject _ CurrentProject.

	"Same code runs for enter and exit; test which for zoom"
	entering _ self ~~ CurrentProject parent.
	displayDepth == nil ifTrue: [displayDepth _ Display depth].
	CurrentProject makeThumbnail.
	CurrentProject saveState.
	CurrentProject _ self.
	Smalltalk newChanges: changeSet.
	TranscriptStream newTranscript: transcript.
	Sensor flushKeyboard.
	showZoom _ Preferences showProjectZoom
		and: ["Only show zoom if there is room for the both displays plus a megabyte"
			Smalltalk garbageCollectMost > (Display boundingBox area*displayDepth//8+1000000)].
	Display replacedBy:
			(showZoom
				ifTrue: [newDisplay _ DisplayScreen extent: Display extent
													depth: displayDepth]
				ifFalse: [Display newDepthNoRestore: displayDepth])
		do: [world isMorph
				ifTrue: [World _ world.  "Signifies Morphic"
						world install]
				ifFalse: [World _ nil.  "Signifies MVC"
						Smalltalk at: #ScheduledControllers put: world.
						ScheduledControllers restore]].
	showZoom
		ifTrue: ["Show animated zoom to new display"
				entering
					ifTrue: [vanishingPoint _ Sensor cursorPoint]
					ifFalse: [vanishingPoint _ self viewLocFor: priorProject].
				Display zoomIn: entering orOutTo: newDisplay at: 0@0
							vanishingPoint: vanishingPoint.
				Display copyFrom: newDisplay].

	world isMorph
		ifTrue: [self spawnNewProcessAndTerminateOld: true]
		ifFalse: [world searchForActiveController]! !


"Postscript:
Overwrite any references to obsolete DisplayScreens with the shared references to the current Display."
DisplayScreen instanceCount > 1 ifTrue:
	[(Array with: Canvas with: Paragraph with: BitBlt) do:
		[:c | c allSubInstancesDo:
			[:x | 1 to: x class instSize do:
				[:i | ((x instVarAt: i) isMemberOf: DisplayScreen) ifTrue:
					[x instVarAt: i put: Display]]]].
		Smalltalk garbageCollect].!

