'From Squeak 2.3 of January 14, 1999 on 5 March 1999 at 3:54:30 pm'!
"Change Set:		twoFlapFixes-sw
Date:			5 March 1999
Author:			Scott Wallace

Fixes bug whereby a cmd-drag of a flap that had never otherwise been touched could drop you into a debugger.

Fixes bug that kept event-replay of mouseLeaves involving flaps from working properly."!


!ReferenceMorph methodsFor: 'events' stamp: 'sw 3/5/1999 14:30'!
mouseUp: evt
	oldColor ifNotNil: [self color: oldColor].
	(actWhen == #buttonUp and: [self containsPoint: evt cursorPoint])
		ifTrue: [self doButtonAction].
	super mouseUp: evt "send to evt handler if any"
! !


!FlapTab methodsFor: 'positioning' stamp: 'sw 3/5/1999 14:37'!
mouseMove: evt
	| aPosition newReferentThickness adjustedPosition |

	((self containsPoint: (aPosition _ evt cursorPoint)) and: [dragged not])
		ifTrue:
			[actWhen == #whilePressed ifTrue: [self doButtonAction]]
		ifFalse:
			[flapShowing ifFalse:
				[self flag: #deferred.  "Later use this UI to reposition flap in ortho direction"
				^ self].
			adjustedPosition _ aPosition - evt hand targetOffset.
			(edgeToAdhereTo == #bottom)
				ifTrue:
					[newReferentThickness _ inboard
						ifTrue:
							[self world height - adjustedPosition y]
						ifFalse:
							[self world height - adjustedPosition y - self height]].

			(edgeToAdhereTo == #left)
					ifTrue:
						[newReferentThickness _
							inboard
								ifTrue:
									[adjustedPosition x + self width]
								ifFalse:
									[adjustedPosition x]].

			(edgeToAdhereTo == #right)
					ifTrue:
						[newReferentThickness _
							inboard
								ifTrue:
									[self world width - adjustedPosition x]
								ifFalse:
									[self world width - adjustedPosition x - self width]].

			(edgeToAdhereTo == #top)
					ifTrue:
						[newReferentThickness _
							inboard
								ifTrue:
									[adjustedPosition y + self height]
								ifFalse:
									[adjustedPosition y]].
		

			(#(left right) includes: edgeToAdhereTo)
				ifFalse:
					[self left: adjustedPosition x]
				ifTrue:
					[self top: adjustedPosition y].
			self applyThickness: newReferentThickness.

			dragged _ true]! !

!FlapTab methodsFor: 'show & hide' stamp: 'sw 3/5/1999 15:42'!
hideFlapUnlessOverReferent
	| aWorld |
	(referent isInWorld and: [referent bounds containsPoint: self world activeHand lastEvent cursorPoint])
		ifFalse:
			[aWorld _ self world.
			self referent delete.
			aWorld removeAccommodationForFlap: self.
			flapShowing _ false.
			self isInWorld ifFalse: [aWorld addMorphFront: self].
			self adjustPositionAfterHidingFlap]! !


