'From Squeak 2.3 of January 14, 1999 on 19 April 1999 at 4:02:14 pm'!
"Change Set:		DisMVCTweaks
Date:			19 April 1999
Author:			Dan Ingalls

Prevents discarding MVC from within an MVC project.
Also prevents creation of an MVC project after discarding.
"!


!ScreenController methodsFor: 'menu messages' stamp: 'di 4/19/1999 13:33'!
openProject 
	"Create and schedule a Project."

	Smalltalk at: #ProjectView ifPresent: [:c | c  open: Project new].
! !


!SystemDictionary methodsFor: 'shrinking' stamp: 'di 4/19/1999 13:38'!
discardMVC   "Smalltalk discardMVC"

	| keepers |
	Smalltalk isMorphic ifFalse:
		[PopUpMenu notify: 'You must be in a Morphic project to discard MVC.'.
		^ self].
	"Check that there are no MVC Projects"
	(Project allInstances inject: true into: [:ok :proj | ok & proj isMorphic]) ifFalse:
		[(self confirm: 'Would you like a chance to remove your
MVC projects in an orderly manner?')
					ifTrue: [^ self].
		(self confirm: 'If you wish, I can remove all MVC projects,
make this project be the top project, and place
all orphaned sub-projects of MVC parents here.
Would you like be to do this
and proceed to discard all MVC classes?')
					ifTrue: [self zapMVCprojects]
					ifFalse: [^ self]].
	Smalltalk reclaimDependents.

	"Remove old Paragraph classes and View classes."
	(ChangeSet superclassOrder: Paragraph withAllSubclasses asArray) reverseDo: 
		[:c | c removeFromSystem].
	(ChangeSet superclassOrder: View withAllSubclasses asArray) reverseDo: 
		[:c | c removeFromSystem].

	"Get rid of ParagraphEditor's ScrollController dependence"
	#(markerDelta viewDelta scrollAmount scrollBar computeMarkerRegion) do:
			[:sel | ParagraphEditor removeSelector: sel].
	ParagraphEditor compile: 'updateMarker'.
	MouseMenuController subclass: #ParagraphEditor
		instanceVariableNames: 'paragraph startBlock stopBlock beginTypeInBlock emphasisHere initialText selectionShowing otherInterval '
		classVariableNames: 'ChangeText CmdActions CurrentSelection FindText Keyboard ShiftCmdActions TextEditorYellowButtonMenu TextEditorYellowButtonMessages UndoInterval UndoMessage UndoParagraph UndoSelection Undone '
		poolDictionaries: 'TextConstants '
		category: 'Morphic-Text Support'.

	"Get rid of all Controller classes not needed by ParagraphEditor and ScreenController"
	keepers _ TextMorphEditor withAllSuperclasses copyWith: ScreenController.
	(ChangeSet superclassOrder: Controller withAllSubclasses asArray) reverseDo: 
		[:c | (keepers includes: c) ifFalse: [c removeFromSystem]].

	SystemOrganization removeCategoriesMatching: 'Graphics-Symbols'.
	SystemOrganization removeCategoriesMatching: 'Graphics-Paths'.
	SystemOrganization removeCategoriesMatching: 'Interface-Pluggable'.

	Smalltalk removeClassNamed: 'FormButtonCache'.
	Smalltalk removeClassNamed: 'WindowingTransformation'.
	Smalltalk removeClassNamed: 'ControlManager'.
	Smalltalk removeClassNamed: 'DisplayTextView'.

	ScheduledControllers _ nil.
	Undeclared removeUnreferencedKeys.
	SystemOrganization removeEmptyCategories.
	Symbol rehash.
! !


