'From Squeak3.1alpha of 4 February 2001 [latest update: #3726] on 26 February 2001 at 12:05:10 am'!
"Change Set:		MemReport-ar
Date:			26 February 2001
Author:			Andreas Raab

Modifies the 'space left' report to include:
* the largest chunk of commited memory (identical to former 'space left' report)
* plus the available amount of physical memory (defining the max. amount of memory which can be quickly allocated)
* plus the available amount of swap space (defining the total amount of memory which could eventually be allocated).
If all of them are the same (e.g., dynamically growing OM is not supported) the report looks as it was before these changes.
"!


!ScreenController methodsFor: 'menu messages' stamp: 'ar 2/25/2001 17:59'!
garbageCollect
	"Do a garbage collection, and report results to the user."

	| cc |
	Smalltalk at: #Command ifPresent:
		[:cmdClass |
		(cc _ cmdClass instanceCount) > 0 ifTrue:
			[(self confirm: 'There are ' , cc printString , ' undo records in your system.
would you like to purge them prior to measuring space left?')
				ifTrue: [CommandHistory resetAllHistory]]].
	self inform: (Smalltalk bytesLeftString).
! !


!SystemDictionary methodsFor: 'memory space' stamp: 'ar 2/25/2001 17:55'!
bytesLeft: aBool
	"Return the amount of available space. If aBool is true, include possibly available swap space. If aBool is false, include possibly available physical memory. For a report on the largest free block currently availabe within Squeak memory but not counting extra memory use #primBytesLeft."
	<primitive: 112>
	^self primBytesLeft! !

!SystemDictionary methodsFor: 'memory space' stamp: 'ar 2/25/2001 18:00'!
bytesLeftString
	"Return a string describing the amount of memory available"
	| availInternal availPhysical availTotal |
	self garbageCollect.
	availInternal _ self primBytesLeft.
	availPhysical _ self bytesLeft: false.
	availTotal _ self bytesLeft: true.
	(availTotal > (availInternal + 10000)) "compensate for mini allocations inbetween"
		ifFalse:[^availInternal asStringWithCommas, ' bytes available'].
	^String streamContents:[:s|
		s nextPutAll: availInternal asStringWithCommas, 	' bytes (internal) '; cr.
		s nextPutAll: availPhysical asStringWithCommas,	' bytes (physical) '; cr.
		s nextPutAll: availTotal asStringWithCommas, 	' bytes (total)     '].! !

