'From Squeak3.1alpha of 5 February 2001 [latest update: #4004] on 10 May 2001 at 5:13:56 pm'!
"Change Set:		instantSorter
Date:			10 May 2001
Author:			Bob Arning

- keep a cache of project thumbnails suitable for the internal thread sorter so it will open up faster"!

ThreadNavigationMorph subclass: #InternalThreadNavigationMorph
	instanceVariableNames: 'threadName preferredIndex '
	classVariableNames: 'CachedThumbnails KnownThreads '
	poolDictionaries: ''
	category: 'Morphic-Navigators'!

!InternalThreadNavigationMorph class methodsFor: 'as yet unclassified' stamp: 'RAA 5/10/2001 17:06'!
cacheThumbnailFor: aProject

	| form |

	CachedThumbnails ifNil: [CachedThumbnails _ Dictionary new].
	CachedThumbnails
		at: aProject name
		put: (form _ self sorterFormForProject: aProject sized: nil).
	^form
	! !

!InternalThreadNavigationMorph class methodsFor: 'as yet unclassified' stamp: 'RAA 5/10/2001 17:09'!
clearThumbnailCache

	CachedThumbnails _ nil! !

!InternalThreadNavigationMorph class methodsFor: 'as yet unclassified' stamp: 'RAA 5/10/2001 17:07'!
getThumbnailFor: aProject

	CachedThumbnails ifNil: [CachedThumbnails _ Dictionary new].
	^CachedThumbnails
		at: aProject name
		ifAbsentPut: [self sorterFormForProject: aProject sized: nil]! !

!InternalThreadNavigationMorph class methodsFor: 'as yet unclassified' stamp: 'RAA 5/10/2001 17:04'!
sorterFormForProject: aProject sized: ignored

	^(ProjectViewMorph on: aProject) imageForm scaledToSize: 80@60.
! !


!Project methodsFor: 'accessing' stamp: 'RAA 5/10/2001 14:57'!
setThumbnail: aForm

	self flag: #bob.		"no longer used??"
	thumbnail _ aForm! !

!Project methodsFor: 'menu messages' stamp: 'RAA 5/10/2001 16:59'!
makeThumbnail
	"Make a thumbnail image of this project from the Display."

	world isMorph ifTrue: [world displayWorldSafely]. "clean pending damage"
	viewSize ifNil: [viewSize _ Display extent // 8].
	thumbnail _ Form extent: viewSize depth: Display depth.
	(WarpBlt current toForm: thumbnail)
			sourceForm: Display;
			cellSize: 2;  "installs a colormap"
			combinationRule: Form over;
			copyQuad: (Display boundingBox) innerCorners
			toRect: (0@0 extent: viewSize).
	InternalThreadNavigationMorph cacheThumbnailFor: self.
	^thumbnail
! !


!ProjectSorterMorph methodsFor: 'as yet unclassified' stamp: 'RAA 5/10/2001 17:07'!
sorterMorphForProjectNamed: projName

	| pvm proj |

	(proj _ Project named: projName) ifNil: [^nil].
	pvm _ (InternalThreadNavigationMorph getThumbnailFor: proj) asMorph.
	pvm setProperty: #nameOfThisProject toValue: projName.
	pvm setBalloonText: projName.
	pvm on: #mouseDown send: #clickFromSorterEvent:morph: to: self.
	pvm on: #mouseUp send: #clickFromSorterEvent:morph: to: self.
	^pvm

! !

