'From Squeak3.1alpha of 28 February 2001 [latest update: #4083] on 26 May 2001 at 4:52:14 pm'!
"Change Set:		WnldRename-ar
Date:			26 May 2001
Author:			Andreas Raab

Allow renaming of wonderland actors."!


!Object methodsFor: 'viewer' stamp: 'ar 5/26/2001 16:13'!
isPlayerLike
	"Return true if the receiver is a player-like object"
	^false! !


!Player methodsFor: 'misc' stamp: 'ar 5/26/2001 16:14'!
isPlayerLike
	"Return true if the receiver is a player-like object"
	^true! !


!TileMorph methodsFor: 'initialization' stamp: 'ar 5/26/2001 16:15'!
bringUpToDate
	"Make certain, if the receiver is an object-reference tile, that it shows the current external name of the object, which may just have changed.  This only applies to the Player regime." 

	| newLabel |
		(type == #objRef and: [actualObject isPlayerLike]) ifTrue:
		[newLabel _ actualObject externalName.
		self isPossessive ifTrue:
			[newLabel _ newLabel, '''s'].
		self line1: newLabel]! !


!WonderlandActor methodsFor: 'eToy-support' stamp: 'ar 5/26/2001 16:15'!
externalName
	^ self knownName ifNil: [self getName]! !

!WonderlandActor methodsFor: 'eToy-support' stamp: 'ar 5/26/2001 16:14'!
isPlayerLike
	"Return true if the receiver is a player-like object"
	^true! !

!WonderlandActor methodsFor: 'eToy-fake' stamp: 'ar 5/26/2001 16:17'!
renameTo: aName
	| aPresenter putInViewer oldKey assoc |
	self setName: aName.
	putInViewer _ false.
	((aPresenter _ self presenter) isNil) ifFalse:
		[putInViewer _ aPresenter currentlyViewing: self.
		putInViewer ifTrue:
			[self viewerFlapTab hibernate]].  "empty it temporarily"

	"Fix References dictionary.  See restoreReferences to know why oldKey is 
		already aName, but oldName is the old name."
	oldKey _ References keyAtIdentityValue: self ifAbsent: [nil].
	oldKey ifNotNil:
		[assoc _ References associationAt: oldKey.
		oldKey = aName ifFalse: ["normal rename"
			assoc key: aName asSymbol.
			References rehash]].

	World allTileScriptingElements do: [:m | m bringUpToDate].

	putInViewer ifTrue: [aPresenter viewObject: self].	"recreate my viewer"
	oldKey ifNil: [^ aName].
	^ aName! !

!WonderlandActor methodsFor: 'eToy-fake' stamp: 'ar 5/26/2001 16:11'!
viewerFlapTab
	"If a viewer in a flap exists for me, return it."

	(self currentWorld)
		submorphsDo: [:mm |
			(mm isKindOf: ViewerFlapTab)
				ifTrue:
					[mm scriptedPlayer == self
						ifTrue: [^mm]]].
	^nil! !


!WonderlandWrapperMorph methodsFor: 'handles' stamp: 'ar 5/26/2001 16:11'!
renameTo: aName
	myActor renameTo: aName.! !

