'From Squeak3.1alpha of 28 February 2001 [latest update: #4207] on 26 July 2001 at 12:06:16 pm'!
"Change Set:		userSlotFix-sw
Date:			26 July 2001
Author:			Scott Wallace

Fixes a dumbo mechanical error from change set 4078wordingEtc, relating to user-specified float-precisions for user-defined instance variables."!


!Player methodsFor: 'slots-user' stamp: 'sw 7/26/2001 12:01'!
slotInfoAt: slotName ifAbsent: aBlock
	"If the receiver has a slot of the given name, answer its slot info, else answer nil"

	| info |
	info _ self slotInfo at: slotName ifAbsent: [^ aBlock value].
	^ info! !

!Player methodsFor: 'misc' stamp: 'sw 7/26/2001 12:03'!
defaultFloatPrecisionFor: aGetSelector
	"Answer the float position to use in conjunction with a readout for aGetSelector, which will be of the form 'getXXX'"

	| aSlotName slotInfo |
	aSlotName _ Utilities inherentSelectorForGetter: aGetSelector.
	(slotInfo _ self slotInfoAt: aSlotName ifAbsent: [nil]) ifNotNil:
		[^ slotInfo floatPrecision].

	self costume ifNotNil:
		[^ self costume defaultFloatPrecisionFor: aGetSelector].
	^ 1! !

