'From Squeak3.3alpha of 11 January 2002 [latest update: #4664] on 5 March 2002 at 10:04:33 am'!
"Change Set:		FontFileIn-tk
Date:			5 March 2002
Author:			Ted Kaehler

Henrik Gedenryd pointed out that TextStyle>>collectionFromFileNamed: is broken.  The problem was that DataStream>>nextAndClose was really only intended to be used by a SmartRefStream.  It tests if the file seems to be a straight object file, or a fileIn with embedded objects.
	I simplified the one in ReferenceStream and overrode it in SmartRefStream.
	Also now uses familyName instead of fontName for the StrikeFont."!


!DataStream methodsFor: 'other' stamp: 'tk 3/5/2002 09:51'!
nextAndClose
	"Speedy way to grab one object.  Only use when we are inside an object binary file.  Do not use for the start of a SmartRefStream mixed code-and-object file."

	| obj |
	obj _ self next.
	self close.
	^ obj! !


!SmartRefStream methodsFor: 'read write' stamp: 'tk 3/5/2002 09:52'!
nextAndClose
	"Speedy way to grab one object.  Only use when we are inside an object binary file.  If used for the start of a SmartRefStream mixed code-and-object file, tell the user and then do the right thing."

	| obj |
	byteStream peek = ReferenceStream versionCode "4" ifFalse: [
		"OK it is a fileIn afterall..."
		self inform: 'Should be using fileInObjectAndCode'.
		byteStream ascii.
		byteStream fileIn.
		obj _ SmartRefStream scannedObject.
		SmartRefStream scannedObject: nil.
		^ obj].

	obj _ self next.
	self close.
	^ obj! !


!TextStyle methodsFor: 'fonts and font indexes' stamp: 'tk 3/5/2002 09:57'!
collectionFromFileNamed: fileName
	"Read the file.  It is an TextStyle whose StrikeFonts are to be added to the system.  (Written by fooling SmartRefStream, so it won't write a DiskProxy!!)  These fonts will be added to the master TextSytle for this font family.  
	To write out fonts: 
		| ff | ff _ ReferenceStream fileNamed: 'new fonts'.
		TextConstants at: #forceFontWriting put: true.
		ff nextPut: (TextConstants at: #AFontName).
			'do not mix font families in the TextStyle written out'.
		TextConstants at: #forceFontWriting put: false.
		ff close.

	To read: (TextStyle default collectionFromFileNamed: 'new fonts')
*** Do not remove this method *** "

	| ff this newName style heights |
	ff _ ReferenceStream fileNamed: fileName.
	this _ ff nextAndClose.	"Only works if file created by special code above"
	newName _ this fontArray first familyName.
	this fontArray do: [:aFont | aFont familyName = newName ifFalse: [
		self error: 'All must be same family']].
	style _ TextConstants at: newName asSymbol ifAbsent: [
		^ TextConstants at: newName asSymbol put: this].		"new family"
	this fontArray do: [:aFont | "add new fonts"
		heights _ style fontArray collect: [:bFont | bFont height].
		(heights includes: aFont height) ifFalse: [
			style fontAt: style fontArray size + 1 put: aFont]].
! !

