'From Squeak3.3alpha of 18 January 2002 [latest update: #4886] on 13 June 2002 at 6:53 pm'!
"Change Set:		eToyPatches-ka
Date:			13 June 2002
Author:			 Kazuhiro Abe

Fixes two etoy-related bugs that had crept in:
 The 'add new instance variable' menu of a StandardViewer was not cancelable.
 Invoking the 'edit balloon help' menu of a CategoryViewer for a script was raising an error."!


!ObjectWithDocumentation methodsFor: 'documentation' stamp: 'ka 6/13/2002 19:43'!
editDescription
	"Allow the user to see and edit the documentation for this object"
	| reply helpMessage |
	helpMessage _ self documentation isNil
				ifTrue: [String new]
				ifFalse: [self documentation].
	reply _ FillInTheBlank
				multiLineRequest: 'Kindly edit the description'
				centerAt: Sensor cursorPoint
				initialAnswer: helpMessage
				answerHeight: 200.
	reply isEmptyOrNil
		ifFalse: [self documentation: reply]! !


!Player methodsFor: 'slots-user' stamp: 'ka 6/13/2002 19:43'!
addInstanceVariable
	"Offer the user the opportunity to add an instance variable, and if he goes through with it, actually add it"

	| itsName initialValue typeChosen suggestedNames usedNames initialAnswer setterSelector originalString |
	suggestedNames _ #('cargo' 'speed' 'weight' 'mzee' 'friml' 'verp' 'znak').
	usedNames _ self class instVarNames.
	initialAnswer _ suggestedNames detect: [:aName |  (usedNames includes: aName) not] ifNone:
		[Utilities keyLike: 'var1'  satisfying: [:aKey | (usedNames includes: aKey) not]].

	originalString _ FillInTheBlank request: 'name for new inst var: ' initialAnswer: initialAnswer.
	originalString isEmptyOrNil ifTrue: [^ self].
	itsName _ ScriptingSystem acceptableSlotNameFrom: originalString forSlotCurrentlyNamed: nil asSlotNameIn: self world: self costume world.

 	itsName size == 0 ifTrue: [^ self].	
	self assureUniClass.
	typeChosen _ self initialTypeForSlotNamed: itsName.
	self slotInfo at: itsName put: (SlotInformation new initialize type: typeChosen).
	initialValue _ self initialValueForSlotOfType: typeChosen.
	self addInstanceVarNamed: itsName withValue: initialValue.
	self class compileAccessorsFor: itsName.
	setterSelector _ Utilities setterSelectorFor: itsName.
	(self class allSubInstances copyWithout: self) do:
		[:anInstance | anInstance perform: setterSelector with: initialValue].
	self updateAllViewersAndForceToShow: #'instance variables'! !

