'From Squeak3.2gamma of 15 January 2002 [latest update: #4905] on 1 July 2002 at 2:03:38 pm'!
"Change Set:		categorizeFix-nk
Date:			1 July 2002
Author:			Ned Konz

The 'categorize all uncategorized' choice in the Browser message category pane often missed categorizations.

This change set fixes this problem.
"!


!Browser methodsFor: 'message category list' stamp: 'nk 7/1/2002 14:01'!
categorizeAllUncategorizedMethods
	"Categorize methods by looking in parent classes for a method category."

	| organizer organizers |
	organizer _ self classOrMetaClassOrganizer.
	organizers _ self selectedClass withAllSuperclasses collect: [:ea | ea organization].
	(organizer listAtCategoryNamed: ClassOrganizer default) do: [:sel | | found |
		found _ (organizers collect: [ :org | org categoryOfElement: sel])
			detect: [:ea | ea ~= ClassOrganizer default and: [ ea ~= nil]]
			ifNone: [].
		found ifNotNil: [organizer classify: sel under: found]].

	self changed: #messageCategoryList! !

