'From Squeak3.6alpha of ''17 March 2003'' [latest update: #5313] on 3 July 2003 at 7:53:52 pm'!
"Change Set:		MoreKCPFixes-nk
Date:			3 July 2003
Author:			Ned Konz

A few minor fixes for some of the recent KCP cleanups:

* SystemNavigation had several methods that included the phrase 'self systemNavigation', which doesn't work.

* Object beep called primitiveBeep when it should have been calling beepPrimitive instead.

"!


!Object methodsFor: 'user interface' stamp: 'nk 7/3/2003 17:45'!
beep
	"if sound system is present use it otherwise do whatever we can"
	
	| classOrNil |
	classOrNil := self class environment at: #SampledSound ifAbsent: [nil].
	classOrNil isNil
			ifTrue: [self beepPrimitive ]
			ifFalse: [ classOrNil beep]
			
! !


!SystemNavigation methodsFor: 'query' stamp: 'nk 7/3/2003 19:51'!
allPrimitiveMethods
	"Answer an OrderedCollection of all the methods that are implemented by primitives."
	| aColl method |
	aColl _ OrderedCollection new: 200.
	Cursor execute
		showWhile: [self allBehaviorsDo: [:class | class
						selectorsDo: [:sel | 
							method _ class compiledMethodAt: sel.
							method primitive ~= 0
								ifTrue: [aColl addLast: class name , ' ' , sel , ' ' , method primitive printString]]]].
	^ aColl! !

!SystemNavigation methodsFor: 'query' stamp: 'nk 7/3/2003 19:49'!
allPrimitiveMethodsInCategories: aList 
	"Answer an OrderedCollection of all the methods that are implemented by 
	primitives in the given categories. 1/26/96 sw"
	"SystemNavigation new allPrimitiveMethodsInCategories:  
	#('Collections-Streams' 'Files-Streams' 'Files-Abstract' 'Files-Macintosh')"

	| aColl method |
	aColl _ OrderedCollection new: 200.
	Cursor execute
		showWhile: [self
				allBehaviorsDo: [:aClass | (aList includes: (SystemOrganization categoryOfElement: aClass theNonMetaClass name asString) asString)
						ifTrue: [aClass
								selectorsDo: [:sel | 
									method _ aClass compiledMethodAt: sel.
									method primitive ~= 0
										ifTrue: [aColl addLast: aClass name , ' ' , sel , ' ' , method primitive printString]]]]].
	^ aColl! !

!SystemNavigation methodsFor: 'query' stamp: 'nk 7/3/2003 16:13'!
allUnimplementedCalls
	"Answer an Array of each message that is sent by an expression in a  
	method but is not implemented by any object in the system."
	| aStream secondStream all |
	all _ self allImplementedMessages.
	aStream _ WriteStream
				on: (Array new: 50).
	Cursor execute
		showWhile: [self
				allBehaviorsDo: [:cl | cl
						selectorsDo: [:sel | 
							secondStream _ WriteStream
										on: (String new: 5).
							(cl compiledMethodAt: sel) messages
								do: [:m | (all includes: m)
										ifFalse: [secondStream nextPutAll: m;
												 space]].
							secondStream position = 0
								ifFalse: [aStream nextPut: cl name , ' ' , sel , ' calls: ' , secondStream contents]]]].
	^ aStream contents! !

