'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5420] on 30 September 2003 at 5:37:42 pm'!
"Change Set:		KCP-0096-SwapByte
Date:			28 June 2003
Author:			stephane ducasse

Deprecate swapByte as suggested by andreas and move it into Bitmap"!


!ArrayedCollection methodsFor: 'objects from disk' stamp: 'sd 6/28/2003 09:49'!
restoreEndianness
	"This word object was just read in from a stream.  It was stored in Big Endian (Mac) format.  Reverse the byte order if the current machine is Little Endian.
	We only intend this for non-pointer arrays.  Do nothing if I contain pointers."

	self class isPointers | self class isWords not ifTrue: [^ self].

	Smalltalk isLittleEndian 
		ifTrue: [Bitmap swapBytesIn: self from: 1 to: self basicSize]
! !

!ArrayedCollection methodsFor: 'objects from disk' stamp: 'sd 6/28/2003 09:50'!
swapBytesFrom: start to: stop
	"Perform a bigEndian/littleEndian byte reversal of my words.
	We only intend this for non-pointer arrays.  Do nothing if I contain pointers."
	| hack blt |
	self deprecatedExplanation: 'Use BitMap class>>swapBytesIn:from:to:'.
	self class isPointers | self class isWords not ifTrue: [^ self].

	"The implementation is a hack, but fast for large ranges"
	hack _ Form new hackBits: self.
	blt _ (BitBlt toForm: hack) sourceForm: hack.
	blt combinationRule: Form reverse.  "XOR"
	blt sourceY: start-1; destY: start-1; height: stop-start+1; width: 1.
	blt sourceX: 0; destX: 3; copyBits.  "Exchange bytes 0 and 3"
	blt sourceX: 3; destX: 0; copyBits.
	blt sourceX: 0; destX: 3; copyBits.
	blt sourceX: 1; destX: 2; copyBits.  "Exchange bytes 1 and 2"
	blt sourceX: 2; destX: 1; copyBits.
	blt sourceX: 1; destX: 2; copyBits.
! !


!Bitmap class methodsFor: 'utilities' stamp: 'sd 6/28/2003 09:33'!
swapBytesIn: aNonPointerThing from: start to: stop
	"Perform a bigEndian/littleEndian byte reversal of my words.
	We only intend this for non-pointer arrays.  Do nothing if I contain pointers."
	| hack blt |
	"The implementation is a hack, but fast for large ranges"
	hack _ Form new hackBits: aNonPointerThing.
	blt _ (BitBlt toForm: hack) sourceForm: hack.
	blt combinationRule: Form reverse.  "XOR"
	blt sourceY: start-1; destY: start-1; height: stop-start+1; width: 1.
	blt sourceX: 0; destX: 3; copyBits.  "Exchange bytes 0 and 3"
	blt sourceX: 3; destX: 0; copyBits.
	blt sourceX: 0; destX: 3; copyBits.
	blt sourceX: 1; destX: 2; copyBits.  "Exchange bytes 1 and 2"
	blt sourceX: 2; destX: 1; copyBits.
	blt sourceX: 1; destX: 2; copyBits.
! !


!Form methodsFor: 'resources' stamp: 'sd 6/28/2003 09:48'!
readResourceFrom: aStream
	"Store a resource representation of the receiver on aStream.
	Must be specific to the receiver so that no code is filed out."
	| bitsSize msb |
	(aStream next: 4) asString = self resourceTag 
		ifFalse:[	aStream position: aStream position - 4.
				^self readNativeResourceFrom: aStream].
	width _ aStream nextNumber: 4.
	height _ aStream nextNumber: 4.
	depth _ aStream nextNumber: 4.
	bitsSize _ aStream nextNumber: 4.
	bitsSize = 0 ifFalse:[
		bits _ aStream next: bitsSize.
		^self].
	msb _ (aStream nextNumber: 4) = 1.
	bitsSize _ aStream nextNumber: 4.
	bits _ Bitmap new: self bitsSize.
	(Form extent: width@height depth: depth bits: (aStream next: bitsSize * 4))
		displayOn: self.
	msb = Smalltalk isBigEndian ifFalse:[
		Bitmap swapBytesIn: bits from: 1 to: bits size.
	].! !


!StandardFileStream methodsFor: 'read, write, position' stamp: 'sd 6/28/2003 09:34'!
nextWordsPutAll: aCollection
	"Write the argument a word-like object in big endian format on the receiver.
	May be used to write other than plain word-like objects (such as ColorArray)."
	| reversed |
	aCollection class isPointers | aCollection class isWords not 
		ifTrue: [^self error: aCollection class name,' is not word-like'].
	Smalltalk isLittleEndian ifTrue:[
		reversed _ aCollection clone.
		Bitmap swapBytesIn: reversed from: 1 to: aCollection basicSize.
		self nextPutAll: reversed.
	] ifFalse:[
		self nextPutAll: aCollection.
	].
	^aCollection! !


!SystemDictionary methodsFor: 'deprecated' stamp: 'sd 6/28/2003 09:33'!
swapBytesIn: aNonPointerThing from: start to: stop
	"Perform a bigEndian/littleEndian byte reversal of my words.
	We only intend this for non-pointer arrays.  Do nothing if I contain pointers."
	| hack blt |
	self deprecatedExplanation: 'Use Bitmap class>>swapBytesIn: aNonPointerThing from: start to: stop instead'.
	"The implementation is a hack, but fast for large ranges"
	hack _ Form new hackBits: aNonPointerThing.
	blt _ (BitBlt toForm: hack) sourceForm: hack.
	blt combinationRule: Form reverse.  "XOR"
	blt sourceY: start-1; destY: start-1; height: stop-start+1; width: 1.
	blt sourceX: 0; destX: 3; copyBits.  "Exchange bytes 0 and 3"
	blt sourceX: 3; destX: 0; copyBits.
	blt sourceX: 0; destX: 3; copyBits.
	blt sourceX: 1; destX: 2; copyBits.  "Exchange bytes 1 and 2"
	blt sourceX: 2; destX: 1; copyBits.
	blt sourceX: 1; destX: 2; copyBits.
! !

