'From Squeak3.6gamma of ''11 September 2003'' [latest update: #5423] on 2 October 2003 at 10:00:04 am'!
"Change Set:		findStringFix
Date:			2 October 2003
Author:			Gran Krampe

Lex Spoon (thanks) fixed these two methods (added for SqueakMap originally) in two regards:

- Now works even if the standard file stream is a CrLfFileStream (this is an interesting aspect - using #position: isn't ).

- (Cough, cough) Fixed a silly bug making it actually *work* properly (string to find crosses buffer boundary)

AFAIK only SqueakMap uses these methods (no other users in the image at least)."!


!StandardFileStream methodsFor: 'read, write, position' stamp: 'ls 8/23/2003 16:44'!
findString: string
	"Fast version of #upToAll: to find a String in a file starting from the beginning.
	Returns the position and also sets the position there.
	If string is not found 0 is returned and position is unchanged."

	| pos buffer count oldPos sz |
	oldPos _ self position.
	self reset.
	sz _ self size.
	pos _ 0.
	buffer _ String new: 2000.
	[ buffer := self nextInto: buffer.
	(count _ buffer findString: string) > 0
		ifTrue: ["Found the string part way into buffer"
			self position: pos.
			self next: count - 1.
			^self position ].
	pos _ ((pos + 2000 - string size) min: sz).
	self position: pos.
	pos = sz] whileFalse.
	"Never found it, and hit end of file"
	self position: oldPos.
	^0! !

!StandardFileStream methodsFor: 'read, write, position' stamp: 'gk 10/2/2003 09:47'!
findStringFromEnd: string
	"Fast version to find a String in a file starting from the end.
	Returns the position and also sets the position there.
	If string is not found 0 is returned and position is unchanged."

	| pos buffer count oldPos |
	oldPos _ self position.
	self setToEnd.
	pos _ self position.
	[ pos _ ((pos - 2000 + string size) max: 0).  "the [+ string size] allows for the case where the end of the search string is at the beginning of the current buffer"
	self position: pos.
	buffer _ self next: 2000.
	(count _ buffer findString: string) > 0
		ifTrue: ["Found the string part way into buffer"
			self position: pos.
			self next: count-1.  "use next instead of position:, so that CrLfFileStream can do its magic if it is being used"
			^self position].
	pos = 0] whileFalse.
	"Never found it, and hit beginning of file"
	self position: oldPos.
	^0! !

