'From Squeak3.6 of ''6 October 2003'' [latest update: #5429] on 24 November 2003 at 5:33:20 pm'!
"Change Set:		VariableDefinitions
Date:			24 November 2003
Author:			Lukas Renggli

This enhancement changes the generation of the variable-definition strings in the class ClassDescription: #classVariablesString, #instanceVariablesString and #sharedPoolsString. 

There are two reason for this change:
- code that does the same basically, should have the same look/shape
- the unnecessary space at the end of every var-lists is hurting my eyes"!


!ClassDescription methodsFor: 'printing' stamp: 'lr 11/24/2003 17:21'!
classVariablesString
	"Answer a string of my class variable names separated by spaces."

	^String streamContents: [ :stream | 
		self classPool keys asSortedCollection 
			do: [ :each | stream nextPutAll: each ]
			separatedBy: [ stream space ] ]! !

!ClassDescription methodsFor: 'printing' stamp: 'lr 11/24/2003 17:20'!
instanceVariablesString
	"Answer a string of my instance variable names separated by spaces."

	^String streamContents: [ :stream |
		self instVarNames 
			do: [ :each | stream nextPutAll: each ]
			separatedBy: [ stream space ] ]! !

!ClassDescription methodsFor: 'printing' stamp: 'lr 11/24/2003 17:24'!
sharedPoolsString
	"Answer a string of my shared pool names separated by spaces."

	^String streamContents: [ :stream |
		self sharedPools 
			do: [ :each |
				stream nextPutAll: (self environment 
					keyAtIdentityValue: each 
					ifAbsent: [ 'private' ]) ]
			separatedBy: [ stream space ] ]! !

