'From Squeak3.7alpha of 11 September 2003 [latest update: #5707] on 17 February 2004 at 7:30:22 pm'!
"Change Set:		BrowseCompressedCodeFiles-nk
Date:			17 February 2004
Author:			Ned Konz

Adds the ability to open a FileContentsBrowser on the contents of a compressed stream, both from the FileList and from the BFAV.
"!


!FileContentsBrowser class methodsFor: 'instance creation' stamp: 'nk 2/17/2004 19:26'!
browseCompressedCodeStream: aStandardFileStream 
	"Browse the selected file in fileIn format."
	| zipped unzipped |
	zipped _ GZipReadStream on: aStandardFileStream.
	unzipped _ ReadStream on:  zipped contents asString.
	self browseStream: unzipped named: aStandardFileStream name.! !

!FileContentsBrowser class methodsFor: 'instance creation' stamp: 'nk 2/17/2004 19:26'!
browseStream: aStream

	self browseStream: aStream named: aStream name! !

!FileContentsBrowser class methodsFor: 'instance creation' stamp: 'nk 2/17/2004 19:25'!
browseStream: aStream named: aString

	| package organizer packageDict browser |
	Cursor wait showWhile: [
		packageDict _ Dictionary new.
		organizer _ SystemOrganizer defaultList: Array new.
		package _ (FilePackage new fullName: aString; fileInFrom: aStream).
		packageDict 
			at: package packageName 
			put: package.
		organizer 
			classifyAll: package classes keys 
			under: package packageName.
		(browser := self new)
			systemOrganizer: organizer;
			packages: packageDict].
	self
		openBrowserView: browser createViews
		label: 'File Contents Browser'.
! !

!FileContentsBrowser class methodsFor: 'instance creation' stamp: 'nk 2/17/2004 19:18'!
fileReaderServicesForFile: fullName suffix: suffix

	((FileStream isSourceFileSuffix: suffix) or: [ suffix = '*' ])
		ifTrue: [ ^Array with: self serviceBrowseCode].

	^(fullName endsWith: 'cs.gz')
		ifTrue: [ Array with: self serviceBrowseCompressedCode ]
		ifFalse: [#()]
! !

!FileContentsBrowser class methodsFor: 'instance creation' stamp: 'nk 2/17/2004 19:21'!
serviceBrowseCompressedCode
	"Answer a service for opening a changelist browser on a file"

	^ (SimpleServiceEntry 
		provider: self 
		label: 'code-file browser'
		selector: #browseCompressedCodeStream:
		description: 'open a "file-contents browser" on this file, allowing you to view and selectively load its code'
		buttonLabel: 'code')
		argumentGetter: [ :fileList | fileList directory readOnlyFileNamed: fileList fileName ]! !

FileContentsBrowser class removeSelector: #serviceBrowseCompressedChangeFile!
