'From Squeak3.7alpha of 11 September 2003 [latest update: #5764] on 11 March 2004 at 9:42:41 am'!
"Change Set:		OrganizeTheAllCategory-nk
Date:			11 March 2004
Author:			Ned Konz

This is offered as a better way to fix the problem with filing in the '--all--' category from the File Contents Browser.

It makes the ClassOrganizer actually return all the selectors when given the name of the allCategory. It also changes the definition of allCategory to answer a literal Symbol, rather than calling #asSymbol on a String.
"!


!ClassOrganizer methodsFor: 'accessing' stamp: 'nk 3/11/2004 08:43'!
listAtCategoryNamed: categoryName 
	"Answer the array of elements associated with the name, categoryName.
	If there is no such name, check to see whether the name is the one representing the '--all--' category, in which case return all the method selectors.
	Otherwise, return an empty array."

	| i |
	i := categoryArray
				indexOf: categoryName
				ifAbsent: [^ categoryName = self class allCategory
						ifTrue: [self allMethodSelectors]
						ifFalse: [Array new]].
	^ self listAtCategoryNumber: i! !


!ClassOrganizer class methodsFor: 'class initialization' stamp: 'nk 3/11/2004 08:33'!
allCategory
	"Return a symbol that represents the virtual all methods category."

	^ #'-- all --'! !

"Postscript:
Leave the line above, and replace the rest of this comment by a useful one.
Executable statements should follow this comment, and should
be separated by periods, with no exclamation points (!!).
Be sure to put any further comments in double-quotes, like this one."
!

