'From Squeak3.7alpha of 11 September 2003 [latest update: #5816] on 15 March 2004 at 7:48:42 pm'!
"Change Set:		AccunyInstall
Date:		15 March 2004
Author:		Ned Konz

Installs the text style 'Accuny' from a compressed MIME encoding in the postscript, originally edited by John McIntosh.

March 15: do a better job tracking down loose and derivative fonts.
"
!


!StrikeFont methodsFor: 'accessing' stamp: 'nk 3/15/2004 18:57'!
derivativeFonts
	^derivativeFonts copyWithout: nil! !

!StrikeFont methodsFor: 'emphasis' stamp: 'nk 3/15/2004 18:46'!
releaseCachedState

	self reset.! !


!TextStyle class methodsFor: 'mime file in/out' stamp: 'nk 1/19/2004 20:36'!
collectionFromCompressedMIMEString: aString
	"aString holds a compressed, Base64 representation of a SmartRefStream storage of a TextStyle.
	Install the TextStyle."

	| this newName style heights data |
	data := (Base64MimeConverter mimeDecode: aString as: String) unzipped.
	(RWBinaryOrTextStream with: data) reset; fileIn.
	this := SmartRefStream scannedObject.

	"now install it"

	newName _ this fontArray first familyName.
	this fontArray do: [:aFont | aFont familyName = newName ifFalse: [
		self error: 'All must be same family']].
	style _ TextConstants at: newName asSymbol ifAbsent: [
		^ TextConstants at: newName asSymbol put: this].		"new family"
	this fontArray do: [:aFont | "add new fonts"
		heights _ style fontArray collect: [:bFont | bFont height].
		(heights includes: aFont height) ifFalse: [
			style fontAt: style fontArray size + 1 put: aFont]].
! !

!TextStyle class methodsFor: 'mime file in/out' stamp: 'nk 3/15/2004 19:37'!
looseFontsFromFamily: familyName
	"
	TextStyle looseFontsFromFamily: 'Accuny'
	TextStyle looseFontsFromFamily: 'Accujen'
	TextStyle actualTextStyles keys collect: [ :k | TextStyle looseFontsFromFamily: k ]
	"

	| looseFonts realStyle classes |
	realStyle _ TextStyle named: familyName.
	classes _ ((realStyle fontArray copyWithout: nil) collect: [ :f | f class ]) asSet.
	classes do: [ :cls | cls allSubInstancesDo: [ :f | f releaseCachedState ]].
	Smalltalk garbageCollect.
	looseFonts _ IdentitySet new.
	classes do: [ :cls |
		looseFonts addAll: ((cls allSubInstances select: [ :ea | ea familyName = familyName ])
			reject: [ :f | realStyle fontArray anySatisfy: [ :fn | fn == f or: [ fn derivativeFonts includes: f ] ]]) ].
	^looseFonts! !

!TextStyle class methodsFor: 'mime file in/out' stamp: 'nk 3/15/2004 19:25'!
replaceFontsIn: oldFontArray with: newStyle
	"
	TextStyle replaceFontsIn: (TextStyle looseFontsFromFamily: #Accuny) with: (TextStyle named: #Accuny)
	"
	"Try to find corresponding fonts in newStyle and substitute them for the fonts in oldFontArray"

	newStyle fontArray do: [ :newFont | newFont releaseCachedState ].

	oldFontArray do: [ :oldFont | | newFont |
		oldFont reset.
		newFont _ (newStyle fontOfPointSize: oldFont pointSize) emphasis: oldFont emphasis.
		oldFont becomeForward: newFont ].

	StringMorph allSubInstancesDo: [ :s | s layoutChanged ].
	TextMorph allSubInstancesDo: [ :s | s layoutChanged ].
	SystemWindow allInstancesDo: [ :w | [ w update: #relabel ] on: Error do: [ :ex | ] ].
	World ifNotNilDo: [ :w | w changed ].! !

!TextStyle class methodsFor: 'mime file in/out' stamp: 'nk 3/15/2004 19:05'!
replaceStyle: oldStyle with: newStyle
	"
	TextStyle replaceStyle: (TextStyle named: #AccunyOLD) with: (TextStyle named: #Accuny)
	"
	"Try to find corresponding fonts in newStyle and substitute the fonts in oldStyle for them."
	| oldKeys |
	oldKeys _ Set new.
	TextConstants keysAndValuesDo: [ :k :v | v = oldStyle ifTrue: [ oldKeys add: k ]].
	oldKeys remove: #DefaultTextStyle ifAbsent: [].
	oldKeys remove: #DefaultFixedTextStyle ifAbsent: [].

	self replaceFontsIn: oldStyle fontArray with: newStyle.

	oldStyle becomeForward: newStyle.
	oldKeys do: [ :k | TextConstants removeKey: k ].
! !

"Postscript:
Install the text style from the compressed MIME encoding, and replace the old one."
TextConstants at: #Accuny ifPresent: [ :oldStyle | TextConstants at: #AccunyOLD put: oldStyle. TextConstants removeKey: #Accuny ].
TextStyle collectionFromCompressedMIMEString: 
'H4sIAAAAAAAAANW9fWAc1XkvfM7M7MysNJZmJQEjWKSRLEC4JFnZBNagWCN5bWRqQHykl7Zp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'.

TextConstants at: #AccunyOLD ifPresent: [ :oldStyle | TextStyle replaceStyle: oldStyle with: (TextStyle named: 'Accuny') ].
TextStyle replaceFontsIn: (TextStyle looseFontsFromFamily: 'Accuny') with: (TextStyle named: 'Accuny').
TextStyle replaceFontsIn: (TextStyle looseFontsFromFamily: 'Accujen') with: (TextStyle named: 'Accujen').
!

