'From Squeak3.7alpha of 11 September 2003 [latest update: #5816] on 18 March 2004 at 8:55:36 am'!
"Change Set:		BitmapStreamTests
Date:			17 March 2004
Author:			Ned Konz

v5 (17 March): added a couple more tests.

v4 (16 March): added tests with literals to verify absolute endianness in addition to round-tripping.

v3 (7 March 2004): added MatrixTransform2x3

v2 (5 July 2003): added WordArray and several kinds of storage:
* ImageSegment on disk
* ReferenceStream on RWBinaryOrTextStream
* ReferenceStream on file
* SmartRefStream on RWBinaryOrTextStream
* SmartRefStream on file

This is an incomplete test suite for storing and reading various word- and short-word subclasses of ArrayedCollection.

It demonstrates some problems with filing in of certain kinds of arrayed objects.

In 3.6b-5331, I get 8 passed/6 failed/6 errors.

I ran into problems when trying to read back the SqueakLogo flash character morph, after I'd done a 'save morph to disk' from its debug menu.

The words within the ShortPointArrays and ShortRunArrays were reversed.

"
!


!BitmapStreamTests commentStamp: 'nk 3/7/2004 14:26' prior: 0!
This is an incomplete test suite for storing and reading various word- and short-word subclasses of ArrayedCollection.

It demonstrates some problems with filing in of certain kinds of arrayed objects, including:

ShortPointArray
ShortIntegerArray
ShortRunArray
WordArray
MatrixTransform2x3

In 3.6b-5331, I get 8 passed/6 failed/6 errors (not counting the MatrixTransform2x3 tests, which were added later).

I ran into problems when trying to read back the SqueakLogo flash character morph, after I'd done a 'save morph to disk' from its debug menu.

The words within the ShortPointArrays and ShortRunArrays were reversed.
!


!BitmapStreamTests methodsFor: 'Running' stamp: 'nk 7/5/2003 15:22'!
setUp
	random _ Random new.! !

!BitmapStreamTests methodsFor: 'tests-ShortIntegerArray' stamp: 'nk 3/17/2004 17:05'!
testShortIntegerArrayReadRefStream2
	|refStrm|
	refStrm _ ReferenceStream on: ((RWBinaryOrTextStream with: (ByteArray withAll: #(20 6 17 83 104 111 114 116 73 110 116 101 103 101 114 65 114 114 97 121 0 0 0 2 0 0 0 1 0 2 0 3))) reset; binary).
	self assert: (refStrm next = (ShortIntegerArray with: 0 with: 1 with: 2 with: 3)).! !

!BitmapStreamTests methodsFor: 'tests-ShortIntegerArray' stamp: 'nk 7/5/2003 18:06'!
testShortIntegerArrayWithImageSegment
	array _ ShortIntegerArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortInt ].
	self validateImageSegment
	! !

!BitmapStreamTests methodsFor: 'tests-ShortIntegerArray' stamp: 'nk 3/17/2004 18:44'!
testShortIntegerArrayWithRefStream

	array _ ShortIntegerArray with: 0 with: 1 with: 2 with: 3.
	self validateRefStream
	! !

!BitmapStreamTests methodsFor: 'tests-ShortIntegerArray' stamp: 'nk 3/16/2004 16:03'!
testShortIntegerArrayWithRefStream2
	array _ ShortIntegerArray with: 0 with: 1 with: 2 with: 3.
	self validateRefStream.
	self assert: stream byteStream contents = (ByteArray withAll: #(20 6 17 83 104 111 114 116 73 110 116 101 103 101 114 65 114 114 97 121 0 0 0 2 0 0 0 1 0 2 0 3))
	
! !

!BitmapStreamTests methodsFor: 'tests-ShortIntegerArray' stamp: 'nk 7/5/2003 18:22'!
testShortIntegerArrayWithRefStreamOnDisk
	array _ ShortIntegerArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortInt ].
	self validateRefStreamOnDisk
	! !

!BitmapStreamTests methodsFor: 'tests-ShortIntegerArray' stamp: 'nk 7/5/2003 16:32'!
testShortIntegerArrayWithSmartRefStream
	array _ ShortIntegerArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortInt ].
	self validateSmartRefStream 
	! !

!BitmapStreamTests methodsFor: 'tests-ShortIntegerArray' stamp: 'nk 3/16/2004 16:04'!
testShortIntegerArrayWithSmartRefStream2
	array _ ShortIntegerArray with: 0 with: 1 with: 2 with: 3.
	self validateSmartRefStream.
	self assert: (stream contents asByteArray last: 15) = (ByteArray withAll: #(0 0 0 2  0 0  0 1  0 2  0 3  33 13 13))
	
! !

!BitmapStreamTests methodsFor: 'tests-ShortIntegerArray' stamp: 'nk 7/5/2003 18:31'!
testShortIntegerArrayWithSmartRefStreamOnDisk
	array _ ShortIntegerArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortInt ].
	self validateSmartRefStreamOnDisk
	! !

!BitmapStreamTests methodsFor: 'tests-ShortPointArray' stamp: 'nk 7/5/2003 18:12'!
testShortPointArrayWithImageSegment
	array _ ShortPointArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortPoint ].
	self validateImageSegment 
	! !

!BitmapStreamTests methodsFor: 'tests-ShortPointArray' stamp: 'nk 7/5/2003 18:17'!
testShortPointArrayWithRefStream
	array _ ShortPointArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortPoint ].
	self validateRefStream 
	! !

!BitmapStreamTests methodsFor: 'tests-ShortPointArray' stamp: 'nk 3/12/2004 22:07'!
testShortPointArrayWithRefStream2
	array _ ShortPointArray with: 0@1 with: 2@3.
	self validateRefStream.
	self assert: stream byteStream contents = (ByteArray withAll: #(20 6 15 83 104 111 114 116 80 111 105 110 116 65 114 114 97 121  0 0 0 2  0 0  0 1  0 2  0 3 ))
	! !

!BitmapStreamTests methodsFor: 'tests-ShortPointArray' stamp: 'nk 7/5/2003 18:22'!
testShortPointArrayWithRefStreamOnDisk
	array _ ShortPointArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortPoint ].
	self validateRefStreamOnDisk
	! !

!BitmapStreamTests methodsFor: 'tests-ShortPointArray' stamp: 'nk 7/5/2003 15:57'!
testShortPointArrayWithSmartRefStream
	array _ ShortPointArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortPoint ].
	self validateSmartRefStream 
	! !

!BitmapStreamTests methodsFor: 'tests-ShortPointArray' stamp: 'nk 3/12/2004 22:07'!
testShortPointArrayWithSmartRefStream2
	array _ ShortPointArray with: 0@1 with: 2@3.
	self validateSmartRefStream.
	self assert: (stream contents asByteArray last: 15) = (ByteArray withAll: #(0 0 0 2  0 0  0 1  0 2  0 3  33 13 13))
	! !

!BitmapStreamTests methodsFor: 'tests-ShortPointArray' stamp: 'nk 7/5/2003 18:31'!
testShortPointArrayWithSmartRefStreamOnDisk
	array _ ShortPointArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortPoint ].
	self validateSmartRefStreamOnDisk
	! !

!BitmapStreamTests methodsFor: 'tests-misc' stamp: 'nk 3/17/2004 16:48'!
testOtherClasses

	#(WordArrayForSegment FloatArray PointArray IntegerArray SoundBuffer String ShortPointArray ShortIntegerArray WordArray Array DependentsArray   ByteArray Bitmap ColorArray ) do: [:s | | a |
		a _ (Smalltalk at: s) new: 3.
		self assert: (a basicSize * a bytesPerBasicElement = a byteSize). ]
! !

!BitmapStreamTests methodsFor: 'tests-ShortRunArray' stamp: 'nk 3/17/2004 16:39'!
createSampleShortRunArray
	^ShortRunArray newFrom: { 0. 1. 1. 2. 2. 2. 3. 3. 3. 3 }! !

!BitmapStreamTests methodsFor: 'tests-ShortRunArray' stamp: 'nk 3/17/2004 16:39'!
testShortRunArrayWithImageSegment
	array _ self createSampleShortRunArray.
	self validateImageSegment 
	! !

!BitmapStreamTests methodsFor: 'tests-ShortRunArray' stamp: 'nk 3/17/2004 16:39'!
testShortRunArrayWithRefStream
	array _ self createSampleShortRunArray.
	self validateRefStream 
	! !

!BitmapStreamTests methodsFor: 'tests-ShortRunArray' stamp: 'nk 3/17/2004 16:39'!
testShortRunArrayWithRefStreamOnDisk
	array _ self createSampleShortRunArray.
	self validateRefStreamOnDisk
	! !

!BitmapStreamTests methodsFor: 'tests-ShortRunArray' stamp: 'nk 3/17/2004 16:39'!
testShortRunArrayWithSmartRefStream
	array _ self createSampleShortRunArray.
	self validateSmartRefStream 
	! !

!BitmapStreamTests methodsFor: 'tests-ShortRunArray' stamp: 'nk 3/17/2004 16:44'!
testShortRunArrayWithSmartRefStream2
	array _ self createSampleShortRunArray.
	self validateSmartRefStream.
	self assert: (stream contents asByteArray last: 23) = (ByteArray withAll: #(0 0 0 4 0 1 0 0 0 2 0 1 0 3 0 2 0 4 0 3 33 13 13))

! !

!BitmapStreamTests methodsFor: 'tests-ShortRunArray' stamp: 'nk 3/17/2004 16:40'!
testShortRunArrayWithSmartRefStreamOnDisk
	array _ self createSampleShortRunArray.
	self validateSmartRefStreamOnDisk
	! !

!BitmapStreamTests methodsFor: 'tests-MatrixTransform2x3' stamp: 'nk 3/7/2004 14:23'!
testMatrixTransform2x3WithImageSegment
	array _ MatrixTransform2x3 new.
	1 to: 6 do: [ :i | array at: i put: self randomFloat ].
	self validateImageSegment
	! !

!BitmapStreamTests methodsFor: 'tests-MatrixTransform2x3' stamp: 'nk 3/7/2004 14:24'!
testMatrixTransform2x3WithRefStream
	array _ MatrixTransform2x3 new.
	1 to: 6 do: [ :i | array at: i put: self randomFloat ].
	self validateRefStream
	! !

!BitmapStreamTests methodsFor: 'tests-MatrixTransform2x3' stamp: 'nk 3/7/2004 14:24'!
testMatrixTransform2x3WithRefStreamOnDisk
	array _ MatrixTransform2x3 new.
	1 to: 6 do: [ :i | array at: i put: self randomFloat ].
	self validateRefStreamOnDisk	! !

!BitmapStreamTests methodsFor: 'tests-MatrixTransform2x3' stamp: 'nk 3/7/2004 14:25'!
testMatrixTransform2x3WithSmartRefStream
	array _ MatrixTransform2x3 new.
	1 to: 6 do: [ :i | array at: i put: self randomFloat ].
	self validateSmartRefStream
	! !

!BitmapStreamTests methodsFor: 'tests-MatrixTransform2x3' stamp: 'nk 3/7/2004 14:25'!
testMatrixTransform2x3WithSmartRefStreamOnDisk
	array _ MatrixTransform2x3 new.
	1 to: 6 do: [ :i | array at: i put: self randomFloat ].
	self validateSmartRefStreamOnDisk
	! !

!BitmapStreamTests methodsFor: 'tests-WordArray' stamp: 'nk 7/5/2003 18:25'!
testWordArrayWithImageSegment
	array _ WordArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomWord ].
	self validateImageSegment
	! !

!BitmapStreamTests methodsFor: 'tests-WordArray' stamp: 'nk 7/5/2003 18:27'!
testWordArrayWithRefStream
	array _ WordArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomWord ].
	self validateRefStream
	! !

!BitmapStreamTests methodsFor: 'tests-WordArray' stamp: 'nk 7/5/2003 18:27'!
testWordArrayWithRefStreamOnDisk
	array _ WordArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomWord ].
	self validateRefStreamOnDisk
	! !

!BitmapStreamTests methodsFor: 'tests-WordArray' stamp: 'nk 7/5/2003 18:27'!
testWordArrayWithSmartRefStream
	array _ WordArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomWord ].
	self validateSmartRefStream
	! !

!BitmapStreamTests methodsFor: 'tests-WordArray' stamp: 'nk 7/5/2003 18:31'!
testWordArrayWithSmartRefStreamOnDisk
	array _ WordArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomWord ].
	self validateSmartRefStreamOnDisk
	! !

!BitmapStreamTests methodsFor: 'private' stamp: 'nk 3/7/2004 14:22'!
randomFloat
	"Answer a random 32-bit float"
	| w |
	random seed: (w _ random nextValue).
	^w! !

!BitmapStreamTests methodsFor: 'private' stamp: 'nk 7/5/2003 16:33'!
randomShortInt
	^((random next * 65536) - 32768) truncated! !

!BitmapStreamTests methodsFor: 'private' stamp: 'nk 7/5/2003 16:00'!
randomShortPoint
	^(((random next * 65536) @ (random next * 65536)) - (32768 @ 32768)) truncated! !

!BitmapStreamTests methodsFor: 'private' stamp: 'nk 7/5/2003 18:26'!
randomWord
	"Answer a random 32-bit integer"
	| w |
	random seed: (w _ random nextValue).
	^w truncated! !

!BitmapStreamTests methodsFor: 'private' stamp: 'nk 7/5/2003 18:11'!
validateImageSegment
	"array is set up with an array."
	| other filename |
	filename _ 'bitmapStreamTest.extSeg'.

	FileDirectory default deleteFileNamed: filename ifAbsent: [ ].

	(ImageSegment new copyFromRootsForExport: (Array with: array))
         writeForExport: filename.

	other _ (FileDirectory default readOnlyFileNamed: filename)
		fileInObjectAndCode.

	self assert: array = other originalRoots first! !

!BitmapStreamTests methodsFor: 'private' stamp: 'nk 7/5/2003 18:17'!
validateRefStream
	"array is set up with an array."
	| other rwstream |
	rwstream _ RWBinaryOrTextStream on: (ByteArray new: array basicSize * 6).

	stream _ ReferenceStream on: rwstream.
	stream nextPut: array; close.

	rwstream position: 0.
	stream _ ReferenceStream on: rwstream.
	other _ stream next.
	stream close.

	self assert: array = other! !

!BitmapStreamTests methodsFor: 'private' stamp: 'nk 7/5/2003 18:22'!
validateRefStreamOnDisk
	"array is set up with an array."
	| other filename |

	filename _ 'bitmapStreamTest.ref'.
	FileDirectory default deleteFileNamed: filename ifAbsent: [ ].

	stream _ ReferenceStream fileNamed: filename.
	stream nextPut: array; close.

	stream _ ReferenceStream fileNamed: filename.
	other _ stream next.
	stream close.

	self assert: array = other! !

!BitmapStreamTests methodsFor: 'private' stamp: 'nk 7/5/2003 16:43'!
validateSmartRefStream
	"array is set up with an array."
	| other |
	stream _ RWBinaryOrTextStream on: (ByteArray new: array basicSize * 6).
	stream binary.
	stream fileOutClass: nil andObject: array.
	stream position: 0.
	stream binary.
	other _ stream fileInObjectAndCode.
	self assert: array = other! !

!BitmapStreamTests methodsFor: 'private' stamp: 'nk 7/5/2003 18:32'!
validateSmartRefStreamOnDisk
	"array is set up with an array."
	| other filename |

	filename _ 'bitmapStreamTest.ref'.
	FileDirectory default deleteFileNamed: filename ifAbsent: [ ].

	stream _ FileDirectory default fileNamed: filename.
	stream fileOutClass: nil andObject: array.
	stream close.

	stream _ FileDirectory default fileNamed: filename.
	other _ stream fileInObjectAndCode.
	stream close.

	self assert: array = other! !


!DataStream methodsFor: 'other' stamp: 'nk 3/12/2004 21:56'!
contents
	^byteStream contents! !


!BitmapStreamTests reorganize!
('Running' setUp)
('tests-ShortIntegerArray' testShortIntegerArrayReadRefStream2 testShortIntegerArrayWithImageSegment testShortIntegerArrayWithRefStream testShortIntegerArrayWithRefStream2 testShortIntegerArrayWithRefStreamOnDisk testShortIntegerArrayWithSmartRefStream testShortIntegerArrayWithSmartRefStream2 testShortIntegerArrayWithSmartRefStreamOnDisk)
('tests-ShortPointArray' testShortPointArrayWithImageSegment testShortPointArrayWithRefStream testShortPointArrayWithRefStream2 testShortPointArrayWithRefStreamOnDisk testShortPointArrayWithSmartRefStream testShortPointArrayWithSmartRefStream2 testShortPointArrayWithSmartRefStreamOnDisk)
('tests-misc' testOtherClasses)
('tests-ShortRunArray' createSampleShortRunArray testShortRunArrayWithImageSegment testShortRunArrayWithRefStream testShortRunArrayWithRefStreamOnDisk testShortRunArrayWithSmartRefStream testShortRunArrayWithSmartRefStream2 testShortRunArrayWithSmartRefStreamOnDisk)
('tests-MatrixTransform2x3' testMatrixTransform2x3WithImageSegment testMatrixTransform2x3WithRefStream testMatrixTransform2x3WithRefStreamOnDisk testMatrixTransform2x3WithSmartRefStream testMatrixTransform2x3WithSmartRefStreamOnDisk)
('tests-WordArray' testWordArrayWithImageSegment testWordArrayWithRefStream testWordArrayWithRefStreamOnDisk testWordArrayWithSmartRefStream testWordArrayWithSmartRefStreamOnDisk)
('private' randomFloat randomShortInt randomShortPoint randomWord validateImageSegment validateRefStream validateRefStreamOnDisk validateSmartRefStream validateSmartRefStreamOnDisk)
!

