'From Squeak3.7alpha of 11 September 2003 [latest update: #5860] on 17 April 2004 at 12:24:05 pm'!
"Change Set:		multilistAdjust-ls
Date:			17 April 2004
Author:			Lex Spoon

Tweaks SPS's fixes to make list widths auto-adjust, so that it works on multi-column lists as well.  Without this change, I see a lot of debuggers during use of Celeste."!


!LazyListMorph methodsFor: 'scroll range' stamp: 'ls 4/17/2004 12:18'!
hUnadjustedScrollRange
"Ok, this is a bit messed up. We need to return the width of the widest item in the list. If we grab every item in the list, it defeats the purpose of LazyListMorph. If we don't, then we don't know the size. This is a compromise -- if the list is less then 30 items, we grab them all. If not, we grab currently visible ones, until we've checked itemsToCheck of them, then take the max width out of that 'sampling', then double it. If you know a better way, please chime in."

	| maxW count itemsToCheck item |

	itemsToCheck _ 30.
	maxW _ 0. 
	count _ 0.
	listItems do: 
		[ :each |
			each ifNotNil: 
				[maxW _ maxW max: (self widthToDisplayItem: each contents)]].
				
	(count < itemsToCheck) ifTrue:
		[1 to: listItems size do: 
			[:i | (listItems at: i) ifNil: 
							[item _ self item: i.
							maxW _ maxW max: (self widthToDisplayItem: item contents).
							((count _ count + 1) > itemsToCheck) ifTrue:[ ^maxW * 2]]]].
	
	^maxW 
! !

!LazyListMorph methodsFor: 'scroll range' stamp: 'ls 4/17/2004 12:17'!
widthToDisplayItem: item
	^self font widthOfStringOrText: item
	! !


!MulticolumnLazyListMorph methodsFor: 'scroll range' stamp: 'ls 4/17/2004 12:21'!
widthToDisplayItem: item
	| widths |
	widths := item collect: [ :each | super widthToDisplayItem: each ].
	^widths sum + (10 * (widths size - 1))   "add in space between the columns"
! !

PluggableMultiColumnListMorph removeSelector: #hUnadjustedScrollRange!
