'From Squeak3.7-m17n of 21 July 2004 [latest update: #19] on 25 July 2004 at 3:48:06 pm'!
"Change Set:		e04EmbedFixes-sw
Date:			29 May 2004
Author:			Scott Wallace

Fixes two bugs involving the 'embed into...' menu:
1.  The embed submenu was offering two separate items corresponding to each flexed morph, though both options typically produced the same result.  This change-set eliminates the redundant entry from the menu.
2.  The case of embedding an already-flexed morph into another morph, whether the latter was flexed or not, was broken.

Adapted sw 7/22/2004 00:26 from Squeakland update 0212embedFixes-sw."!


!Morph methodsFor: 'meta-actions' stamp: 'sw 7/22/2004 00:28'!
addEmbeddingMenuItemsTo: aMenu hand: aHandMorph
	"Construct a menu offerring embed targets for the receiver.  If the incoming menu is is not degenerate, add the constructed menu as a submenu; in any case, answer the embed-target menu"

	| menu |
	menu _ MenuMorph new defaultTarget: self.
	self potentialEmbeddingTargets reverseDo: [:m | 
		menu add: (m knownName ifNil:[m class name asString]) target: m selector: #addMorphFrontFromWorldPosition: argumentList: {self topRendererOrSelf}].
	aMenu ifNotNil:
		[menu submorphCount > 0 
			ifTrue:[aMenu add:'embed into' translated subMenu: menu]].
	^ menu! !

!Morph methodsFor: 'meta-actions' stamp: 'sw 5/29/2004 13:30'!
potentialEmbeddingTargets
	"Return the potential targets for embedding the receiver"

	| oneUp topRend |
	(oneUp _ (topRend _ self topRendererOrSelf) owner) ifNil:[^#()].
	^ (oneUp morphsAt: topRend referencePosition behind: topRend unlocked: true) select:
		[:m | m isFlexed not]! !

