'From Squeak3.8alpha of ''17 July 2004'' [latest update: #6281] on 1 October 2004 at 11:25:53 am'!
"Change Set:		AssociationsSelect-dtl
Date:			19 February 2003
Author:			David T. Lewis

md: moved tests into corrent class, added to this cs.

Add convenience method Dictionary>>associationsSelect, a variant of #select which iterates over the associations rather than the values in a Dictionary."!


!Dictionary methodsFor: 'enumerating' stamp: 'dtl 2/17/2003 09:40'!
associationsSelect: aBlock 
	"Evaluate aBlock with each of my associations as the argument. Collect
	into a new dictionary, only those associations for which aBlock evaluates
	to true."

	| newCollection |
	newCollection _ self species new.
	self associationsDo: 
		[:each | 
		(aBlock value: each) ifTrue: [newCollection add: each]].
	^newCollection! !


!DictionaryTest methodsFor: 'testing' stamp: 'md 10/1/2004 11:25'!
testAssociationsSelect

	"(self selector: #testAssociationsSelect) run"

	| answer d|

	d _ Dictionary new.
	d at: (Array with: #hello with: #world) put: #fooBar.
	d at: Smalltalk put: #'Smalltalk is the key'.
	d at: #Smalltalk put: Smalltalk.

	answer _ d associationsSelect:
		[:assoc | (assoc key == #Smalltalk) and: [assoc value == Smalltalk]].
	self should: [answer isKindOf: Dictionary].
	self should: [answer size == 1].
	self should: [(answer at: #Smalltalk) == Smalltalk].

	answer _ d associationsSelect:
		[:assoc | (assoc key == #NoSuchKey) and: [assoc value == #NoSuchValue]].
	self should: [answer isKindOf: Dictionary].
	self should: [answer size == 0]! !

