'From Vancouver1.0 of 8 October 2004 [latest update: #271] on 8 October 2004 at 5:23:50 pm'!
"Change Set:		VocabSummaryFix2-nk
Date:			8 October 2004
Author:			Ned Konz

EToyVocabulary initialize will loop indefinitely due to a bug in update 0340VocabSummary-nk. This changeset fixes this problem.
"!


!EToyVocabulary class methodsFor: '*flexiblevocabularies-scripting' stamp: 'nk 10/8/2004 16:21'!
masterOrderingOfCategorySymbols
	"Answer a dictatorially-imposed presentation list of category symbols.
	This governs the order in which available vocabulary categories are presented in etoy viewers using the etoy vocabulary.
	The default implementation is that any items that are in this list will occur first, in the order specified here; after that, all other items will come, in alphabetic order by their translated wording."

	^#(basic #'color & border' geometry motion #'pen use' tests layout #'drag & drop' scripting observation button search miscellaneous)! !


!Morph class methodsFor: '*flexiblevocabularies-scripting' stamp: 'nk 10/8/2004 16:21'!
unfilteredCategoriesForViewer
	"Answer a list of symbols representing the categories to offer in the viewer for one of my instances, in order of:
	- masterOrderingOfCategorySymbols first
	- others last in order by translated wording"
	"
	Morph unfilteredCategoriesForViewer
	"

	| aClass additions masterOrder |
	aClass _ self.
	additions _ OrderedCollection new.
	[aClass == Morph superclass ] whileFalse: [
		additions addAll: (aClass allAdditionsToViewerCategories keys
			asSortedCollection: [ :a :b | a translated < b translated ]).
		aClass _ aClass superclass ]. 

	masterOrder := EToyVocabulary masterOrderingOfCategorySymbols.

	^(masterOrder intersection: additions), (additions difference: masterOrder).! !

EToyVocabulary removeSelector: #masterOrderingOfCategorySymbols!
