'From Squeak3.3alpha of 18 January 2002 [latest update: #4981] on 6 October 2002 at 2:05:08 am'!
"Change Set:		threeFixes-sw
Date:			6 October 2002
Author:			Scott Wallace

Published as 4987threeFixes-sw.cs to 3.3a.

1.  Fixes a family of bugs in which balloon help remained up after the mouse went down over a menu item, because the balloon owner was different from the target of the hand.  Any existing help balloon is now deleted when the mouse goes down, whether or not the balloon-help's balloonOwner is the same as some hand's target
2.  Make LineListView give the appropriate reply when asked for its morphRepresented; this allows it to cooperate better with the wear-costume command.  (Thanx to Bert Freudenberg).
3.  Fixes a method which could not be recompiled from decompiled source because its optimized bytecode representation had code after an unconditional return."!

!HandMorph methodsFor: 'balloon help' stamp: 'sw 10/15/2002 20:01'!
deleteBalloonTarget: aMorph
	"Delete any existing balloon help.  This is now done unconditionally, whether or not the morph supplied is the same as the current balloon target"
	
	self balloonHelp: nil

"	| h |
	h _ self balloonHelp ifNil: [^ self].
	h balloonOwner == aMorph ifTrue: [self balloonHelp: nil]"! !

!Morph methodsFor: 'events-processing' stamp: 'sw 10/5/2002 01:47'!
mouseDownPriority
	"Return the default mouse down priority for the receiver"

	^ (self isPartsDonor or: [self isPartsBin])
		ifTrue:	[50]
		ifFalse:	[0]

	"The above is a workaround for the complete confusion between parts donors and parts bins. Morphs residing in a parts bin may or may not have the parts donor property set; if they have they may or may not actually handle events. To work around this, parts bins get an equal priority to parts donors so that when a morph in the parts bin does have the property set but does not handle the event we still get a copy from picking it up through the parts bin. Argh. This just *cries* for a cleanup."
	"And the above comment is Andreas's from 10/2000, which was formerly retrievable by a #flag: call which however caused a problem when trying to recompile the method from decompiled source."! !

!ListViewLine methodsFor: 'object represented' stamp: 'sw 10/6/2002 02:00'!
morphRepresented
	"Answer the morph that I actually represent"

	^ objectRepresented! !

