'From Squeak3.7-m17n of 29 June 2004 [latest update: #0] on 30 June 2004 at 12:03:25 am'!
"Change Set:		BVSfInstall
Date:		30 June 2004
Author:		yo

Installs the text style 'BitstreamVeraSerif'
from a compressed MIME encoding in the postscript."
!


!TTCFont methodsFor: 'friend' stamp: 'yo 12/13/2002 12:13'!
derivativeFonts

	| result |
	derivatives ifNil: [^ #()].
	result _ OrderedCollection new.
	derivatives do: [:f | result add: f].
	^ result asArray.
! !

!TTCFont methodsFor: 'caching' stamp: 'nk 3/15/2004 18:52'!
releaseCachedState
	self flushCache.! !


!TextStyle class methodsFor: 'mime file in/out' stamp: 'nk 1/19/2004 20:36'!
collectionFromCompressedMIMEString: aString
	"aString holds a compressed, Base64 representation of a SmartRefStream storage of a TextStyle.
	Install the TextStyle."

	| this newName style heights data |
	data := (Base64MimeConverter mimeDecode: aString as: String) unzipped.
	(RWBinaryOrTextStream with: data) reset; fileIn.
	this := SmartRefStream scannedObject.

	"now install it"

	newName _ this fontArray first familyName.
	this fontArray do: [:aFont | aFont familyName = newName ifFalse: [
		self error: 'All must be same family']].
	style _ TextConstants at: newName asSymbol ifAbsent: [
		^ TextConstants at: newName asSymbol put: this].		"new family"
	this fontArray do: [:aFont | "add new fonts"
		heights _ style fontArray collect: [:bFont | bFont height].
		(heights includes: aFont height) ifFalse: [
			style fontAt: style fontArray size + 1 put: aFont]].
! !

!TextStyle class methodsFor: 'mime file in/out' stamp: 'nk 3/15/2004 19:37'!
looseFontsFromFamily: familyName
	"
	TextStyle looseFontsFromFamily: 'Accuny'
	TextStyle looseFontsFromFamily: 'Accujen'
	TextStyle actualTextStyles keys collect: [ :k | TextStyle looseFontsFromFamily: k ]
	"

	| looseFonts realStyle classes |
	realStyle _ TextStyle named: familyName.
	classes _ ((realStyle fontArray copyWithout: nil) collect: [ :f | f class ]) asSet.
	classes do: [ :cls | cls allSubInstancesDo: [ :f | f releaseCachedState ]].
	Smalltalk garbageCollect.
	looseFonts _ IdentitySet new.
	classes do: [ :cls |
		looseFonts addAll: ((cls allSubInstances select: [ :ea | ea familyName = familyName ])
			reject: [ :f | realStyle fontArray anySatisfy: [ :fn | fn == f or: [ fn derivativeFonts includes: f ] ]]) ].
	^looseFonts! !

!TextStyle class methodsFor: 'mime file in/out' stamp: 'nk 3/15/2004 19:25'!
replaceFontsIn: oldFontArray with: newStyle
	"
	TextStyle replaceFontsIn: (TextStyle looseFontsFromFamily: #Accuny) with: (TextStyle named: #Accuny)
	"
	"Try to find corresponding fonts in newStyle and substitute them for the fonts in oldFontArray"

	newStyle fontArray do: [ :newFont | newFont releaseCachedState ].

	oldFontArray do: [ :oldFont | | newFont |
		oldFont reset.
		newFont _ (newStyle fontOfPointSize: oldFont pointSize) emphasis: oldFont emphasis.
		oldFont becomeForward: newFont ].

	StringMorph allSubInstancesDo: [ :s | s layoutChanged ].
	TextMorph allSubInstancesDo: [ :s | s layoutChanged ].
	SystemWindow allInstancesDo: [ :w | [ w update: #relabel ] on: Error do: [ :ex | ] ].
	World ifNotNilDo: [ :w | w changed ].! !

!TextStyle class methodsFor: 'mime file in/out' stamp: 'nk 3/15/2004 19:05'!
replaceStyle: oldStyle with: newStyle
	"
	TextStyle replaceStyle: (TextStyle named: #AccunyOLD) with: (TextStyle named: #Accuny)
	"
	"Try to find corresponding fonts in newStyle and substitute the fonts in oldStyle for them."
	| oldKeys |
	oldKeys _ Set new.
	TextConstants keysAndValuesDo: [ :k :v | v = oldStyle ifTrue: [ oldKeys add: k ]].
	oldKeys remove: #DefaultTextStyle ifAbsent: [].
	oldKeys remove: #DefaultFixedTextStyle ifAbsent: [].

	self replaceFontsIn: oldStyle fontArray with: newStyle.

	oldStyle becomeForward: newStyle.
	oldKeys do: [ :k | TextConstants removeKey: k ].
! !

"Postscript:
Install the text style from the compressed MIME encoding, and replace the old one."
TextConstants at: #BitstreamVeraSerif ifPresent: [ :oldStyle | TextConstants at: #BitstreamVeraSerifOLD put: oldStyle. TextConstants removeKey: #BitstreamVeraSerif ].
TextStyle collectionFromCompressedMIMEString: 
'H4sIAAAAAAAAAOTdD3iOdf8w/s/faywxImkxCy1JzGItSTRrCYkludfyZ5sZM8zSWpIkubUk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=='.

TextConstants at: #BitstreamVeraSerifOLD ifPresent: [ :oldStyle | TextStyle replaceStyle: oldStyle with: (TextStyle named: 'BitstreamVeraSerif') ].
TextStyle replaceFontsIn: (TextStyle looseFontsFromFamily: 'BitstreamVeraSerif') with: (TextStyle named: 'BitstreamVeraSerif').
!

