'From Squeak3.8alpha of ''17 July 2004'' [latest update: #6270] on 26 September 2004 at 8:38:27 pm'!
"Change Set:		NewUIBingBang2-dgd
Date:			26 September 2004
Author:			Diego Gomez Deck

Second set of changes.

- Support for icons in trees
- Visual Explorer (see preference #visualExplorer)
- Very first version of 'Object Hierarchy' tool (aka Object Selector)
- Icons in FileList trees.

- Alternative look for handles in halo (see preference #alternateHandlesLook)

NOTE: Conflicts checked up to changeset 6270.

"

Preferences
	addPreference: #visualExplorer
	category: #debug
	default: true
	balloonHelp: 'Show icons (when posible) in explorer.'.

Preferences
	addPreference: #alternateHandlesLook
	category: #halos
	default: true
	balloonHelp: 'Use an alternate look for handles.'.
!

StringMorph subclass: #IndentingListItemMorph
	instanceVariableNames: 'indentLevel isExpanded complexContents firstChild container nextSibling icon '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tools-Explorer'!
Object subclass: #MorphHierarchy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Widgets'!
ListItemWrapper subclass: #MorphListItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Widgets'!
SimpleHierarchicalListMorph subclass: #MorphHierarchyListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Widgets'!

!Object methodsFor: 'thumbnail' stamp: 'dgd 9/25/2004 23:17'!
iconOrThumbnailOfSize: aNumberOrPoint 
	"Answer an appropiate form to represent the receiver"
	^ nil! !


!Boolean methodsFor: 'controlling' stamp: 'dgd 9/26/2004 19:05'!
or: block1 or: block2 or: block3 or: block4 or: block5
	"Nonevaluating alternation without deep nesting.
	The receiver is evaluated, followed by the blocks in order.
	If any of these evaluates as true, then return true immediately,
		without evaluating any further blocks.
	If all return false, then return false."

	self ifTrue: [^ true].
	block1 value ifTrue: [^ true].
	block2 value ifTrue: [^ true].
	block3 value ifTrue: [^ true].
	block4 value ifTrue: [^ true].
	block5 value ifTrue: [^ true].
	^ false! !


!Color methodsFor: 'thumbnail' stamp: 'dgd 9/25/2004 23:26'!
iconOrThumbnailOfSize: aNumberOrPoint 
	"Answer an appropiate form to represent the receiver"
	| form |
	form := Form extent: aNumberOrPoint asPoint asPoint depth: 32.
	form fillColor: self.
	^ form! !


!Form methodsFor: 'thumbnail' stamp: 'dgd 9/25/2004 23:26'!
iconOrThumbnailOfSize: aNumberOrPoint 
	"Answer an appropiate form to represent the receiver"
	^ self scaledIntoFormOfSize: aNumberOrPoint! !


!HaloMorph methodsFor: 'private' stamp: 'dgd 9/26/2004 19:37'!
addHandle: handleSpec on: eventName send: selector to: recipient 
	"Add a handle within the halo box as per the haloSpec, and set 
	it up to respond to the given event by sending the given 
	selector to the given recipient. Return the handle."
	| handle aPoint |

	aPoint := self
				positionIn: haloBox
				horizontalPlacement: handleSpec horizontalPlacement
				verticalPlacement: handleSpec verticalPlacement.

	handle := self
				addHandleAt: aPoint
				color: (Color colorFrom: handleSpec color)
				icon: handleSpec iconSymbol
				on: eventName
				send: selector
				to: recipient.

	self isMagicHalo
		ifTrue: [
			handle on: #mouseEnter send: #handleEntered to: self.
			handle on: #mouseLeave send: #handleLeft to: self].

	^ handle! !

!HaloMorph methodsFor: 'private' stamp: 'dgd 9/26/2004 19:39'!
addHandleAt: aPoint color: aColor icon: iconName on: eventName send: selector to: recipient 
	"Add a handle centered at the given point with the given color, 
	and set it up to respond to the given event by sending the 
	given selector to the given recipient. Return the handle."
	| handle |
	handle := self createHandleAt: aPoint color: aColor iconName: iconName.
	self addMorph: handle.

	handle on: #mouseUp send: #endInteraction to: self.
	handle on: eventName send: selector to: recipient.
	handle setBalloonText: (target balloonHelpTextForHandle: handle) translated.

	^ handle ! !

!HaloMorph methodsFor: 'private' stamp: 'dgd 9/26/2004 20:13'!
createHandleAt: aPoint color: aColor iconName: iconName 
	| bou handle |
	bou := Rectangle center: aPoint extent: self handleSize asPoint.
	Preferences alternateHandlesLook
		ifTrue: [| fill | 
			handle := RectangleMorph newBounds: bou color: aColor.
			handle borderWidth: 1.
			handle useRoundedCorners.
			fill := GradientFillStyle ramp: {0.0 -> aColor muchLighter. 1.0 -> aColor darker}.
			fill origin: handle topLeft.
			fill direction: handle extent.
			handle fillStyle: fill]
		ifFalse: [handle := EllipseMorph newBounds: bou color: aColor].
	""
	handle borderColor: aColor muchDarker.
	handle wantsYellowButtonMenu: false.
	""
	iconName isNil
		ifFalse: [| form | 
			form := ScriptingSystem formAtKey: iconName.
			form isNil
				ifFalse: [| image | 
					image := ImageMorph new.
					image image: form.
					image color: aColor makeForegroundColor.
					image lock.
					handle addMorphCentered: image]].
	""
	^ handle! !


!IndentingListItemMorph methodsFor: 'accessing' stamp: 'dgd 9/25/2004 22:25'!
hasIcon
	"Answer whether the receiver has an icon."
	^ icon notNil! !

!IndentingListItemMorph methodsFor: 'accessing' stamp: 'dgd 9/25/2004 22:27'!
icon
	"answer the receiver's icon"
	^ icon! !

!IndentingListItemMorph methodsFor: 'drawing' stamp: 'dgd 9/25/2004 22:47'!
drawLineToggleToTextOn: aCanvas lineColor: lineColor hasToggle: hasToggle
	"If I am not the only item in my container, draw the line between:
		- my toggle (if any) or my left edge (if no toggle)
		- and my text left edge"

	| myBounds myCenter hLineY hLineLeft |
	self isSoleItem ifTrue: [ ^self ].
	myBounds := self toggleBounds.
	myCenter := myBounds center.
	hLineY := myCenter y.
	hLineLeft := myCenter x - 1.
	"Draw line from toggle to text"
	aCanvas
		line: hLineLeft @ hLineY
		to: myBounds right + 0 @ hLineY
		width: 1
		color: lineColor! !

!IndentingListItemMorph methodsFor: 'drawing' stamp: 'dgd 9/25/2004 22:46'!
drawLinesToNextSiblingOn: aCanvas lineColor: lineColor hasToggle: hasToggle
	| myBounds nextSibBounds vLineX myCenter vLineTop vLineBottom |
	myBounds := self toggleBounds.
	nextSibBounds := self nextSibling toggleBounds.
	myCenter := myBounds center.
	vLineX := myCenter x - 1.
	vLineTop := myCenter y.
	vLineBottom := nextSibBounds center y.
	"Draw line from me to next sibling"
	aCanvas
		line: vLineX @ vLineTop
		to: vLineX @ vLineBottom
		width: 1
		color: lineColor! !

!IndentingListItemMorph methodsFor: 'drawing' stamp: 'dgd 9/25/2004 22:36'!
drawOn: aCanvas

	| tRect sRect columnRect columnScanner columnData columnLeft colorToUse |

	tRect := self toggleRectangle.
	sRect := bounds withLeft: tRect right + 4.
	self drawToggleOn: aCanvas in: tRect.
	colorToUse _ complexContents preferredColor ifNil: [color].

	icon isNil ifFalse:[
		aCanvas
			translucentImage: icon
			at: sRect left @ (self top + (self height - icon height // 2)).

		sRect := sRect left: sRect left + icon width + 2.
	].

	(container columns isNil or: [(contents asString indexOf: Character tab) = 0]) ifTrue: [
		sRect := sRect top: sRect top + sRect bottom - self fontToUse height // 2.
		aCanvas drawString: contents asString in: sRect font: self fontToUse color: colorToUse.
	] ifFalse: [
		columnLeft _ sRect left.
		columnScanner _ ReadStream on: contents asString.
		container columns do: [ :width |
			columnRect _ columnLeft @ sRect top extent: width @ sRect height.
			columnData _ columnScanner upTo: Character tab.
			columnData isEmpty ifFalse: [
				aCanvas drawString: columnData in: columnRect font: self fontToUse color: colorToUse.
			].
			columnLeft _ columnRect right + 5.
		].
	]
! !

!IndentingListItemMorph methodsFor: 'initialization' stamp: 'dgd 9/25/2004 22:33'!
initWithContents: anObject prior: priorMorph forList: hostList indentLevel: newLevel

	container _ hostList.
	complexContents _ anObject.
	self initWithContents: anObject asString font: Preferences standardListFont emphasis: nil.
	indentLevel _ 0.
	isExpanded _ false.
 	nextSibling _ firstChild _ nil.
	priorMorph ifNotNil: [
		priorMorph nextSibling: self.
	].
	indentLevel _ newLevel.
	icon := anObject icon.
	self extent: self minWidth @ self minHeight! !

!IndentingListItemMorph methodsFor: 'layout' stamp: 'dgd 9/25/2004 22:26'!
minHeight
	| iconHeight |
	iconHeight := self hasIcon
				ifTrue: [self icon height + 2]
				ifFalse: [0].
	^ self fontToUse height max: iconHeight ! !

!IndentingListItemMorph methodsFor: 'layout' stamp: 'dgd 9/25/2004 22:26'!
minWidth
	| iconWidth |
	iconWidth := self hasIcon
				ifTrue: [self icon width + 2]
				ifFalse: [0].
	^ (self fontToUse widthOfString: contents)
		+ iconWidth ! !


!ListItemWrapper methodsFor: 'accessing' stamp: 'dgd 9/26/2004 18:22'!
icon
	"Answer a form to be used as icon"
	^ nil! !


!FileDirectoryWrapper methodsFor: 'accessing' stamp: 'dgd 9/26/2004 18:22'!
icon
	"Answer a form to be used as icon"
	^ item isRemoteDirectory
		ifTrue: [MenuIcons smallRemoteOpenIcon]
		ifFalse: [MenuIcons smallOpenIcon]! !


!MenuIcons class methodsFor: 'icons creation' stamp: 'dgd 9/25/2004 22:59'!
createIconMethodsFromDirectory: directory 
	" 
	Preferences disable: #showWorldMainDockingBar.  
	MenuIcons createIconMethodsFromDirectory: '/home/dgd/'.  
	Preferences enable: #showWorldMainDockingBar.  
	"
	| iconContentsSourceTemplate iconSourceTemplate normalSize smallSize |
	iconContentsSourceTemplate := '{1}IconContents
	"Private - Method generated with the content of the file {2}"
	^ ''{3}'''.
	iconSourceTemplate := '{1}Icon
	"Private - Generated method"
	^ Icons
			at: #''{1}''
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self {1}IconContents readStream) ].'.
	""
	normalSize := #('back' 'configuration' 'forward' 'fullScreen' 'help' 'home' 'jump' 'objectCatalog' 'objects' 'paint' 'publish' 'squeak' 'volume' 'window' 'project' ).
	smallSize := #('smallBack' 'smallCancel' 'smallConfiguration' 'smallCopy' 'smallCut' 'smallDelete' 'smallDoIt' 'smallExpert' 'smallFind' 'smallForward' 'smallFullScreen' 'smallHelp' 'smallImportFile' 'smallInspectIt' 'smallJump' 'smallLanguage' 'smallNew' 'smallObjectCatalog' 'smallObjects' 'smallOk' 'smallOpen' 'smallPaint' 'smallPaste' 'smallPrint' 'smallPublish' 'smallQuit' 'smallRedo' 'smallSave' 'smallSaveAs' 'smallUndo' 'smallUpdate' 'smallVolume' 'smallWindow' 'smallProject' 'smallSelect' 'smallRemoteOpen' ).
	normalSize , smallSize
		do: [:each | 
			| png base64 contentsSource source | 
			png := directory , each , '.png'.
			base64 := self base64ContentsOfFileNamed: png.
			""
			contentsSource := iconContentsSourceTemplate format: {each. png. base64}.
			source := iconSourceTemplate format: {each}.
			""
			self class compile: contentsSource classified: 'private - icons'.
			self class compile: source classified: 'private - icons'].
	""
	self initializeIcons! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
backIcon
	"Private - Generated method"
	^ Icons
			at: #'back'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self backIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
backIconContents
	"Private - Method generated with the content of the file /home/dgd/back.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABwAAAAcCAYAAAByDd+UAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAAD30lEQVR4nO2WXWgcVRTHf/fOzM5uNpu4/TBN
SzUGWx+KUqwfxSRqbf2oYB+lQkVBFC2CUPHRR0GoUIv4IFYt5EGw9LWittKmaaFa2oC0FCIh
JGpsm9jsbrI7szP3Hh8mH5smaTbqk/QPw8y995z7P1/3noHbqEG2K/VAc4f30L/ZQ9cj1Px4
+p6mzvTXWlSfVfrnxi7/wD8lVEsJNHX4b4tiP5CumRZEPVE6E5z+zwizj2ZbtBd/Beycnsvc
6xFdM8RFC9Afa7290lMZnlHaid9coqFqMg0pp1Iu9HKjLsJcp/8C8AWwGsDJafI7Gsi0exR6
KxTPBbXiJSA19dy8XwUYAfm81FrdzxGMswDZu8CXQBYFjZt9dr3xPFs2PEx/8Qp2Uqj0R7Uq
PuAuYrwH5EHt8Ce8VHUoPlErpHKd/kfAPgCnUbN6V453tr3HW/ft41D/Jxy8/CFSFYrnA+Ix
i1iZVXYV2lfo9NTbVyhPMX6qgpm0AEastzYh3ESqMZ8+rJCXALwVDm2713DwqUMIwpHBbk7+
eRwjMQDrs23cn9/MSn/1jFsCVG1IYAICUyEwASPl37nQc5EbJ8qJUSJ7XICmfLpbkBcBUq0u
7bvX8dqmvRy4/AFXCpfmxakYjbPCX0V7bgN3ZdtozazDiiWwAaGpMBpc55fxPi6MncPJzZ48
0TytmrrSe0SkG5LiWPNyE3fmWxgNri2QkuUjGIy4fnRiOvA/uYhsnV5s2JhCZ1R9ZAJiBTGA
EcQmYyyIJOvKARvW5BkpuUrsYVH6TcCJRmOiMYO3wln0hJoJS/V6hNj6PBQzx8aiEw7bP1J3
u3kFW+OCJbXWwYYWJ6NRznzWcCSas8mShKEQDMTTwx4NkHHC94EBgPEfythQqAxXicbiOZ7E
JYPEsyFCg3KS8leuSr6VSsJahWjUUjg9e0ko5NSMC82d6XaL9ADrdIMm/2x6Kg8KN6dBK6Ib
cZK7KhTPhJhJO9eAW8PiplpmarbQGwwgbAeu2rKl8GOAUiBGiMYN0V8JGcDE+ZC4YJZDFin4
rHSyNDovSY0dqU1KqZPAKp1W5J/JzGliylGMHp2sCZN6RWEuicIR4zpoHNGitVFVo03ZiVW5
eEc4zLeEifwCyD7mbdZaHwNalQPN2zI4jYlodM1SPJvkReC7id7wuXrdhEUa8OTZqM+67oPA
GTEwfrxC6VxIMBDPkE15981yyBKdW2ELXlPG/1hg781LAkMTuXDjdKjqxbz2NAcj2HDIHPPX
e4MonmS26/+GVq9WT8S/LocM6vjFmEbukdxKUuHrKGxDpvrp1e+ZXFrrNv6P+Bvls6OLnK0L
aQAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
configurationIcon
	"Private - Generated method"
	^ Icons
			at: #'configuration'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self configurationIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
configurationIconContents
	"Private - Method generated with the content of the file /home/dgd/configuration.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABwAAAAcCAYAAAByDd+UAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAAGC0lEQVR4nLWWf0yU9x3HX8/9PrhDfpTiUYRB
gZEilta2TiFL11lhWe1ZrDNzTeymYS3OUpcdMSydTDPjyJZJlrJat6ZklJ0a1mJtwza70Q1J
DU5pUSlIFQFRUE7voQcH591nfzzPWUfQ2aZ7J0++yff7/TyvPJ/v5/P+PnBr3XWbtS9dFcA0
8AvA+jljHwFKP0/AT4DI2rVrZf78+QL0AEV3EPcg8HZcXJwAo0DuncC2KIoSrqmpkZELF+TI
kSNSUlIiQAT4LeCYI2YR8KbD4ZDy8nJpbW2V4uJiAQ4A9tvBngSu19TUiM/nk8HBQenq6pK2
tjbZvn27OBwOAQaAWH1/LrDfbrdH1q9fLy0tLbJv3z45ePCgVFZWCjDJHJkx6GMcoADDFy9e
xO/3o6oqE6qK3+/n3qws6urqADKAJD3mRwUFBWu8Xq9SWlqKiOB0Ojl37hz19fUBYAcQD8TM
BVSBS8DehoYGuru7mVBV1IkJJlQVo8lESkpKNMapj6aMjAwikQhJSUnYbDaGh4epqqq6HAqF
PECX/pU7AfNsIMApoCsYDH5QW1vLVDDIhKpiNptJTU3Far1RrHFRYHRCURQMBgN79uxhenq6
Rc9ClcVi+XtycnIl8CJgnA38FDgHvNbe3h7q7OzEZrfjSk0FwGazkZ6eDvAzwIZ+liICQDgc
ZvPmzSiKssHlcu3YtGnTo83NzXg8HoAfAGno53azTMBjQLnL5VrtdrsJBoPMzMxQUVGB0+nE
7XYzMDAwaDQa0z0eDytWrEBVVWJjYwmHw4yOjuJyuVBVFavVitFoxO12EwqFfgi8OhsIsABY
ClSjtYEVSMzOzo45cODAjRc4HA7q6+uxWCwMDQ3hdGpHG4WLCFNTU1RXV9PX1zeGVkTeuYAA
eTrIqEPvBX6dn5+f4PV6AVi1ahXJycls3bqVQCCA3W5HURTMZjMmk4ljx46xc+dOJicnjwK7
gXGg8xa8/9JXge6HFi2QhXlpsnjxYunp6ZGTJ09KTk6OKIoigCQmJsq2bdukqalJysrKBLgO
/AFYCXyNO7TICrvNHDjcWC6nj/5JvLufkQVJVikqKpLe3l458atd0lGQI6cqNkq+xSRA9LkM
eIBvoxnErTJ5Q6lA61Mr8iXQ97KI758ih5+UY9UPyKvfzRFFQZ5ftkRaXAlyPP0uubrlW/LJ
S9+UR3IdAgwDG4HHmePGMcyeANY4Yi3d7/1xQ8mfm+qIifig9afQc5XClFj8BiMiUNj/MQIk
PH438csDZD3zMO+/W0thruMe4HngBHDldsB4oHF16cL9o//elfhYSRmc+A20/VU7bpPC/hED
njc+DgLXX/ZPYrEY+UphEpwV+KQDG5f518Fd5KbbHwSamcO8o7mdZzAoH/7t9fUZ+cueZUL1
kd3/CoxOATAZa6Nk92naP7rQAbQB9wDr1uXFmxtfKEAJ62/KUiBvJVcDJu5fvpWh0em/oF0K
M1GgUR83P11asKbq+3ns+P1Zzpz383VnAEIqh/1W8ioPq4OjE3XAG2gWeAYY6L4SLB6ZDhme
uC8RRYBrQKQPe1oh68qKadjflj0ZjBToXxu5GeguvC+1aPWSKTJdS3g04RpKoJdVrw/wUsPx
DqAGOA1068+IHnfp+NlPl6lKWCnJTdDq8yoQOYUjs5i1Kxfzmvf9vOmQZANvARIFTnb3Xtrw
8EOLyI7pp6//PNmV76m9g9d2A03AEHAU8On7Q8AYEAbGPzgzsSRiR/lGZvxn0HAX8xZtYHn+
FRoPnSm4HpZU4O2b++NF4JeABWgHXkGrstM6cC7FAcsAN/Bc7fcy8SxN06AKjN8tjA0F2feP
y/z80HmAF2Y3ZBqwEM3Ex4CPgOAtYFEloDnJd4Bnf7cxh+fun48Y9IqMwExYmOfpIBiK/Ng4
K1gF+oE+4AKaPf0vBdGS6AeM7xz3LczOspOZYsMa1rru0EkfjZ1jAHtnA7+opnTgOBDzZud4
3rBvGhMKzR+Os6X5LKGwjABVXxLvhlzAE8C7fOar0TJaCndgql9AacADaFdaKpqR70Xr0v+b
FLRfkJjZC/8BvUBdOSBHQOgAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
forwardIcon
	"Private - Generated method"
	^ Icons
			at: #'forward'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self forwardIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
forwardIconContents
	"Private - Method generated with the content of the file /home/dgd/forward.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABwAAAAcCAYAAAByDd+UAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAAD5klEQVR4nO2WT2xURRzHPzNv3p/tbrsLtKSI
FqpNMBJClDQKbNsDsQdRYyQhHCCG9Gb06MELJt6MiSdOxgM3RI+a1FQDGJCiaEIU/FdEbU0p
tLrd7m73vbdvZjzsbqVNhaXeiL9kMnm/me985/udfw/u93D+Czibd3epLaqrNqlvtoqRayXr
GAjeNMivpRWXO/LByexg0NsKTqyJbI/bb6UcZ7lDobC8tvBFdPzeCLfj5bLBpsQxaZ04xYxf
Lc6epQJYgOxg0GuMHQW2ORlJ0KOofB/fPsKoqamjlS8rq9q8RJjJ+y8LOAZsXHUiqyl9KiC7
N0U4mVAYq5AUTbNpFhgpnY8+WolxADr2+q8gOA5kWiUDyOz0cTsdnt9+gMf2bON6YYJ4RgOk
gUN+jyrHk3p8OeEuXM9VnwKe9AXrhtOkHvHwe1z8zQqvW+F1ObgbGmV9vU71uWR2+AhHMPzA
s7zx+Ft09q3n2/RXLP4WYWMrgGH/IZWNp/TYkqWZgWBIWHsWoOPJgP5nnqCvYxuucHGlhytd
lHSXyS7G83w3f5nrpYmlXH/nHg5uPUxX0M2rZ44ycXKK2qyukyDeXyiEL3GVWEnL07YBUjmH
6+VrbM/tZPfGAbpTm3GEgytdAG5Up5ks/0o5KTNTnV5m76W5C1yau0BPupfDO0Y46Z3g51O/
E00lWOyh9pyXlIiPiI58cMpiDwJs2J+m7VGv1SW8Y2S9HIVSgZkTC+hyYzMJ+4Ky2FKzk4ks
SVFjk4bmho9CClACIUE4AuHU6zttr2I8j/QFwVZF5Urj2BgxpIBis5O1lnguaU2CAG+DQmX/
5XY0EM8mxLd0MxNi7LsSYZcOqA3t6uDVwkKtoBvXwQquqqH6R0w0nVBrEgqOlcbjH6U09nSz
Y3E8JJpMMBWLjeuDCikQanlpWmm1JVlYUoDVlvhWQjhdw4aW+dPVZtPnpe7onYYxyPa8fxPo
bFWccCE3lEJm6swq54ABXdZYUx/2z48rkACIb1QQ7it8Vl86B7DBFhUC/UBbS4wGarOG4GFV
/wwtJrJ1R4Sg8Mli3SG4SuztK56LC0uTvX2cbJ51SS3tmZRxgwQZKozQQksttUiElm7Ya4Q8
D/gAnS+mseafRbQR/DW2CBoQXNM4g4vnFm8sc6dVG5vRnvffA0YA0jt9gl4HBNRmNAsXo+Ym
uqKQ+wvnq5Mr8ff84qceVKEVHAGo3dSYsmXxh5jwl6ShQHzQ1hY9N3cmmVsNv6YHuH3Au4AV
u1ekNYLXS+eit++EXdsvhhFHwV68LfOTlWL4bmSwRoVNbGbAOyCsCEubolE+RN8d8n/cD/E3
+N6Gyb/E5QUAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
fullScreenIcon
	"Private - Generated method"
	^ Icons
			at: #'fullScreen'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self fullScreenIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
fullScreenIconContents
	"Private - Method generated with the content of the file /home/dgd/fullScreen.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABwAAAAcCAYAAAByDd+UAAAABHNCSVQICAgIfAhkiAAAABF0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'! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
helpIcon
	"Private - Generated method"
	^ Icons
			at: #'help'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self helpIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
helpIconContents
	"Private - Method generated with the content of the file /home/dgd/help.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABwAAAAcCAYAAAByDd+UAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAADOklEQVR4nL3WS2hcVRzH8c9k2sZJmhqTojVa
LTHWRSZqS9FuKkKsSqCrLkR3bt2IiBtRRBCKuFWUbqy4EBR8ga21IFJRqRGbKvaZl02TNDHt
TJ6dPGaui3OjQ5zOTDT4g8O9538P53sev/M/l/9ZiUrfO+jE3gJ70YL1WMjTjWNJ3v2Nmf8M
7ODpAi8maLsTO9GGrTiFLzGMAkMZnh3lc+SrBf+lNLek+SpN1En0MVGeKCpRDhLtJEozv5WX
sWnVwO3sSRO9TpS7Dqi4fEL0IFE7kymeQF25/pMrA1cYauapzTTvK4oXhI2qXdH+LpzHJWpv
4MarnA7VKoHQwPww+3YjgyPCBn0Tl4dQU9TBWcyHwbYWOD3HCCarBmbpaaLrMC3HMYsx9AiG
eRxNRe2PC9btDSYczvIH+kr1XVMqiPwIT2Y5OMLYd+jm5yyzDwhuXdZUGKAkUgG8BetQvxqg
KXoHef4Cj43yzBL9jdS/tqLdifi5iByWmIhDqVUBY80scmoLiTr2H8CtRR8z+CF+HxeMlQse
gmv/BljTzqtJ3jpAYk/Rhzw+CgALOBOAo6P8giVh6/+hdeVoaY7exCMv4dGieA4fYDCun4yn
M8khRPg9fq4OiF2H0FoUyOI9wbUFwbXjmOeLYb4Pr6UdWhFYIHuZxmXgGXyKaczhpzAr1/iw
j/fjWZ0UVrmkyu5hxERvUX0ghk3iW2SZneTNGJbHj/52aUlVWtKLfewiLN9SPPTlMsILGYbi
ardg3LIqC4zo7xGGf1GwXVLIpzXYRDoTJntOOIoVVTK1LauBySkePkFzDhtxWXDEHPlFzmVD
qq04s6qAWcYn6N/A6DR3D1A3Rn6W3AKX5hiaCTfDwJoAha0bn2IiRWo7O56jpov1CZomuK+B
tqt8Hca3RrqXmzvJTRVdvEtEb8Q3fguvoLGaviqlNrBAVye1DUWxJHZjG+rYgdvWDIjNuRLB
xQCTCDdD2V+LVQELHDtKNFIUmxFOeZzWzrpOsl6pSqYBVxir557DdCSEM/mZ8AfQy/lB3on4
NbDXTqlW3m4ncz9RB7NtHNnAftxebSeV/rxLtb9jI9tmQv6eFlJbVcsJfwJYKDRpDcPnEgAA
AABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
homeIcon
	"Private - Generated method"
	^ Icons
			at: #'home'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self homeIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
homeIconContents
	"Private - Method generated with the content of the file /home/dgd/home.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABwAAAAcCAYAAAByDd+UAAAABHNCSVQICAgIfAhkiAAAABF0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'! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
jumpIcon
	"Private - Generated method"
	^ Icons
			at: #'jump'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self jumpIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
jumpIconContents
	"Private - Method generated with the content of the file /home/dgd/jump.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABwAAAAcCAYAAAByDd+UAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAADMklEQVR4nO3WX2hWdRzH8dc5e3JYBKYDcw/b
1FAEaeKETUmxqLwWLIjCP13VVTdFF6N5I3hTREgRSBd2Ew4iQ29CbZkudRlTVg6lUsbcs3Sb
f6bWedazc7p4Hvfv+eOKugj8wo9zOHx/n/f5fL/f84cH8X+PYLaJbaxES8i6hLUJYcyZkOPo
2sX5fwXYysIUH2HLxKYwvy2Jk4m8W3zXx/Yv+fUfA9vYFgTBB5LksZrlDRpffk5dyzLpNQ3E
WQM/9Orvuqhn/ynDP1+TC0SZxO597PrbwJ1sx76gKrT+ra2efmer1Jxxkog4yh8L57nojmO7
v9K5p1MSJ86y9xBvIDtTt6oUrJWFYRAcCqrCua8e/VjT9k3Cqj9LwiSRMByzdGOtJU8tcq69
Vw0rL3NllLOzAj7Dp2ja8PY2TTs2TQFkSQprKriw5qXnyEVZV7quphayopsjGKkIbGNlwIc1
yxu8+NlOYVjOWXb69cKxvmWe3oN9qm6MLcgQX+db5O7phyUMtkDjK89LPRRPCs8oY5HjQl4q
NaZxSy2oZzmenCpeBAxZB3XNy2YIl+7fdJf5vLqmh0GaWvlVHpiwNggD6TWLS4iV6F9RL7PS
q6oFIQtKAFMlSlogZ4mDosEo2b8SvSzc/DgWVXQYcDqJEwNnesuLFTmefgMDZ29KYoYZRFQR
GHMK+rsuTBcrOziTpbx3rb97FAzyGwYqAtEFPftPyv1xZ1Isvk//CqXORZGeA7fBZTIzgUXP
4XGG1rM6un53RZIbs3RjesZgVJ7YjveGXDgSucpPR+nBYdys5FDCa3HgdueeE/o6fykz/tmi
kvedvqVz723jgbuf5z9b3+eNVnAIJ7i7gUyQ2Hyu/bxclFXfPE8YjpV0lstGOt695mBrflhO
8nUvP2Kf/KRORMXP05u8Xh14P5WYW/PEoxpfqFW3+hHpVdWFabyhv3tUz4FRw5dyxgO/n0wc
+4Zz+GSmu/sC4SUW19A+n+aJTYVGJPFk3iAXvqBjhF60Y7iU3qx/MZ5lcxU7HmdJ4Q1ihMwA
mcsMXso/c4fle5eU05k1cEr+fJOvrJT86GcwhLj81gfxH8VfzYgq0uLDBKMAAAAASUVORK5C
YII='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
objectCatalogIcon
	"Private - Generated method"
	^ Icons
			at: #'objectCatalog'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self objectCatalogIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
objectCatalogIconContents
	"Private - Method generated with the content of the file /home/dgd/objectCatalog.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABwAAAAcCAYAAAByDd+UAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAAD5klEQVR4nN2VW2wUVRjH/+ecmdmd7c7e2qVb
uu1ulrZWoNUURYILSiKoBcRIN+gLUUKMifLiAzHEhHcVtInaxJQYY0g0Jo1CEBXaKBA3RhMp
0Ai10NpUbO32uu3u7GXO8QF6o7NLL5FE/8nJZL75n+/3zZn5zgH+S6r0s+cAVN4z4NqQfLE6
KLcDkBY6hy6D56oOSIVHDjjvC/hYI4BCACW3rznFlgh7oNTL3n5jr7ZuZ1i1MEYq/F62v6pc
fnV4nNfHE6J5iXnnyVnooH++/oI22P5psRBR/5yxdb21D0BFvgSLXdIxVSGHO25k9LLiuYtz
/NtEouN6+n0AXfkSzHzsNRE75ExRTienWVxq6euLGc19MeP8roND35xr8ganHrsd1AKA363i
GSDVG2pDgffKfN6kmTF68aoxDPhv317jQowCwMnzyURPvyEatqgFTo3tuTnE37ob9JZqdr7Y
9PkpMT4RNx2hp1/unm3fsFZpPxCxDwRLpEbNxp6tKpdaHQUkBsC6sDdcpG7GjJ4vziYP9Y8Y
pwAg3osvARAA4l8B9vYbu0zCeWHA8hp/SbrnwDlLeibanh4ajRtmxoSeUhaa1PMIHGlJeYJJ
dLshcHzinN42H8jR1tIa3dPSGjXPIpDIB7FvUlYTTupLKtyRVXUrHpKLJUrdDD80XrEDmAaS
hVadT1rYuu+x5+8/pvgtSExQ9FwbQurvNIrXSPijc0D/6/q4C6eRmvuGJrIBz/goi1AC5yBw
cswwPgaQvdPHCf/F7rEi2taD0Stjv/E0PyEovqMZ7ROtzuqfaNefiiP9VT6WJUDY94cs2shl
rVh0OXziQ9WdCFGpA8BKEz999HBVMniwUGhh676poD2svFnzUalw7bC1TMVMj6dyyj44qrq2
v2a121dQBg+heFhS5K2Sxfu1kdo4KvixO6aIuKJvKQ97QrFL8f50yDirlVqaJI1FhMxdkkZC
cZo6gj5kTdvCAbptt6LO26JWMxkPMjmAmT31ln+TpYnIvC4ukiAE6zVDXaf4pP361UzAVqtA
rVIsdkmpB8z7ULESknM/rCFygQRUT8M2WyrBySt6Z9YtNAHZy2pJlg/wDM+4nrRh4tcURs4k
khDEB5j/NOlRYeQ8Zi6LzGQW6Jyuzkj1Z51qrGhzQVHyRgaGLiih3GWM8HBiiG8EEQOqLX1i
+AImgRxtUUZZ87tW597dik2eHe/iWWybHPyp2zA2zI67HrcGeUbsAEU3Eakfxy5gJFfBuaSW
E/bzO6pzvNdRImLOleIzmye1irLfAQQXm2y28jU+8TD2khukQQDapOCnBzg/CkBfDvD/r38A
0MR5I7Mls/AAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
objectsIcon
	"Private - Generated method"
	^ Icons
			at: #'objects'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self objectsIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
objectsIconContents
	"Private - Method generated with the content of the file /home/dgd/objects.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABwAAAAcCAYAAAByDd+UAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAADhElEQVR4nMWWW0wcVRzGv3POXHZhZdldoAud
RkzRQFsaxBpTNcUtIMZaTdoQBa+tsYRYS2mjD/riiyY2pkL6JulTaUgkaayJ8aUoohgfWlOl
GiNqTY1chr1Bmc7uzuX40E4i7A7Nsqt+yTzM+X///++cyXeSAf5n1Ycp+2gDoVcrCVUVwr4s
BXvxXyEFKO0NE5o8UxK05/zVXPdv5JO+Kr5bkBcrCZkAIBUNJgHbFcKSCX8N5+VK1nNYLtVC
oIPFYBEAqCbsq6GSwMN7RE9Ok845apdmr6vc3gxgoRAgBYA0+NZ2UXY1eQlBq+CxBKC5EJgD
FEWASjcP66o6yrwcUIoBNGxAi3J7TePXVlqjwFQxgCAE50+klnQ30xXLwPec2xsU5bZAr4Su
ynJ62Zm9WgwANM4//9k2D4Qo8TUzaYXxJ8vAXi26aFZv6tnSsr/zrsad2tWpb/9yA4Yr2ECk
WW5Sk7ag6Xx8rc2Fqwgbq6dC8nXZd+N9r998XPDEA4SqAtDumNq6+59q7e5/s6OzP5jrALU1
bMacVPj2OnEBwJbVhqykSMBWC2iWgJABfGcCFwHc+Kdn76FDJfpyaQ/n9sLYyOBZAPxWaf/B
J0o/PP1WIPjLNRN7jkdVRolOCBBdtMr0NHl17WjeRq1PH7snOj99LDE9ETRSyzt3NEieD476
KzZvFFb4/pg18eAr6rXZmL2tICAAhMrZ5P310gMfnwgyWcweZ1rAfS/Nx3741egAcClnkvJR
LGlFLk+nhx49Ek2qieyrNXR+2fhz3joN4BLgEt08lZmL2b0/zvgOtPUltNXFhlpR9HrJJue9
GEB0dr4tNbU935hOm1Fn7crvBgyTY1eTDNjY7bAE1yl5KC4lj1siTlGCl1MZjoPvJBa/uJie
ppTXtNzrkcMV9I6ZqLULwHjBsNauvp727iN3A4BSxeYb7hRioTJ6+FaZAHiopoINl/uEiLOw
QuGWF0ZlWWxyA+ipzG/qxJnHACDyXN+TDGTpwvDAOABUBdk5NW69i5t3N6eyPiljdNvUuYE6
t4bGfUcBAO3P9O+wLbvswsjAJ05NjVv73PocrSs0jzz7msKJHRkbGRzOtzd/IAdlnPYGzJmT
efeuB0gAJhH7vdHRUes/AXIC47Ozp5bWA1sXsFBlpTRjWJmuN07OuTVoeqq4wIV4rOPTb67n
/l8EAN3OFAL8G3xJPtRdAsoRAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
paintIcon
	"Private - Generated method"
	^ Icons
			at: #'paint'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self paintIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
paintIconContents
	"Private - Method generated with the content of the file /home/dgd/paint.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABwAAAAcCAYAAAByDd+UAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAAEK0lEQVR4nLXWW2xUdRoA8N85M53O2Av0Rgus
tJZCKASvUO+E3aBFN7IbWGNMdqMmPGlMdC/ZGB/U+GI0IfqiPigvGLImXtaYdReMAomu2TXB
FYGFRSUVSgstCKWdGTpzztmHKaQhiEaHLzk5+V++/M53/l9yTsqlibCHNS3kTjB8iYxKLKS1
my39c7JJX0Mm6eHFS+mF3ezYsLY7GXru2uTdh/qSK3PppJtl5zZUU5vPH3ovz65Yv34Nde2S
oMb1S2fBLVUHu+jC0w+t7aT9GtGZgiihrSUnYEnVwRRPLOnM1d7y81uJI6WxEyKhQqEMcVXB
Lhbhdw+u6WB2H2PfiGLKAvliCSarCqb4/fzZtambbr2e2kbGBsRxIBIaz5fgZNXAn5HDPf3L
ZjL3hsrkVIURJvJlAfurBmZYi8Zf9V9FXQeTp5k4WqkwCAwcGRezr2pgwAOLO3Nm9VxZmRjZ
DaKEdFA2li9FuWqB3czDL1Yvm0HTwilwVwWMA/l8Hv69h/GqgAH3Ibhz5aJKs0wMkx8Bcczg
0VMCtk7P+amv9N7u2bVauhZXRsd2nVuIksCufcclvF8V8Ao60XtTbz2N84hKjHxxbr1Yju3+
6tuxy/lXVcCQ1XDj4gZSGY7upFw4t35gaFyS2Lad8vS89I8FcUcQkCSJ/25/22XRqHmtKUFA
HLFt1yi8d4EH/dHRPP/qa3zWer+O324ycPUz/rS9x9YvSg6PTvpk38lCwuvnJ12wwn76WlmX
ITvI5q3nncNUDDe3t+vu7dXU3KwUxxb03ezz44u8smmjhDe/5tT3gneycCn/XEUqwB4eDvnN
P3jrvK3RgZ07fdLRJB1N+vqbQUE6LYoiA0fGinjhQsUEsJ7NXdz2Hx45zYcd/HUWc7NkM9Tt
5tPXWXE2qYdHc3W1G5bd2CXbkBEFjAyfduxI4tihwxNxFN31FdsuBKYRNLJ0Di37WXiKkSFe
Ha6c7ztbGOrnqrMJK0kf4vFV110hW5NRnqQcJrJtDUYPHRZH0RvfhZ0Fkw0sXUl9LS+sYktW
5QO2k+dv574t0w7/NEEYBE1zk6xykVKqApbDREdTncFD39Z9F8a0Lt3OeEDbBzz5N/5yBvdS
28Lm1dwNS6g/yfI4STaOHJ/QnE9pyodmFkKNxVAuDqH4g8DbWTHCuq08FfPnUVyGXxPW8NrN
/LHIwTDwcYqP3th7YHjGRKgtn9IydR05Oibg04uB07s03cqX/eyYw7XLpyZbsIbMOzy7sr3b
L8MOj536/OVEkJ03lnGmJlFIx947M+TgyMn/Zdl4MTCYPuhndT0vddLVgAbUIYMU/p6qiR+Z
sTxcUMgp1sSOZUt2ZE54+8SAwfzEjjQP7OfgDwbhScKPmR/SENIQVe71CTPRdpzriql0thCV
UzgcVH7lN33J3otBZ+P/SNx4XWnWkNMAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
projectIcon
	"Private - Generated method"
	^ Icons
			at: #'project'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self projectIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
projectIconContents
	"Private - Method generated with the content of the file /home/dgd/project.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABwAAAAcCAYAAAByDd+UAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAAF60lEQVR4nN2VW4ydVRXHf/vynTO3c2amTKdO
O7WXKRVqW02mtdp2IEZsBNrKLYFY0OADJFAMGIM8AVEfJKhNVRJpk0J4KE9ApClDE4vIyGW0
rcVOC6U0OFNkmNO5neuc81328uGc+c5MgSdDYtwva+9vX/7rv9Z/rQ/+34eau+jdcVdTk9Fr
lZNuJyS1koSgE0q5hBNVW6sEqCRIAicGRaCEAKVDF88JEAKlCJwQaBW9+9of978JiALYfN29
y7QNn1JwNaA/D2aiGJpxsskCGBs+B/Q2NzWw7spVrFy2mFRLE6mW5pptoiGZwGuweAmL5xls
wmA9g+dZlIbIOaIoJHIO5TQzBZ/J8RxvD73Pc4f+TK5QXNuoWWdrYb3iK1++nL2/eADRQll8
AkIiiYiIiCTCiUMQHA4nARV8HrnvHu5+9Oek29PxnmiHU4K0OmxauOGKrSzv7uKRx/ejnDTo
q757TzfQvGb1CkIdMS15SjKDLz6BBHPAXPVBcTiEs6dOs61niAOP3s+pE//k+JvHuZi5iJNZ
p6rnJ8IJli/tqgpGabEKWS7A6p4vUpBSfFBqFy+1bw++xeDLz+NPnOWxOyK2XPk+JwZ3c3jA
se1Hv6Sto7fGVhBxFF2RdtNcBxQnHgqWLu2sspkH4uKLs98L0+NEU+/yk+0ZjNZ0dWiW5YXL
v3U7azb2Ege+djdyEcYYACIXiVVKjAAJz+JwzJQrPHGgH5GaupDYbtm8mq99exvr+67isQdv
Z8+d42QLjkXtYPNqNuhVB6UOjJE6wwiMAoy1OHHMVCosaEqz+9br5sk6my+xr7+ftWuX4CU9
CsWQB57upG31ZkxxhLHJMzErucSiZwEjsVqhRcB6GidhzOhTawmJPV937S62bv8O1jOfAjI/
LbPtRUVarJtlaDRhLQSfBSkiCBFOhG/euJ1Yu3PCV3VqvhXjAAiVFqtFK6ldnfUumysyMnpx
HliuOBMzrJfJJcxqwCMfDpNKp2lJtSAiGF1tXkpHYhEpoCBfKGGbIJm0dHQ389LJvyGxaAQR
YdPXV9bBao+HUcg7751h6J2TDOdPM1b+CNWqWV5Zzw933YVD8KxXF40zKquckMuXaFvYgLGa
G3b0xnnwA5/hc//CD30Wf6HlE+VSqszw7F9/Q844xs4VadPtNLbO8Hp0lDvCO1FG42kLgI4i
sTp0OdGQzRZIS2JeHR0/8hoDD+/l6kyOZOR4ZmGant23svX7O2JRNDYkSbpWLpw/xZ779tO5
aBGHD7/IS5mDvP7GAJv7+kjYRJxDHXoqC5DLlmpZqYJVymUGHvo1T45k+V5ZuDlQ/PajPJnH
n2Hs32Nx+5rxyzCVIr2kkdNnhvj9k3s48MIfKFufQ4PPI+Jihkpr0Ympcg4gO10AqNaSOM6f
Pc+28fwnlHrLeJEzA8fiFvjQwz/m6It/IuwM+cfJ4+RLebyFmspoBGVFuVzGr4S1sojEvvrq
0+W+nXf709lCwsMSSIDg6F65lIPtTdx8sTwP8Ehrkp4Na2KGt9x0G8XGfbQOt7GiZyXX79hJ
JjNGc0sTycZGUqaFYqn+hp1V/XQu3+EpD0cREUeyOcmK+3fx070HuWk0RwI4tLCZ8LZrWLKi
q6pWcWzcsIkNGzbOq8WOzo5YzSmTopQv11VaA8xOZwsdSZ3EhXXZ9/1gJ5PX9zH4xgmCis9X
v7Gey7ouq2b60lqMAeO/JiJC2qYZvjBaazUujBl+OJoh5VJ0eULZlfHFx0lE66JWVt3Yg1Ea
owwGgyCEEhJKSCAhoQRV6wIcDoXCKMMCu4DuZDfP/v0vAJVmP/meBVCojz/OTHDvg7/iS6uW
EUYRk1NZsrkCSimMNRitsdZgjcEYM2euq3bOGWOqe9aO4AfHOPLKWwDH+vt/V7HVHun2odQ1
5z644J374MJndNL/apSUyM+q5Gpjy87di5WqrAG9GDDaoUUpLYhSoEGUUmgRrUQ5rRwahQfK
ovBE8HTNgoRKMQV6yombTBrvlaMvPDHxeTD53xv/AR4UzKU1laJtAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
publishIcon
	"Private - Generated method"
	^ Icons
			at: #'publish'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self publishIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
publishIconContents
	"Private - Method generated with the content of the file /home/dgd/publish.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABwAAAAcCAYAAAByDd+UAAAABHNCSVQICAgIfAhkiAAAABF0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'! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallBackIcon
	"Private - Generated method"
	^ Icons
			at: #'smallBack'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallBackIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallBackIconContents
	"Private - Method generated with the content of the file /home/dgd/smallBack.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAAB9UlEQVR4nL2SwUtUYRTFf/d7M2/ezDiNEwgy
FbmMIopEF5aDEOKuTdsIat1S2tdCiKRVG/sDWkS0KagBM7AgWkhQUBAFJZo6CjrjzPjem/d9
t0UYlShR0NndeznncjgH/hHebofi6cxous8L4nm7upeA/L7Ij+R7TSe5jXBeoW0sJxovo49/
JFA4E1wGJlNFKRUrWdan27gtXVHlHoIz4Cv4KA0xVBvPo+p3gRFShcS/A3Kp+1SeiSs3mHx/
ndWZOs3XEXiCpMD4gmQEHHTWbKzImJT7yTWymQfGMHb4XJkLYxdZaH3h6dIT0ibNyf0DHO0+
TtbLoTgacZ3q4kPe3vqEjbgrheHMTZTx0miOvsFDrIW1HT67/RK92TIAC615mskmX6fq2Kb7
kFKVsqD4ZW8HOalbXKSs2BrLrgaqiBEwoB0FsMaJGQc2mnMRcS1BrQLgQke8lpBsWmzb4UKH
ixQbOmxLcbECLAtAVyWo4PRxcTjI+T0GL+9hQwcKrTcxrqnYlsO2dfvzdoZXf8SYHw7OGtVH
hcFM4B/wQKGzZGm8ihDkmgqLqpo2kFIkNE4/1/1o5pcedFWCiji97x9M9eSPpNl4toVa3m2+
iI7tViTz89CcDWcTY/rjBTu3Pr2FWlRUJ3Yj7wUpVLJD+4bSA39D/r/4Bkux5LIwlMbWAAAA
AElFTkSuQmCC'! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallCancelIcon
	"Private - Generated method"
	^ Icons
			at: #'smallCancel'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallCancelIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallCancelIconContents
	"Private - Method generated with the content of the file /home/dgd/smallCancel.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAACC0lEQVR4nK2RX0hTYRjGf+d85882bWZMESIC
CSHOaYu6TIksRwRCXhgUOLqWsn9IlFAQ3YRSoFTQWEFGeFUXBd4FQVC3zrrJIOgiglzTOd12
tp23myY6XBfRe/XxPt/zvs/3++B/Vgx27oXdjfQ9EI5C+8aeXjs4kDhu8zVu8dmFvi2Gdx01
WThh892F85vELohctPHKvTFZfvVUxrYHSg4cqekuREe3mdnl6UnxBnrkWgDfgRiAAaCBlfOp
+Ok5U31ZYHTmiVUaTMzqK+W4D8X+sPnm6nSySfM89A/v+eWDArUpxT44fM6i6LUhK8k7svTy
sYwEVeFmi1VYev1McjMPpdyhZMTGdyBR82kbhzjQe8xmdqJFswr3pvA1DVpb0TMZAlcucDnr
+289hubhecOfcKHvko1X7VCSn7olq+PXpdSuy7BFxYVT9feN+oYG5i6FplerlMduoGmgTKhA
WYdvDTf/eUL//RAVaUN+NCPzBpJWSCaMFCLIWZN8FA40ij7wqIlqzZw2kCGDwoRNNa2QbBjJ
R5CEyVIU3PrNh1IbzPMGcsZgzYFuB05PBvDTClluQXIRZNBg8SCE1hlo0OoY6ItF+FmE21D4
WCH+Cd4BJIsErCAp8midYehU7JirEALW1lOcVKReNCODilUHurfgMzweQB4EkRjc3ZJDFHpc
iP4F8v6GEP+1fgOfrL0AYYB91QAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallConfigurationIcon
	"Private - Generated method"
	^ Icons
			at: #'smallConfiguration'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallConfigurationIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallConfigurationIconContents
	"Private - Method generated with the content of the file /home/dgd/smallConfiguration.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAACmElEQVR4nHWTXUiTcRTGf++7XrepW7VpogNt
SU0oVNLoJisJkvVhTcMEiREiBN2IBWVZXkSIZPQhRiJFEDLzwpEFRVniXURQWSCjFU0ZSPZa
sYZB7j1d6NAsn5tz8Zz/c87/POfAAlYCrYCD5ZEPpP6PsFut1jcdHR3i8Xi+AUeW8GtTUlJu
e73eWVVVewBlMakB9/r7+8UwDAmHw9LQ0CBAF4CmaV0+n282EAhIMBgUp9OpA+uSj9X5OBwM
BkXXdeLxOLW1tWia5gEoKiry19XVmex2O21tbbqu66eBnUB2UuA38Kivr+/x82fPmJ6eRtM0
bDabG7AAislkIpFIEAqFvhcWFl5obGy8BVwElORfFGC/y+UKFBQUpLrdbmpqaqiurv5aX1+f
UV5ejtlsZmZmBkVRMAwDv98fjcVim1fMCwgwEo1Gt0ejUQdwTlGUsoGBgYyWlhaysrJwOBzk
5OQwMTFBc3NzJBaLXVg0ggU31jjTewfvNEmtd5M0NTXJ055u6dpSLPlWi5GXl2cAQ4CXOdv/
wq7jR3ZM//rYI/LwoIydL5HczHS573JKyF8gnx4clWKPPQbsA5KdowJaVobt5tuh9qHOk9tW
m0fukpj8weVXM/HxqZ+RKQtsKM3ErUYZ7j+Vvj437RaQu7jywdHBBukL9Mpk92EJ36iQzFWp
T4ADgA8Yfd9WItJZJvLIK19eXxJXpmUccCUFDl09u1v0QJW0+kvjwBlgI2CaX7IKVWUs3LFl
TuRJpUReXJRVthUhICNpYQtwB9jDv7eQAuw1a+qHiStbRTrLZPzaVmn3uQW4sjjRzJIdX8JV
plnUyLv2EklcL5Nj27IFOLFM/n9hAaqAsN1iMoCXQNpyFZeDlYXhfQZm/wDvmfZYAyOuUwAA
AABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallCopyIcon
	"Private - Generated method"
	^ Icons
			at: #'smallCopy'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallCopyIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallCopyIconContents
	"Private - Method generated with the content of the file /home/dgd/smallCopy.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAACp0lEQVR4nHXRz29UVRjG8e977pk7HTpzOwPt
TFqbWGscWOiGuCCAhI1oMNYfCzcNCQuSmpCQ6ELiwsjCBX8BJl0YV6xYKQsSQgIETNCMxhJD
m7SRqdg6pUwLzHRm7r3nvC4KiLW+2/M8n/ckr/A/c+TIsf52tm8sMOZFDxXV5MLN7755vDVn
ATk0MfWBwoHKUGn30M7S+I7+3AuFfD6KogJRIU+jscKlKz+MAV9uBeSNiamPD+/f+/WxyY9w
kmWj52l1Hb1EcU5JvVIdSjlx6ouLcRJOhpl0TPDF63uHb3DmjLdA6eD+fXRdiPMer0pjaZF6
fZFmc41Op811El7dM350IMo/LEZ5lhoP8D/PTd2AaavQiwo5dmQNXuHylWs0lhf58N23KO4c
wqnQiZVO7EySKqlTImnyy+mz+4Bpa0R7Lk3IhZvAo0frvHf0TQqlMrED7xUj0JcxZAJwXqkU
B0GoAlhVE8e9Ln1PgNAGFAfym6AHr4r34HQTcwr9uQwDUX73E0BbrfYGWSt4hWwYoC4lmzGo
/gN4VQJjKOQCcqFhpDI4ePj940Ur+KXG/SbWCoKQzQTESfwMVBUA+kJDaOXZ+UZHytxZqFet
C+Teyuoa1gjGCGGYod1qY62AboZDaxD59/1HR8rgtWrC9fjPldUmgREEKO8q8tf9JtYINhCy
mf+WAUaHy6C8Yq5e/ba72lxfe/pQKe9iubGKESEw2zSf/4Fo1QIsNx7cvvnjzCHvPbWZWR63
Nrbd+vyUB0uAvGQBfNed/Pyrc59iZFnQmdf2vHweMFtLSZKycPces/N1btV+A5Xb2+55Z/KT
hXNnPxvv9GLm5uvMzdeZna/73/9YupOm7idUasZr7drrw7e2BQ5OTL0tymkMd5+GW6K/1r6f
3tia/RuMlS09PH8/SwAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallCutIcon
	"Private - Generated method"
	^ Icons
			at: #'smallCut'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallCutIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallCutIconContents
	"Private - Method generated with the content of the file /home/dgd/smallCut.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAABp0lEQVR4nI2RwWuScRjHP77vmq9TWzqb0+iw
dAahluhhQV42MDwogyBo/8JgEEF/QhA7BF3WZYe26tDJLjtIG4w13A4lMbaFF8UyTGKa5pyN
17fLa2w2X/2cfvye5/vheXhAm2fA0x49/xCBKKBrf8S81lzEO9ZUa+cinHpHH8T8q067OQFI
AIZB4ZLLIgwC1/sRbKV3s4eJF7Nxp928CYwaLggmz2UJwN+PoPwlV3u09Po9a0uxkG/CknbZ
DOL4iARws5ugc7fPH/fLoamg2fNkPmC2isDRCS93SlXgTTdJJ5YhScxur0wrrfR9pbA8rQCF
fsNtAqNWfSO/MKlkHvoU9xWjAoT7WaFNsd6Qj6N+W8R928GtiWHebhQCcot76jTZXgKAin1o
YC6ZKv5O7pZ/lSrNk8af1nNgEagBn7RWMAE7oqCTr9mkH+EblkUdvFNrd4CvnL3gf8wA24BR
Bwd6UYwDVeCuGqwDHoCBLoIwkALqCqSasuxTpa+AQ+A7kNES7KkBADeQANaBIHAVyGuND+AA
fgIfgG/AcK/AeYwBj4GLWk1/AX4ycm0mm5UYAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallDeleteIcon
	"Private - Generated method"
	^ Icons
			at: #'smallDelete'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallDeleteIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallDeleteIconContents
	"Private - Method generated with the content of the file /home/dgd/smallDelete.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAACrElEQVR4nG2TW0hTcRzHv+ecqdt0l1YT2pq3
NFyaLCK8RNiDdqMiBJFeDIogIujBtzB6ypcu0FsFgQ/ZBSEpUSu6EUo9RGltiCXihk7ntnbO
zjyX7Zz/v4fyMufv7f//ffj84ff7/hlsXkxpqasRhGsCsIXT9fsz4XBoU3D9wePx1LKgFytK
He3HWrzFh5urEIlLeDni1999mn4mqVpPKBQK5AhcLpc5j2Me1nq3d1w+f4DxmCQkZqYxNrGI
pmorEgYH6g414unAT/qo/9srUZZvhELhsbWX3e6rT2630fjUTTrx4gK93rmbFhZwFAC1mAy0
63QZ7b9WT6P+HhqZvEUvnWulHo+rAwA4ACg0m492nXIdDPv94HUjjrS3otq7E2yeAz5fJc50
tqCmwQdFA6yWAmQ0gpG3gVgqtTzEAIDNZmtx2GwD+/Y3FXWfVEBlEdaKXSjfuwdqhiApKrBa
jPg6HsbQFxnDzwdTwblIlyCIDwwAIAjCqLWoaPH773Rl+918lLnc6D4RhdO9hNcTKt6M5yFJ
TLC7mqGaNURjfYOCIA4DgOH/GBRQwnt99YCuQ0zyuNIXg/2jBmd5HfK3FoMzGCFQFvzCD2hE
nwUwt14AAiRWtmqx2mGx2gFHMdhtZdDWrU3hF0E1spoJdq1FEwQkKyQGY2FOcBRhAWldD+YI
KEGcEC0LZhkWG0sVY1RRlNlcAaVxoqezYF1dzhFkZDGVTqeFHIGayYz+mQ8QcNwarErZwowC
KT4XASCv3K3SsiwH5cT8lMwHG+w7aqwsGGRYApOzBHpaRjTwATPv7+n8UuixJMmDwL+BZX0m
ADCZTCV2m+1OVUNHG5NvZKTkAuK/xkRpOTWSFMVeSZI+A+BX+BzB/zI4nY6zBi7/ONH1ST6Z
7FVVdRaAthH8C1vLN+tQdL6MAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallDoItIcon
	"Private - Generated method"
	^ Icons
			at: #'smallDoIt'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallDoItIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallDoItIconContents
	"Private - Method generated with the content of the file /home/dgd/smallDoIt.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAAB70lEQVR4nMWSQUiTcRjGf/v8f/smihrOslFU
ZGYddokVtMtICkIQDGrGgjrGILpVhzQQOkRdqhV5iRCLwCJGIOom5Bzs0HdxBElKW21jUyrC
bYHbvu/fJUptwujSc3x5f+/zvC8v/AfZgOP/RDbWc+rZ4KF88Hq7BG4AKDWyDfsc6tTbxz0v
zx4pNG5tKkugAdBqgVvPndix8D10RspX2+SLwa7VtmbrTWB3TdaXvfs/fJ3yyuzTLnnVuycD
+ICmmmAhxJWHgbvy+Z3TZvsWLQi4gbp1PdVAVVXv2e12txBCJD6lpf/2mA8IAV/+MtlYsFqt
A6NPRi917u1kMbnI/MK8BNqqwWyMA/QNPxh+5Ha5MUwDW72NluYWi8fjOZnOpH25XO4dkNxs
gHNoYGi6v69fqRgVypUypUoJiUTTNFyHXa1Op/O8rusHS6XSOFCGP3+g9fb0Tvgv+OsUpfpr
WCwWOjo6EEIcAHatu4HD4bgfuBXYbtNsFFeLABimQfFHkZXCCnPxOWYiMwVd1/V8Pj8GfP49
GDgWfh2e7j7azfK3ZZLZJKlsikg0wmx0dikej8cMwwgBb4AUkF+bTKiqelERCiPBESbDk2Ys
FvuYSCSiwDigAxmgVHWvXwl2KopyzTTNIjABvAeWAHMzaK1+Aq3csxjBiXwaAAAAAElFTkSu
QmCC'! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallExpertIcon
	"Private - Generated method"
	^ Icons
			at: #'smallExpert'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallExpertIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallExpertIconContents
	"Private - Method generated with the content of the file /home/dgd/smallExpert.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAACS0lEQVR4nJWRu09TcRTHP+1tL33QVkjB0lqN
QABRiiE6SDCEElJcYWbV4GRSw9zBP8BFSRwk6mCiI4Mp0dCQaHwwgQllACqlPEIfVOhte3vb
n4M0ImICZzq/c36f73lJnMHehJDfRiiLGW44nGRGfMj6swjU1qObfoSHNWJ2lcZ7z1B0p4W/
PsEraTR61yg7BWHFwsRKM3On5X0+Jx/uXiM3NYRYGuPTx4c0AvyvAxm4CnQDWeAxsNpgZrLX
w/eZH9ieB1GlFRZOgseQSNY214pWf6twd7oFIID3wOXDP9dDIfQCdMc7eMo5xj13PPR099Du
biefyBOdjyLbZcIvw0qlXLkFfyobjsCjyIxzG1wXXTTVNdFyvoWOng7Mo2ZiuzEKhYJl9vXs
K+AmoAIcPeMEV8BoNVJjrMEsm7Fb7HjqPbS526iz1jEwMoCl3uIDAlWoKmAAfDRAqVyiWCqS
V/NklSzxVJxoIkrqIIWiKji8DoDe4yNYARPy70fyZ5LN9CY2k428mscoGUntp4in4miSBuA8
LpAFVsjQghXWU+uYZBOlcomtvS0kvcR+fp+N9AaZRAbg80lLnGaVB1wAIQTLm8vs5fZwWBzo
9XqUosJ2bBttV8sB4Sp09IxmYJ4uOungXysAc0CW+8BkNSxVnVAopDcYDEs7iztdpa1SE4bD
7AEQB90XnXrJeWkqGAy+6+/vVyORSO4vgUAgYHe5XA19fX0LxXRxmzjFynJFsiVtCa/R+214
aPjF4ODgohBC1jRN8fv96UgkIn4BMVjYCuwVUJAAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallFindIcon
	"Private - Generated method"
	^ Icons
			at: #'smallFind'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallFindIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallFindIconContents
	"Private - Method generated with the content of the file /home/dgd/smallFind.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAADIUlEQVR4nHWTXUybZRTHf8/zvOVted+2g20d
HyV0H7iNKoMQYjKH06BeYMZ0yW6MMUanWZZl3hgJ6hKN8cZ4R8zUeMPVxqZibJaiDk3N4iKR
6RrF+MGoVoLCaKFQSj/e9/GCQWLUk/wvzzn/nP/vCP67RE/fiVBJy0YhVFjjNCJkWGgdRlPj
ot+4Gnv3KoAB0H3kmcNCyMcQIlpftzWyvWbLjkDANoJ+P/5gEL9l4fdb2LZFavomQ8OXLaAH
wDh05NlD1T7v5/1nnpLhyG7KWrFadMivuRSKLhVXr8vRLLjQ+0A9Qxcut29YlUjRsjPSKJt2
7yVfEhRKLlqDaQjsakXAt66gZRCoVgSDQXw+s/a+3lN1AFKiq0PbavAogeVV2KbE8iosn2Il
M0NidJjxRAynsIjfpyg70Byuw5FOFEC6iGU0WKbCVyXxmZJyfonXB55mfPQMHdEUzduucenc
cUaG3sRraJqb6tBKRzeOmF1ZLeCtEiAk2tU81/8kL776MMuhEzj4MIHHD6aZ+Pg1Xn5pgAN3
9yC1WHeAq7OrqwU8SmIagtjIRY4dC5MLncTBt5lrtrydrwuPkk59QqmwhIbbAww9t5DNYSjw
GILkjevcdfAhXDz/AKNUqpDJFWnr7mF+Ng3QCiD9a97f5m5lXdd1MaSgUl5Debz/IiuzuLJO
mBnAUAKPYdTc03e6Qcbjg0XXdWf+mltASUHbgXZ+n/wK0JvNi0t5Pk18h1KS6esJOjs7CTeE
EKLYKm+Te3Pmz3mEgEeOHuWdt8aoL8eYncsQuzLBe+fHWM6vcXZlhCcyaWzbJtwQQmoZVQDN
d3Tee+e+XR37WyJYlsWelg7OPv8CkR23kB6TptoCkeIox5Vm1+EtDH14nsk5m+VC5QsJoKWY
mpmd37Tc1dXF8KUECykv375/kYkPPuLHSQ/3f5bm59A++nsjTI1fyJTKnrcNAIX48to339O6
dyeZbI5fp//gl+k0qfSsUy7X/gQ6mc2SrNq650Z737n9r5xqG3B0YWwiPpgTG1u7+06eBvdB
NFMgk+Am7Yr5Qzw+WPyflwfgb70YMA7AGG7WAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallForwardIcon
	"Private - Generated method"
	^ Icons
			at: #'smallForward'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallForwardIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallForwardIconContents
	"Private - Method generated with the content of the file /home/dgd/smallForward.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAAB+0lEQVR4nL2Sy0uUYRSHn/POd5lRZxTLLhoJ
JUGBUC2SZBQX5SaCKKN/wUW0yYVQ9BcELSOI9iGBG3fdwJI0SKIgWgiZ3fAy0/iNOt/tPS00
W0hGi/qtzuF9n2dxzoF/nXzRP1RfzJ763btsB+dO5tqcjH0LNKE8sK5zeeXpyrctgoZits+g
AyC7FFtVZBnFiHDB5KS1+XQd38fXSMpaBoaCZ7V7m4J8b64bax+5zZksDmio2EjBruvrO31a
+goMHbnB9TvDlCarYLkbtIaDjJBKoce/rcLg4avtnG0/z+7cXhzjUo0D3pSnebk4QWQjulqK
HGjoYOTJfT6MfkFTRoNyeEnyxeykuJzYd6UJz3jsybXhGY9StEgpXNoyl2Z/Jx+nPlN+uArC
TQexqcZC+DWmZmOW9T2IIAYkI4gnuE2ZTUEpXMTdsdEreUfUfFKUpGIxPiiA6kaxHuMJmTqD
xkq0kFCZqAHME3nXHFXGEC6WxlZ/rcZdB0xeKHT5RPMJxhfSNUs4mxLOJRWj9kxlKlgSgMYe
93hqpcOIyaI2tUJkVNpUuNVwzMNvdxADtZmE6usoEDX9y8/XXvzxkApFf1qFo409WVbfxSQL
6ZyIPVcZj1/9/JPZTuDvd2aBgXA2ceyKPlbj9gfjtZntmC1p7PYP1vd6nX8F/df8APkKy9tN
EDE0AAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallFullScreenIcon
	"Private - Generated method"
	^ Icons
			at: #'smallFullScreen'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallFullScreenIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallFullScreenIconContents
	"Private - Method generated with the content of the file /home/dgd/smallFullScreen.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAADIklEQVR4nH2TTWhcVRzFz//e++7Me+1MxkxS
0jR0nJZSbI0am07c2OomI7HrilB0GVy5kJDtZJNVEHQTcONKF2otlGmUEhoQSUtClTAWalJp
Pmtik/l47828efM+/m6yiFA8cDaHw1n84BAAMDNNTU2ZWutjWmsrCALDNE3HNM3q+Ph4gP8R
TU9P90oprwHIARBHHBJRi5nrQog9rfVap9N5OjEx0fzPwMzMTG6nuvVp+dmPH/fnTiad9ebO
Bxc++uVIJwbgMbMNYJ+INpj5t8nJyS0iYjk6OnpybXf12vbQ6mU+7xvVf+rd/UFuP22mIyIC
AAagiShFRD1E1EtEpxcXF7PFYrEq4ji2rIRFkR3B3nBx7t08/dS4ddULvB4AJwD0AegCoABI
Zu6N4/jNOI4vM/NZRURGvuesnX80uOqppvXEezLgd1hpqWMAICIJ4DgzHwNgA3CJKH2YaUVE
YcJIBO+9+v5TIQQeri+5sd9OLMz9MAgiYZkWeW2/menudc9deH03ne5yD9n4YRiGKgzDkIg6
RGQws3Xp5YKz8uDeqTvz91PKMAAAraaLysoy5m5/f/Hu7Tsbr7w2sjmQO+MqpTxFRB0hhB/H
sRRCSAAwrWRi6VkVXzeycCKB00kTQ6cK+OSzM+LDG5v57779Jr8wd9MYLFwtKwCNKIr2AdSZ
uYuIglS6S246LsJAISUktpvAhkO4K9O4nu7D8PAw7IbTr5RqKc/zqpZl7QA4OKSuojDg4ypE
MRWhS0vUgwjL+y10AFTaBoa0xt+7e3YGmQNRKpXazLzGzAfM/JiZ9xzb9nuojazyICMbL8kW
BlM+BgwbGdmElBLr61vPZ2dn6woAMpnMSq1WSwohiswc1WqNR1lCIYyqiEmCmZBLCJyQIZIc
od1qot5w/wDAEgDK5XI8Pz+/OTY29lgI4Wid6Cz9eq9QvPK2UtyAZBeafJjko08aqCwt88KD
Sqlet/+iFz2sVCqpPysPz9vV7a9G3iqMvDF8SXZnMxBSI/Da+PLzL36/+fP9dwDYLxw4qouA
drK4EofIsYBBgPLauHXgYQcA/gWOnHIlydMKjQAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallHelpIcon
	"Private - Generated method"
	^ Icons
			at: #'smallHelp'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallHelpIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallHelpIconContents
	"Private - Method generated with the content of the file /home/dgd/smallHelp.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAABi0lEQVR4nI3SzUuUURgF8N87zmQmQh+mFW2k
gpmMiGoRLVpGi4hAQoioXe1atQj6AyLIv6RN0kYoCoKCskxsyoZMB2IKEyccpenD6bZ4X2nS
d6QDD9x7Oefc5zn3RlLQz47AiQadeFliIo0H2eZNgYs5rp7m8AGiNowgYnSBS5+ZbGVkL8fO
EsqE0FQNwm1Cgfcb6Vuta1tZVKl0ce4C20t4gBx6knrB1iVyCzzC8hoD2EDlLidf0fGYHwWy
ecxhCtPUqoziy4om02xQZvgth4rcypM5k5w/w6+/tI6WIUIf3Ue5MkQuwlO8wwzqjGGxRYwx
zlP7ngQ4QrhBGCTkKeJUPOk6HWT41k7XQ3FaRXxgbJqb4v/wc12DEh/n6J1BDVOMl7ieiGdT
LvwX89wbZPm5OP2I33iTJmbVM8JXJqq8Dhw5SOc8uQb1RZ6kGaRiHwPjSZCThON8wp407poR
EuzfnCzasYVtWXr/u4Nudg6wdIdwjdDPMHancaNWJpvY1cPlOpVZ7qOcxvsDkT16QO3FioMA
AAAASUVORK5CYII='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallImportFileIcon
	"Private - Generated method"
	^ Icons
			at: #'smallImportFile'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallImportFileIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallImportFileIconContents
	"Private - Method generated with the content of the file /home/dgd/smallImportFile.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAAC3ElEQVR4nKXT3W9TdQDG8e/v5ZzT0nZ9oV07
trJWoXRbtzFf0A0JzCWLUW+4MyZeSOKdN0b+Bi9MvFZvMAY1cRgTIUjcYoyBMDSIAbpp5hTW
bo4Xu5W6du1ZzzleOBMjiZj4/QM+V88D/zPxwmj/CMoNt20v4eFt7Yj4Zk5OX6v/V0AL4Zzo
zYb3ayV5dCzJwvya/VJr4AvHdj9B6TMfXbi+/m+AGs50jr/5Rqaw/2AvP87dQyuhXn61sK8r
HTjaqLeO9+wIPjWwe2egL5Vanv/17sZ9QCEd3zvxhJzY6ZbIDSWo2xYLlxZ59mmTsSNd8smJ
zMOhDt/zv9ear2cj4cnBdDzal4kszpfWGttAIlwYjL2YigpUq0ZnX5azp1c5OKww7RodboV9
D2mOPNMjhkfTacPSkys/118ZSMXOFVcqt1Uhm2rG4v7XBnIBkAZoE7MjxPsnb9FoKrq7A5jS
QTdrxHSVQr+fZC7tu3zpVlexXPlYFZfu1HJd8WOHDyXDSAPZtkmlgxwY381GS3N+tsaVa02k
YZJMBpDOFok9u/h06ob3w0prSgOUbmxMVTeN45GgCZ6LbjYxvAaP5RUjQxnahp+Zz26y5To8
MhRCuC5aKRPaeQngIk9/f30DT/vwtB9P+3G1H4FGt2x89SqTR7PMXqnj6gAg0AYGYEgAZ9f8
xbNnyuvNtsJTBp4y8ZSFp60/UWmhbJv+kQS/lLcAiZLCABwJcOoUTuVu460PP1hksy22EQNX
mtuYiXQFB8aSXC3eAyHRhtIgWuqvQRTLlfMhx6p8NV0+tGm7ViTuJxi2AAlSgpAoKahUW/T0
hvjyXMn+7qf1E+rvq5pb/u3b/u7UO8Xi7cXpz0vtby6uRitrrSCGJBj1oQ1JOGbhSfh6etm5
vFB9VzzoLKO5TD5oiuf8Pj2e74s+nstHOrvTQd57e255avbm+AOBfxTYk0wOxkPm2GqtvrR0
Z23mD9YOClDTtmV4AAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallInspectItIcon
	"Private - Generated method"
	^ Icons
			at: #'smallInspectIt'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallInspectItIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallInspectItIconContents
	"Private - Method generated with the content of the file /home/dgd/smallInspectIt.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAACX0lEQVR4nKWST08TURTFT2f6nyntlJbWAq2h
BYxUSAoblBg0rsTECiEkfgANSgyuXejaj2CMicaFhhhdINGYKAYQYjUYTG1EBIZph1JaSodO
W9uZqSvISAYT41299847v3fuzQP+szQHD3wNtf2+o9Yhu03frNUSBp6vrJZF6cnUNPtCDaBV
rG2dQef9sZFQX9/p5oLB6lmRqwa+xDMdk5OxS5IoR1bZ7eF4vJhQS0C1+unx188H+yr0ufdr
5LBBeYkqzZXq+YehkbFX62+mmB4A4p5GAgBNG++8fBo+L3kGp1lywHww5qZA10wu6G03wnnv
x4VkY3JTmNjTCADobHd2N3rdCY64YFHrsyLJBJu1GCVrx/LxFnuvUiMAWNpa6LqCxsuqmQFA
KPzSAcDiRqPJ5TI7AeiUAKfnCAVJY5IOA2R3BCMAVGQ9HLRZC8CqBKzMRzi+prrmUDOn0rwp
9oN1AUDAniww8VwKQPqPGURjmSW5lAlZq9Hd/b5FiYgtJ+xvZ7/6RVEm9ZDELvMXOs7ll5QP
kACQ48vR+chGz/WBYluy4E7PLPJNc5+WfCyXpiVJJkx6qXzv2ShVM/7ZzpxsIKKxbEQoivF9
AICdrUwpOheJnxnqSXV1eLitOqpYDjhyhXDw2+5F7yxtybnNuHqC6KV4K6MznF1niu+EUjl1
8CvbAs22260BOuRxU26djtRv7xQTCS4fJQnNsYkHV05RmTRZZRYrg4/XuZ+s0H7Y4PfSEYq9
sdVPP/o+c3NXmr8s3r3VnQoG611/A6iW02kaDff7P/iaaq/9s1mtfgOeOPMUwSrvxgAAAABJ
RU5ErkJggg=='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallJumpIcon
	"Private - Generated method"
	^ Icons
			at: #'smallJump'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallJumpIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallJumpIconContents
	"Private - Method generated with the content of the file /home/dgd/smallJump.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAABxElEQVR4nMWSP0xTURSHv/amPFoH+3CywHsm
/puMYmqT4i6ri5sMDjI5O5hoSERnDQ7EzTi44aARNakhYgwVl4YoRojyoOIfiNFXS9vX3ncc
4LWUPDVM/pKT3Jzc77s39x7434mENS/BXgUDyoidrAlx7dWfJ+DhMKz8U3AFBpXRMdadPaKs
zCEDv8bSqzlvOT/Ph1rj6l0Y+eN1LsPZ63t2Vxcnb4t4OZHKfZHyHRF3VBYnzss1s9M7DaNb
GRUshiGljI6ngw9uxu3+A6BL4LvNSnZHsdKm+jw+f2xNy+tVWACIBgINp3qyR6N2/37QAVhq
ibSLndmFnTYbKRgKuKYgZsSyvZmDnfilDXATaoo2y+pLxHtikX1Ask0gEEG8FqRDRNpFfA+Q
CtDVJmjU6i+X8m+9JuRvF230PxV+lp0634Ev29/gSTH/XpwXhRakt4pcnOlvODNVNQezwHrb
L0zBr+PaX1149GbAOmGqZEpaJ+sSzvRX7g2tVJ6VZWIWbgBroYN0Di72GmrETndpqy9h4HsU
Cz/WnZmqmvLkcQ5uAblgf+gon4HDGi6YsUhGg1Gsy8d3MFmEcWA5jPlb4jsFdpTfSTvti4zh
egUAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallLanguageIcon
	"Private - Generated method"
	^ Icons
			at: #'smallLanguage'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallLanguageIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallLanguageIconContents
	"Private - Method generated with the content of the file /home/dgd/smallLanguage.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAABlElEQVR4nMWRv0sbARTHP+bulOCQwaQnauoF
rYGiDpa2Wtupg7q5Fsng/+CmODqUigouDuLg4L/goCBxiFkEtRXj0CVNuWhE6cn9MOZeB1NI
S07qlC+84T34fHnf96DRaqozawE+Aa8ikchLTdOaS6XSN+AY2ASsxwxTuq7/XFz8LPn8d/F9
V0Q8Mc28rK+vSSJh3AAzgXBvb49/eVkQEa9u2faNDA+/FWCu3tr24WE2EP5TppkXTdMEeA6g
Vg3eGUZ3uF9R+PVlCTXehZowqBQvENtG6ezAy2RRYlHaPrxndHSEvb30R2AjVDVwXNflLneO
1vcCpV2n+c1rymc5lK5OvEwWymWaWlupFAo4jgvg1EZQAHN3Z1tEPPHvbh9Wrjh/974r52cn
EgqFHKDt3zsM6fqz61zua2D+YvGHJJN9LjAe9AkjHA5nVleXxbKuxPddsawrOTjYl/n52fto
NLoF9AfBAKiqmj09PZJ0elcGBwcqwA4wCUQeBauKT0yM+anUlAesAPH/gWo1DSwAsaeCjdNv
pz0BrfQjq7kAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallNewIcon
	"Private - Generated method"
	^ Icons
			at: #'smallNew'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallNewIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallNewIconContents
	"Private - Method generated with the content of the file /home/dgd/smallNew.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAACb0lEQVR4nI2RzWsUaRCHn3r7ne6e7p5MPjTu
mMRE8bIOe9iFsKwiePAgQcGFBW+aYy7e/APyXwQPe9uL5CJIbnszgrCw7IQISr7Nl05kY9Rm
ZpJ53/LQKIgfWJeqQz1Vv1+V8I24dH2y98iVhowJhsXrsBcdBjmuav569GDmMYAtGqfGvNM/
EH6Kk2j05OCxU0kS1yppEvdkKZVKRpYlVLKUl81X3Lv/98/ABQD57erUkBVduHljov/X8XHS
ai/tQ8g7nrztyDuOI6c4p3Q9XK5H/H7rTuvhL7WM6WlvrLizfb2V/omJK7hSD/u5J+84nPNY
K1TigJ5yQDW1VJOAUlSmr1opn/9v53RhQSQ7MTiAKqRxgPeKU3Be8b7IH+quV7pOGRup8Xox
rwMrRpUDAZLQUA4N5ciQhIY0MiRRkbM4II0NQ/0hWRwwOlJD8fVCgdVm3moTlQxOQb3iFbwW
W70qcWioJpbQCgBjIzWAc8WAQ7uX5y1KgRBZQVUKWAVrhCQy2EA+ee/o8A8AdQAzPzfz+s3b
vCOilKxQskJoTXG8JPgMBhg7VQP4kelpYwA96naf/79/gDWCDYQ4NJTs5+CHGOirkibl+NK/
zTMGQGF9e7dJYArZ5uvsJyqcuroBEJWN7Rd7iIB8BwwwUhsEtBighvXt3VffR1J85uBtjogJ
LYBR1nde7H2xud3usLKxw/LaJkurmyyvbbG6sU27c9gQCf60AD5w/yw+W+0uPl2x7/IWK+tb
LK1usby2ydZOs6WqT0AXvNAQrw31dmF+7u4+wEfHF69NTSJ6G9hFpCHogvHaOB7vL83Ozrqv
2XkPgdkFGpcRD6AAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallObjectCatalogIcon
	"Private - Generated method"
	^ Icons
			at: #'smallObjectCatalog'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallObjectCatalogIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallObjectCatalogIconContents
	"Private - Method generated with the content of the file /home/dgd/smallObjectCatalog.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAAB9UlEQVR4nGNgIAxYGBgYuIlQhx2YqrNFR7hx
bcAlz4xHL6OiDKuZkQZbUUMynyM/N6MTEyNj0IMXf1cQZbOICINkuAvXpR+HpP//Py7z/9Q8
sY9OJuye6OpYGBgYGMzDC90EBHidYIJ//zIw7Tl7unvlnu1mJhqs5xJ9uDXff/7HdPvx/8dY
DZCWFvVZ0JSbCxO8dOshw57YS8sYGBgu7D714+/eUz/KmJmZ5MSF/hs+fslwBcMAfGDXqZ82
DAwMH3HJMxEyAJ9muAvevvt0o3ry0o0wwU9ffrAzMP9F1RjKwMz7gtPCwFk2+8e/X/qnDz3Q
ZzjA8IcRh8EcDAwMP5AFzBtVXnOKcIs8f/jxJ6vQX+an+94Gvt/1bQuKF5zZ2ELS2LhOVLDz
XvZg5VjAwMAAt+A/4//Hl3bf2nfz1AOeL/e+bWNXZS5kYEBNSMzBrFwLJ3EKmrqwcgipM7No
nfj748ar//+vCbow8P/48t+XRZxRk+kDM9M/1n9ZXCpssh/Yvnchu0BGg4lZHsbRY2ZlE2Fg
cWRgYGD4+4PN6zfLHxdGDiZJxn9/bzFzMj3+cu7nKr4PaHkkio1r2zt+qf9/BWT+t3HyvRVn
YFBiYGBgYDBmYOWz5YjhteO0YgjFm/wZ+GxZ2Ds9WdhXq7CyWuBTSDUAANeVnXOvNaMbAAAA
AElFTkSuQmCC'! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallObjectsIcon
	"Private - Generated method"
	^ Icons
			at: #'smallObjects'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallObjectsIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallObjectsIconContents
	"Private - Method generated with the content of the file /home/dgd/smallObjects.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAAB/0lEQVR4nJWQXUgUURTH/zN3ZnMGbXcM+9AN
spaelETtQyLbsiWofAjspYwegggfpJ6KoqjH6KEEeyjDoBfFCvbBqChZiGJD7EMa66koQzPX
zf1o292ZuXN6aWSM2KYDl8s55///nXsuw+/wAfW1jO3LEsEGZvA/sVGSe64qgXm9YgXdVLTM
dubr92xeDmnrdTWQokCQnBNVl+VCjLV78YvVIsJ7JMXvLu6Uy1RNEHd5AiQEGn/LDcNdfG+b
dpZs/S96bUOtvGkRYIrz4cvFH09GedEiADo37bP5THzVga7pyMETDW5xS53v+Pq18i0AFU5N
cO56Ue5SBWzOEY3rttUDwAp3ngxJHI0kGyMjt69Rxw5lqO+M1tZ5YX6MCZT8PGu/8bImGuuq
hi8e0+bmHlYTxYNE8SDdOK1NhWqkFk8AAFq4SYl9uLfScgC7tyy5CwDMI6CwdF2EKoVPrYwJ
wkzSpi/frMLoO7NPWpA0tavgzLfIZso/MXHHiBzqbnv5YGhsIJc3++/nz3/PcL3KLx4GUOZ8
Iho6uqN7tzU3O3kqm2OPnr++tKay/IXAjcnHg70Jvx+r02l8dM9YeIHmL8epo/trnHzyawLP
XulBblM2Ntg7DQB/mgFALLW4ZSMfG7gyUUpTEkBE6VJ9wLXCbDIVbT1yLuVuZgrFp/8C/AKq
oMu3BdqijAAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallOkIcon
	"Private - Generated method"
	^ Icons
			at: #'smallOk'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallOkIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallOkIconContents
	"Private - Method generated with the content of the file /home/dgd/smallOk.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAACF0lEQVR4nKWSz0sUYRjHP+/7jvuOuzMbq7uZ
lkJESlSHLoExkAmF0K+DLBV0S5I6SKf6EzpVHrpU0LFLaZeiLh6KOXjIS5FREpUIi9oiOuOu
M9vMdHANEYWy5/rw+T5fvt8H/nPEdiDb0XuAPuCJsQ24E3BlWhSiStwl/xHOAS8a9xmFQr8N
0PTXArajDeCZblP7m89YeBMrCMQjo748DlwGXntuMLKFxn1lyd7mcxbhfMTyZDDuu+G4tB1d
lFqMNXY2DMhG8dh2dGGT60MoBpvPZ5CmZGGsgkDcA5DA1ZaLWZU/a5E9ZmaB4ga4D7ibO5lG
7zJYdCvUZqNvwMiqgKRruO8hQwduYR02MfLqeh0UtqNvAM+tIyllHdRUp0K8d0ECXPHcIAJQ
ut3omcl/7ZpTJeaCEjLFzjhMssBN4FrmUMrI9Wb4tRQxP+pDxLDnBg/WHCrdYewu++VTXkcZ
gIYmg+VPYXcSJHuz3Sa5E2mIE+afekRe8gG4EE5H0ZqAsB3djmSqbXCHVunVVmvliCSGVEFB
DD9f+lS/1H4AjucGM+szUuF0tKTbjRZpyqOpVoWQApWWSFMghKD8yqf6uTYL9Hhu8H1jQ6Ie
WKtI8TFfzOSIBYgEoQT+REhlMlyow+83ew4J4LlBKQm5tPh2JZGmQCSSxTcrVCbDEnB6K/iP
g3Wd96uMuB1V4yqxGAXueG7gbwUD/AavXL0SoSTm+AAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallOpenIcon
	"Private - Generated method"
	^ Icons
			at: #'smallOpen'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallOpenIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallOpenIconContents
	"Private - Method generated with the content of the file /home/dgd/smallOpen.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAAC3ElEQVR4nKXT3W9TdQDG8e/v5ZzT0nZ9oV07
trJWoXRbtzFf0A0JzCWLUW+4MyZeSOKdN0b+Bi9MvFZvMAY1cRgTIUjcYoyBMDSIAbpp5hTW
bo4Xu5W6du1ZzzleOBMjiZj4/QM+V88D/zPxwmj/CMoNt20v4eFt7Yj4Zk5OX6v/V0AL4Zzo
zYb3ayV5dCzJwvya/VJr4AvHdj9B6TMfXbi+/m+AGs50jr/5Rqaw/2AvP87dQyuhXn61sK8r
HTjaqLeO9+wIPjWwe2egL5Vanv/17sZ9QCEd3zvxhJzY6ZbIDSWo2xYLlxZ59mmTsSNd8smJ
zMOhDt/zv9ear2cj4cnBdDzal4kszpfWGttAIlwYjL2YigpUq0ZnX5azp1c5OKww7RodboV9
D2mOPNMjhkfTacPSkys/118ZSMXOFVcqt1Uhm2rG4v7XBnIBkAZoE7MjxPsnb9FoKrq7A5jS
QTdrxHSVQr+fZC7tu3zpVlexXPlYFZfu1HJd8WOHDyXDSAPZtkmlgxwY381GS3N+tsaVa02k
YZJMBpDOFok9u/h06ob3w0prSgOUbmxMVTeN45GgCZ6LbjYxvAaP5RUjQxnahp+Zz26y5To8
MhRCuC5aKRPaeQngIk9/f30DT/vwtB9P+3G1H4FGt2x89SqTR7PMXqnj6gAg0AYGYEgAZ9f8
xbNnyuvNtsJTBp4y8ZSFp60/UWmhbJv+kQS/lLcAiZLCABwJcOoUTuVu460PP1hksy22EQNX
mtuYiXQFB8aSXC3eAyHRhtIgWuqvQRTLlfMhx6p8NV0+tGm7ViTuJxi2AAlSgpAoKahUW/T0
hvjyXMn+7qf1E+rvq5pb/u3b/u7UO8Xi7cXpz0vtby6uRitrrSCGJBj1oQ1JOGbhSfh6etm5
vFB9VzzoLKO5TD5oiuf8Pj2e74s+nstHOrvTQd57e255avbm+AOBfxTYk0wOxkPm2GqtvrR0
Z23mD9YOClDTtmV4AAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallPaintIcon
	"Private - Generated method"
	^ Icons
			at: #'smallPaint'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallPaintIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallPaintIconContents
	"Private - Method generated with the content of the file /home/dgd/smallPaint.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAAB60lEQVR4nJXQT0iTcRzH8ffze/5srT0zNvqr
KM42JTskoRJISVARCf0RCTp4KCMhELpJx4gQomNBl+jgtX8QnQorqIyg/5atpZmOlk62PXPP
9uCz5+kQ7bAObd/rh8+LD1+o8cJwIgzDgKi1S0Qw/Gi0wx0f3O62wAi1KG0Q6tu1/nLnnr3o
uh8JumoCXFmMjZze56eYxgYcyFQNNENTT7v/VKi1B4w5Vl0AFqoGBAwdP9IlIWuQX8SyS4hq
gV5QhMTJju6dsPwJcFk2TFyYrAr4AQd2tKzd4tkQhdQUpVVIpsylbxCvCpBgf19vM5hLkEtQ
tFzeTqfu/M2V/wKStNsQIV6+eMNWbN7FinxdyI3/AwyAvAbOBED9CFcfgw2gB4NqtP88iqZx
/d5dpiZuGrPwvAwcgnA9DM7Bg04YC4DPgM3AaBgiqrAablw6h+INkU1bzvRs9ixQKgNe8Ot/
kGPfYTIGFySYAVCFGDrYHq4reSQsJcur1x+exaE8H0Dcgvef4WIaMl7YdhSeKnA4At224yS0
lE1jRqHekPFpmlT5IwXAgTYVGppgXStIebjWHNy0uNGr1+krwowWPL77TpKcaV2pBGSAOHxp
hPwvMGMQL8D8z8KKFdACqt+W1du5+YmHyUT/DDypBH4Dwguh75kYJgEAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallPasteIcon
	"Private - Generated method"
	^ Icons
			at: #'smallPaste'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallPasteIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallPasteIconContents
	"Private - Method generated with the content of the file /home/dgd/smallPaste.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAACpklEQVR4nHWTPWxTVxTHf/f6vuv3np/TJPaz
HTuJgdBEoqGoWyQEA4KBDRgYmECRYIxgR2Jh6sjEUlWt1KlrhRgqJlpEJQZEA0kAJxFfMSTg
b7883/c6OJiv8h+P7u937jnSEXyW+fn5g5lM5pxt29MbGxs/jl6/fkfBLgGTBu5checfv1cA
V8CO4BgwW33y5MzY7Oys7/u4CXGIE4fZu72GEHD7j7V7wClg7RMBgr/mznz7Q3uqyKI6guu6
NOrvKO8ZpyZyzEy0GC/nWfr71TRbweQXgnTePTBzssDLapu4dpNcGDJkG+IARFEQGkGjY9BT
JW+/nzk2vmfu7o0b14IPgpwTtbtGuo5kyulR2fS4VRmig490Clgpn1SQYXRhiLPN5uWffv5l
BLgEhApACiKtLXoGmoHi1uZxLl46jxGa7TAiNAAxQghy6Yhff/t9GhgGXiuAsBsZbWuCMCYO
FZMTExihAdCWRFsgdmZ2nSQ53y8DqY8EPaO1ImH1sIwkDgyulgPqPZyQAkdLypOlsR1Bfwet
t0EjmVSeshRJkyAyBlvLASwEOFoOamPFQtr2hjPd5jskQKe+XYnDGK0Ved/GmB62JbAtgZOU
DKfUAAYo5bMiW9w1A/QFAtZb1Q6ea1HMahr1GpaSaCVxtEQIPkmp4JNKj04BQvb3y1rrdZeR
b5IAxNtvUAmBpT4jd1IsZEkm3TLgvhesNzY6JGQfsKIt5P+zAAylPZR2soCrABKwWn1c63eP
wY3qNJpt0p4LQLPV5uHyKv8uV1hcqnD/waPq1qvVP4GugP4xxVKsFPeNjG+uNsLl4d1vChcW
xjzPYfHhSnP58dOVTqu+FLRr/1RfrN+ubz57BrwF2oNvXQH3NBxNwfdA6bu54wfzpb1zQAnw
vjbOfw2z5rrakfVdAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallPrintIcon
	"Private - Generated method"
	^ Icons
			at: #'smallPrint'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallPrintIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallPrintIconContents
	"Private - Method generated with the content of the file /home/dgd/smallPrint.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAACSklEQVR4nK2SS0iUURiGn19/RWcaL/xjVgs1
GoqZEhuHoSItFDFcVaDBhCGtrIUiWlEobrqtJMXLRIISgQUt0o0geNk52iKELMRAUsrFEOoo
+IvjnK+NTjoZtejZfJvzvuc5F9iLFfABz1NSUmZ0XX/DP3IM6HI6nWv19fUyPDwspmlKYWHh
JpAJJPwpGLc9z7a0tNweHBw8YBgGzc3NVFZW4na7E+x2+6LX610DavcriN+eZk5OTq2madTU
1ODxeDAMO4FAgNTUVG1iYlLf2NgoCwTG44Gx/YqOu1yuiN/vl4KCAgHEarVKY2OjhEIhUUpE
KZGioqIt4Ohv6bS0tO8NDXdEKZH5+QUZGRmVYDAoSimJRFS0oLW1TYCm2Hymz+eT2dkv0tXl
jy6ORJSEQqtyt6pKFuYXRCmR9vYOAV7GXmJufr4Hh8NBdnY2pmkCoGkaaysrWG02DLsdgHA4
DPAj1qBudHRMlBLZ3AxLf/9A1GK3TU9Pr5zKzRXgLZCx2+BIYmIiALqus76+vqd9aGiIB4+e
ojvc3Ot8Rd3jZ+Un8vIXgdfAuTigraKifGlubi6qaZomL7q7uf/wCcGkDPJKLmNkHgbg9PkL
eC+W6PG67gSSdza6brFYvlZXV0tpaalkZWVtJSVbVq/evCV949MyMP1N+sY/SVNHrxgHD5lA
J1AMpGu7jnISKAMswEcgBFzRNO3ameJLGavLS3z+8H4KaAcmgRkgslOwQwKQDiwDYcAGuIAb
gADvgClgKfYl/oYNcPDr6/8/fgJnMgqt6rM6ggAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 23:00'!
smallProjectIcon
	"Private - Generated method"
	^ Icons
			at: #'smallProject'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallProjectIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 23:00'!
smallProjectIconContents
	"Private - Method generated with the content of the file /home/dgd/smallProject.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAACtElEQVR4nKWTzWvcZRDHP/M8z2523eymJiaw
Se0KLdsXEfRifSsVoafA2ksbbEErUigFQYT2UEHwIoIXPRS0IKJCc+mtoDb4EiWKQokgIpLE
pDTbpG3S/rpZdjfZ/c1vPGwa/4AODMNcPvPynYEHNAF4sXJ6Vyz6nCTWbyLOYWLgwImZiQgO
MxERZ5ggIpawGjL+y3Cgcur5VI+ffGpvOTw6PESh0Es+nyWVDrjgcEHwzuGcI3iHmCO6W+fy
t1PMX19+OCA8PXb4UHjl2CHWbQM13fIEZeKrD8kW+hl+4iCDI0OIF4rWy2MjR3j73Y8fcZjt
2LOnRMvWiS3+H4DyxQdneDIzwWjfp0yPn6PdaaNJTNs6WE8MQBAh3ZvPUr21yuzMMiE4zIxU
zvHy6XP8e/E4q2vb6C2W8WlPjJKYYj50AWaknBdu3anxTHk3ffmHALjyx1XSuR5WBo+yf7QC
i4uoxaglKAredQEYQRwoylqjuSVPR7vjPFs5jJoyuGMYNSWqReQKOYJLbwLEGo1mi1JpgLmF
JWgqsSrbd/ZtVby2OM/F386zfPM2bVq8/8YnDPhtQFfrqFZrkEo7yuUhVsYvsfbaW/zz+lmq
f8+gpmQyGWZnZnmz8g6uleW7qW/I+J5NgBDV7jW67UUR/eNf8+r1O5y8OsfMhUuoxZz//COi
UOf7n65QXbnBtZvzOL2/g4SoVmugFpPry7Gw/3GmfpymOlBgcPQF1JTjR0+wuPQS+/bu48jY
MRKUjdu6CcCie3frZCXLWlLn4GfvsbRQZWdxiFQmTcc6lLaXKI4UiS3GzMj7PH/+NQdIPTiS
pYnJ32m21tlod2g0W5tnu0AInuD9VvT3o3dM/jqNOX4QQA5UTo0JtsuQNIIXzBt4DAc4Q1RI
1MwljkS7uf3y8+ULEw/6zfwHQM5Dmbx39hcAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallPublishIcon
	"Private - Generated method"
	^ Icons
			at: #'smallPublish'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallPublishIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallPublishIconContents
	"Private - Method generated with the content of the file /home/dgd/smallPublish.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAADMklEQVR4nI2SW2yTZRjH/+/7Hfqt7XrYbNcD
G2HKcBsQ2XADhwIXGKZithsTAlGIzgtDvHUa442nbHKh6OSKZIkiuIFDE2JIZlTEMbPgwiHB
6qYdYtt1PaztvkO/w/t6YbjQpInP7f/5//Ikz4/gf0z77sF9jAlPEKCVg11nhJ/57fLUbQAg
/9rshOwPu34SfULESDpH1Lanpzev8E8fXO9/Sn14IJOq7/A4yRtZ+7tJH7eq7yeunD8h3Ot6
HpO3KIrwlmer0v/cy89673qSh6TZ4vZDezoHTx6LuGKbHmg4HLhZPxM6ELF6Bn3Oz5faGtfd
f0tAN6TY9vsu7zjY9a60m20TYhyLegINsQAxArm2l9rWk0DrQ0jnCHZ6b2Ox2owEi1LS0mGy
+W+bRa9LfmXv0V19s8s/oDpvc84AX5dCcqt5mHkb55MptD5SjzP5bRAshiUWxE5/Cll3OHKL
kC0iYej9g/4KI2nz9FjlDU+33Cf66X7tpmlYsw2sd/SIe6OdgCv4KF5fG8CP7R8B5TyKKsfj
CjUpq+JKLp8DdRNCZTqHZePwXyOl4ZXT6q6maM+1DzOd6YuZrZivhKE7IowqwVeZLrw6wQsV
3Zqgbr85VprRNKZzELD2yi/I20U2AuAapXi+eu6489r1llSVCRhqnIOLVXD8m9LS97MLfzpe
/W3Sd2Cov04xx7KZRNOT+54xmtZFOSiIQAVQCrJ0J4Ovp68SmwqlpmCdbGmqr6SaU5pIjv0+
PVkSXYLcf+HsBxs06LC45c6mFrAydxKG0Ij4nqPYIW5EPBzi7536ImZpa7GFuJTExXPOvfeL
8XioJV0uoFLUwOHAoDJMvQzZ7wVEDotZgAx+9+qkDmDxv5aK4VAwslopQ3FcAASsMo7mwXdg
cwuFch5UFkAkwmppLq6puhaNBrFayOLOqbOo6+mAE9mMN8eHQRhFINiIXmmA1wLQbLaQAudY
OD2F/aOfwBodh8lMZNLL8JIGAATEEWtfkCuWUnrJxKYXDuLLSAjh7k54BC8+Hh6HzS0oVMHE
iRm1JsCh7LMXh0ZaGSAwzoDPb/wTUIFIkkhlSSRl1bhQC/A3cdNl1Xs1VC4AAAAASUVORK5C
YII='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallQuitIcon
	"Private - Generated method"
	^ Icons
			at: #'smallQuit'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallQuitIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallQuitIconContents
	"Private - Method generated with the content of the file /home/dgd/smallQuit.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAACkElEQVR4nIWSS0iUURTHf/fxfTNOPsZpzCxC
GWuqMSOn1yKIIIiIahPZoqiIilpFtAkiKIQ24aIWLTIICulBkG1s0SIsyB5aIkn0fmii1ZTm
aM5833y3jX4qBv1X9557zo9zz/8IxrR9eazIhOSVilgo6bqO1MJILQ2WzAklkFpBX8pTrR3D
vQgoyLNbShLdR/Q4IKOorz+7auuciCI3OsLAjzS/UmlSqWGG0g4AA20jtH/sjwAU5wcXL/Hm
vfcBlYvCydmzQuBmsLSiNBqgLAyy3MLJuKQGHV6+dsbT+ZUeVVnXqZXjAW1JxRQJ/2RbgrKo
zexIYEqG8dATACn5nzxjpsX8KimFmPaKmNLJP+onAEJNAhhwM55/zXmGxvtprFBkGsAfYmHB
DAFgPMPto4/oef6dDccWUb0+gpKCitICPn/xSCQSfvEMlUGchBoBl1RxaEl+vrLdPw7m5ygH
55dwb8Ahu0Cx7XScYL6m8a5L08s5PuBP75s2DZzZGLGTKzesw43OQvT3EmhrBWGoPbCHJzdv
cflQJ3svLMW2A1RVVfmAV4M9aAGlxdksv5ubMYAWYBQE1RBcPMdqren64dJ+p49AbCGJyokv
9HQ8Qgt4/TVDzagHxgNvbNILwxBU8GbAZSQaJLmllIdv84hNmsHDUB5awI0HDnND82auDEdV
MN0/TOzbMGIQtIRWW1GxfzUt3dWE42soKiqacMCy0KegCWi6eXz7s42bciv6nvbQuOMuEQte
WDblJ46xbPdhbDuAlBKlFHJs6dxsJuvb+OlDqqHlfigpdY2M7yumb8hhV10dM+Pxad4bz+NG
w/mhZx1dV6ds377Na3cWFoYPmEn78S+5bs48ft55rf1d9/W/IR3hO/1r6QwAAAAASUVORK5C
YII='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallRedoIcon
	"Private - Generated method"
	^ Icons
			at: #'smallRedo'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallRedoIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallRedoIconContents
	"Private - Method generated with the content of the file /home/dgd/smallRedo.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAACWElEQVR4nI2ST0hUURTGf/e+O/OqmXHEhLJs
FiItgoykEHGIiFoZtJCIoFYhhLSJCFoIrVtF5KooIoqCIqKkjUSboaTE/kApZYgzkjk4pr4c
fe/dd28LFYYi9Vtd7rnf73DO/RzWUCrrtroZddLNqOkgH039XRdrmNuB3vh2RVjU1oZcAbq9
nB+tvHFWA7gZdU/Vyu11p9Ik97rC+DYbTkZtbkY9D/LR4n8Bqazb6GZUF3B6Y0OMC0cvcaS+
nS/pAUStbSiPBIfdHephkI98UWESQAfQHa9Xe9wtDsm6BNRpYlWKvTX7aappprfwhMLwOFPP
yv1oe0gsm2uAPlUtm493dpDYupFPv97zY76ACS0yJhFyqVFMxglNgDe4yMyrhcvO8qzP3HS8
redqD31zvQyOv2VqokRQ1Oi5COkKZHyJYGyEtRYRE/z+6DepVNZtAQ6fu9jF/dHb5Atj6LkI
XbIsDIeoWgeVdlDJpXXp+YhgSrP4VSMQAwpolUmJqpYMvf6MKRtmXvrWePYJcFPPmBebdsWk
ThrCaY3xLfODPv5YNAycVQA7dzfyzRvGakswaTCeveXl/M7l/byz2rb4EwG6aJjtX0BE8gZw
3sv5ZQVMCCH4UBpAugKwAIWKX33kvfFb9Kz5aX3uCuQdL+cPrRQV0Pd9dMRsaa2STsJBVRuA
fRWA62HRDAC5ygSuSAAks/HctjPpNpkQLOQDSk/LnkBs9nJ+uFpSAeQSRVyb7isTlPTKvcMa
Mf9Hqaz7OHEgZlMH4zaVdR+s16cqziekkccwbAAerhfwB4uIABacJugRAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 23:00'!
smallRemoteOpenIcon
	"Private - Generated method"
	^ Icons
			at: #'smallRemoteOpen'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallRemoteOpenIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 23:00'!
smallRemoteOpenIconContents
	"Private - Method generated with the content of the file /home/dgd/smallRemoteOpen.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAADOUlEQVR4nKXTSW8bdQCG8ec/M/Y4XmK7djbH
DmkWnKR10qqkDUlDU1RUWgkhUCUEXFh64MwJKr4AJ6QiEQQSClwiSgKqaA8sFS1UXUKqLkkh
Kg3Z7MRxvMWOt7FnhgtIcEBC4v0AP72XB/7nxIvDPQOA1TDNUQFPCCHuA1OT1xZu/xdAMTG/
CoZcu7cSJZ483kK4z/3s9aupM6pNXqqU9XN/YrP/+uDl0Z5vPxjveypneLjyzRrS9jonn67H
dDUxOy+4cXWThbn0smEwBUwBM5PXFsy/AHlv0D9w/JA+7DPX6R5oZSsr8+B+jkgwR7s3w9BQ
PUdOtnvqGzzDhbx2ejujvRYJ+dsiIf/6/FoyIUdC/uZI/67nGr0CuZylob+XC+c3GBn0gGxB
1ivYqym6AxqjxwIcGOtw2x3WobXl/Ku9Lb7rciTkF75mxxvhTgfLWyqLcQWX18HnXyRAshII
OJEUFQHIpTwekaKnz0XfYJvy46X1fgWYu3yrujPxc4NT8fhobgkRXXxIR4NMUdWYmE4jTJ3D
B52EOx0Is4ZS2iEUasBWpwSV2/Ke9uaS1fbpW2Ey7S+g63ZWRRt3fviSc5cmGH+7C01R+f78
MkIRdHe4EGaNXMEkl9diklMV7797OqAEWj1E03n2WW6RqtToPfI8GWsb311O4ijlOHGqi5t3
y5gWO4bFwUa8glYzopLFohzuDDYxU9xNKb1FOlshmq8SK4F//ygzv0kgW5E0jWCnm800GIqd
zViRctVYkXYqRuFispfHLXeZ5iCvJJ7hncZJ3rR/xJiYRVUFurAg6fDYcBNzv25jKlbi6wVK
mr4klUulK+/dc6Z+ybQSrbpJaTaMUpKHcZ0LN7J0BWVQrCArqELg9tkwZIl4rEC2WF2Uyvns
meLXH1ZfmhvJFHQLr/tvUtVqnBpP7iRWl6q5RIaVWIGqkEBIdIY9aDWdjWhBX9zM/i4AWsKD
Y05/8Kzs8tofbVQ82cyObS2W+Gx17qdPDrU3Whw25cQur3p07x7fvu4ej9PjU/n47PzK9MzK
MfG3LpxOX2BAdbjb0tEHC6ahbwDxf6bj9u5/pG6kTrUciKWLCyvJ1MU/AOEYUfN6KK2PAAAA
AElFTkSuQmCC'! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallSaveAsIcon
	"Private - Generated method"
	^ Icons
			at: #'smallSaveAs'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallSaveAsIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallSaveAsIconContents
	"Private - Method generated with the content of the file /home/dgd/smallSaveAs.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAADIklEQVR4nIWTXWibBRSGny9fm37pSFqTNOlP
6qJrsv5gpRR1izqmjG2oqxeWug2ZDiqKG4oMBS8mgqhMREFBdyOo4EAnliIrrpYWVjfT0NLQ
tU1nN7vVNj9t07RJ87O0X443Y8458b193/ecc/Eclf+RZ7OtwWoqU5bX1jK3WQqA4b+K9TVm
m7e24utGr22y2KRfcLvd2g3L9nhLS99bhw4lAZ96x60u+0Fv8wM/H3n3020vPpPEoCjW0ZE5
Z6mWN391Yv9gq0fzNOvVxh+DwdV/FJudzk3eWvv375z4SPojBekNi3zz3Unp626XA7srC7HB
V0WGn5Wp03tll8MRAfb9fbK70t16n2e8yz8hvWGR/ojIyOV5eelwuwS6jokEO0X66qT3451S
V1nSDewGHABsrbE/1vbUnkT/nznpDYsElkQG/QHpfL5duk52igxul/Fvt8vx/dViNhUPAT5A
AzB4XPaD9U3WX44dcZQruRR1Zrh09hSvvHac4hILwYsx3vxylc8HsmzZ0YzbdVeLzWxyAjkA
taK89L03Xm+td9+9icWpM5iNXhobm9hcaSGbvMDDOzSslWX8frmU5zpqqHVZ1KFArCmRyvYA
q6pBUUpyGf3pKodFefSRCkYCA0xMJri3+hxtT1SRSOj8Mf8QpWYnPT2jHH15K/6hqCMSSYeu
r29Mq5ncejS5sr5lz053Qzyexuez47knjtOh0TcQ4Up4G/HlBH6/n9jidYLBGQLD4auLycwZ
XRdNBdYyeX16MhRv69hbZTaaTWhaEd0/zTIwuIKqpBgdmyGRWGF5KUooFL04G1t9O5/XM8CS
ClAoFKIFnXRBlydd5TnFUevApBk49cM1Xjhg49yvM8zPhsmmU+dnY8n3Nzb0HHAJCN0kMZ3L
j0dj+cZ9PmPDxNQyTfe7sNtUPvxkjIVIXFJr2dPXoitfiEgOGAbmAG5FeSOvK+eDk/mOw7vW
LPnYFQLTJn7zzyUXljIfhOOps8AyEABuIqzc/gdGI/X2MstRrajoQUXFEF1KfZbOrS8AU8BV
QG7N/2vADZmBWsAK6MAYkL5T8C8m0GUZPNX0AAAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallSaveIcon
	"Private - Generated method"
	^ Icons
			at: #'smallSave'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallSaveIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallSaveIconContents
	"Private - Method generated with the content of the file /home/dgd/smallSave.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAAC40lEQVR4nIWSXWxTdRjGf+ecWlqWdlvPoWXZ
JiWyTwQEP7JMTCQhKJkChgSVhCgXJhAW0XDBHYGQ4EdMTORCE6/0QkVnDGkIDAlLUKQUljX7
KmaQsVr7tbXrej7WdT39ewOGwNDn9n1+7/u8yaPwP2pZpXb43LVS3jCspeby48D2Ro/a2rzi
m85WdfwJt/1HMBh0LeVTlrzapO1tXf/8hUMnv+h6b3cRWZJ8Q4OJQMGYD/1n3PWBQE1rs/bj
8U8+E5dTVXExKcS3Z74S2dsHxZauYGWl5u15LNweXBl8dl3L6C/hMXExKcTllBAJU4jpbEac
79snLvTtFmsa1dseUB95oa1R29K2YePAse+vPOmob6DOCZtU8C2D5TU19PffoGebk0TC8E0l
rfo5c+E8UAWQW5q0ve1rfb8eOeSvk0o6azzwnApuBQxD5+vTR9m1PQfAh4c34ldr3lE9y1+7
n0CWZd7av69TCWgO5qMfsBAfRQLGRqKEfujlzTcsdL3CiY9TOBSZ93ufcdZ5XSeBVQCKLEnL
Spa9s8HvlV7avILByADXI3/hcfzMi121jIwVuDb0NLKznlBokN4DbYSvp/2plBlbWKxMKFZp
MV0sLD71ysvBjlzOpLtbo2V1joDfxaWBFHeSXeTys4TDYTLTC0Sjk0RuJu9OF61zti1cCmBY
ZXtiPJbbsefVBo/T48blcnA2FGfgtwKKpDM0PMnsbIH8TJpYLD0Sz8wdK5dtC5hRAKrVarpq
Y1Zt0dNUV5L8zX7cLpnv+qZ4922VK79P8nc8ybypX41niqcqFbsE/AnE/m2iWSqPpjPlzte7
nR1jt/Ks3dCEpip8+vkw2VRO6Mb8T1PpwpdCiBJwE0g8XOVK2ZauRsfLe/ZvNbzlzB0iE26u
hRPF7Iz1UTKn9wN5IALM3YekhxvpdNKu1Xp7XQ7HC5KCnJ7RT5ulxSxwC7gLiAf9jyy4Jw/Q
DPgAGxgGzKWM/wCIojxGWb3q0gAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 23:00'!
smallSelectIcon
	"Private - Generated method"
	^ Icons
			at: #'smallSelect'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallSelectIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 23:00'!
smallSelectIconContents
	"Private - Method generated with the content of the file /home/dgd/smallSelect.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAABK0lEQVR4nKXOO0oEQRAG4L+6q2cfjojgBmJi
YmroEQwNBBPxFF7AzBt4DMHcyFwUE2MRPIDruuxMd9VvsKCbrOJOQVNNPT5KcHK7gTjdA2UH
MQzgnoCQIJ6AEAE3QFqQBSFk0DMcBaot1uxOobPjm/ODy/WhxrqvWvei1r35v1+FUIzM5mwz
PZt7a2Qx98eX9/Hp1cOFJpV0uD8aYUmkKJJixLBCXKxv1qmCSz/0VKtly79FEJlnjdBVgG+o
CljpgoVLJP499guQVFInIDtKJ6DJ3nQCPps86wTkgoYAVwYAycXYARAW8/8DKQZBgCgczdPr
x3h3azBwEtmc5qQZWZx0gsXJUpzFOe85+fw2mQCIgrPrbVg6AtFAQgHpAOznyTzTHRCDLNRt
ev8FfDedurn+q90AAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 23:00'!
smallUndoIcon
	"Private - Generated method"
	^ Icons
			at: #'smallUndo'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallUndoIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallUndoIconContents
	"Private - Method generated with the content of the file /home/dgd/smallUndo.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAACOklEQVR4nI3RT4iUdRzH8dfzPDOzOynJ7tZu
sJBCQaBJQUXkSiZeIumghy4FHpJOnez/QXfwECHBHjrpKS+CmEEbUst62A6CSMialmsabZjr
5Li27rizMz3PPL8OjYttSn5uv9/v83l/f9/vN3IXfURfke2Bm1McPUL7bj6Il19UeKWLi6uL
DpQih9fyyb3C/9EeKgcK8uu9QuiPwrdlYQ/ND+n53x8MM/J82fCbvVHUt2MnXxw3UABdJfbv
5rm3KC4HRJ3Kn75Q9s7Lfd28sZPZGuPHtG7d8msoqmZcbaYutcxmjMR8VmEeot1seqxkYscq
dHXTai7RFzOKMYW+Xp561sLAoNGDh0zVW3Mx2ypMJJvZN1SybqBAnGdL4Xbg7A3+WGTu5qIw
/Yue6Snr331fc2am+3LtxrYhDiabePjP3NYH/iIPrCgQRdRTrqScuN1oynwjs/LMSY+/94Hv
x8a7s2Au2czpRvDEdPBkf6DWII5YyPgp5/fc21eDHy8G6x9NdM3W2wbb89Keh0xfqTaSCcJ3
HN1A9UJuS54oljMaKaeCdIHXP+bYS1ya47XBwCP1qnjoRZOT535bWuNe9sesuZDZ9WXmzKmY
ZjC2j3rHci0ESglJnln4YVJErXDnTitcwwhGKm1PJ1Rvv+U8sybhwU6ien5KYPRfgGWwyTvP
gY39KHcS51vSmG/uCViuiGIh4nqTnwO1ts/3Mn/fgMDo16lXY2SZyxnDHfD9q8KGnHUxX1X+
mZe/ASGg28UCHOe+AAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 23:00'!
smallUpdateIcon
	"Private - Generated method"
	^ Icons
			at: #'smallUpdate'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallUpdateIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 23:00'!
smallUpdateIconContents
	"Private - Method generated with the content of the file /home/dgd/smallUpdate.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAACz0lEQVR4nI3SW2hTBwDG8f85iSdpEnIxR+01
0TlmbawOWy8PdXZYFRXLVHwYLt5ARMUXH0Rh0DxIq1jQl3irw6KCSMecKDiYVZEZ6+jEFsrs
apektsY2tWnNSU/S0+T45IMgxO/5+35Pn8CXRyqysRmROoOIVReJSDl+MeZbOcx85XaYL2/Z
tnV1bd16saKyGovVgZJ8z/ZNNQvzAYt27tja/dOe3UJfLEXwfhjloQqiAX+1i5JS75J8gDh/
/jzhbqifJxNejHIFVWUzmcxo9IR7sNrs5nzAlDqp6mFVEYQCAZ9nJovnyuR0nbe9r3n+Ovom
HzCazkzp5aUOwW1zM8tupvvvByhDL1lTs5Shwcg1sbzUsq92xcK++rqVI99VL+gvdnLLbWHZ
R6C9/VFkTbWXRF+IcPtF0rF/WVtTyc0r5yfC72gRdmypGzjbcrPsRU8vnuLZSKLGrbartN24
8bb/VeRoMsd/P9av+8vhchlNZhMDkQGms9ncLM/immAw+FS0O53uI40XOPnnMAdau/Cf/oNh
oZizF84VHjy0r1VVGej8p6szq88gqYgsqKhiND7aVVRUdALAKCLqU7qRVb5isjmdjl4DnUkd
57OX2O02Ach0vxpe2xe97isw4RlTuAcotRtzjwHEWGww7il0kZvWMBkNfF3oACClTDIxkcwC
aUBRNZ6NKbQBSiAQcEqSpAIYX3SGWv0HjwXu3G7BOnseGYsXr7uQ5XPLaAn+PgJMAjQ1NS0T
BEFOp9OqLMtHotHoJQABkDasXvLcv3evr6M7yrSWwfNNJb45Art37W86fDTwsyzLv42Pj49o
mpaSJMmUSCTuNTc33/kIUAUW/6njqY5QCKvNSmwwRkpNx1d+X7+npKTkQCKRaG9oaDjzuaMY
AGKgxYf+r9hU/0O5JBWIY2PvctGheOjbquWueDz+a2NjY2uew30SJ2D70vIHGPAd/9jj14AA
AAAASUVORK5CYII='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 23:00'!
smallVolumeIcon
	"Private - Generated method"
	^ Icons
			at: #'smallVolume'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallVolumeIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 23:00'!
smallVolumeIconContents
	"Private - Method generated with the content of the file /home/dgd/smallVolume.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAQAAAC1+jfqAAAAAmJLR0QA/4ePzL8AAAE3SURB
VHjajdE/SJRxHMfxF/f8Hp/n7vLhlAKhyKRCOpccA6EbFEW0BsciyKWphiBoCRuiQXEJnIyG
ampyEppydy8wBOFEyPzHA0X1wNGggV0Ivbbv8h3eH44rKWkT/XUNqdhxgrjz5kBTA90SiVlD
h0+PdI6PvZhKwDmPVL13G4KaOqcuTL+6k3z8iis+Sd0175pxy0H91ss066g+SKo+Q68uq4Zd
9M5DyyUdE6dHzg7XIrmdM7XHPriq8NoNaxJdgRypA7/Ezo8e9NjDpgzfhMC+kp92FXZb++u+
KKPbd5S1Ak2xVJ+WH3nzqQE5Jq3IpPJgY2GOrDe+NxhCYUvZkkGXvHHfkuJPhkr/4pNiZlsD
dbPq+ryVHS9Zqc1c39JAJhF5Zqw9dsXzw7yIXBb/u0fUNt7/+A0ZzEdfNHX2/wAAAABJRU5E
rkJggg=='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 23:00'!
smallWindowIcon
	"Private - Generated method"
	^ Icons
			at: #'smallWindow'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallWindowIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 23:00'!
smallWindowIconContents
	"Private - Method generated with the content of the file /home/dgd/smallWindow.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAAA80lEQVR4nO2PMUvDUBhFz5c+IjFp0YJD0SWL
i6OL0FIQQUQo/gk3wcXN0X8hOvgHXFRo54qWLoogKC2Eoh26iOBQadP3XpeOBpJBXLzj5TuH
+8FfR6q1/XC3XL7TYRgIjhWbfKyVFbEwiHofT7f3282b065yPW9zY/RVikpFbGGRfM5LFAzG
n1hg2XXzzavLQ+BYjb5j019bpbKyAFhgmDzBnwOg/vCGnsQ+UFQAeztVAn8+/eNbcHZ+AYCT
nvo5/wJwxDHj59coE/TS6WGMjgFU7OrGwdHJteQkSCuwEzN87z62AGTWrQNLmWaABtoZmV/I
FJjvR0sUmC0hAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
squeakIcon
	"Private - Generated method"
	^ Icons
			at: #'squeak'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self squeakIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
squeakIconContents
	"Private - Method generated with the content of the file /home/dgd/squeak.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABwAAAAcCAYAAAByDd+UAAAABHNCSVQICAgIfAhkiAAAABF0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'! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
volumeIcon
	"Private - Generated method"
	^ Icons
			at: #'volume'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self volumeIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
volumeIconContents
	"Private - Method generated with the content of the file /home/dgd/volume.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABgAAAAYCAQAAABKfvVzAAAABGdBTUEAALGOfPtRkwAAACBj
SFJNAAB6JQAAgIMAAPn/AACA6QAAdTAAAOpgAAA6mAAAF2+SX8VGAAAAAmJLR0QA/4ePzL8A
AAAJcEhZcwAACxMAAAsTAQCanBgAAAHrSURBVDjLldTLahRBFMbx/xu02hEvm1mZIC4qovaA
LhoE142+QIMvILoRgjASdKEilSBxO5CFIhKbmUAQNWmD6KCQxCAMEi+JGGKISuETfC665uIM
DqRqd6hfn9Nd5zRidxsBV/jOH5rc5QhjJBDwnyUQ43xmix9ssMo8GRiygaBBg0dMM887FsCE
jvyfUwEZaRdY5CrDnOUyt8GE7pbaIKEEgEGYNnjpowmYIXdfeQfErJMAUCliArFMAJwEM+Sm
9V5r6iopIC+eXdDiK1lycux+90Qb2tavAlQxFxgBwwoAl8haIH+sTKN6oZ/6rW1ttjJYzEMO
QZUEKPnTgnxHmzqjHW3pm77ooxApEFC9QwoxVV+U8eCTmirrq9bU1KqWVNZBEewDe55JwGfM
iT1Y0hud0gct661ea1HndEzEQOUiUxzoBwt6quNq6JVyPdOcTuuwCE6AtUywpx/Mqq5RPdec
ZlVTTTjSBxBgp7gGCRYA136HG7qpYU2qrppqqou8VtxAcI8RyDBACddzD6GzbTAOFYIxjkLs
C6pQbYHWMqGbUF11kcNeH2OdEhDgiHsBmNBZzXRaI2XFN4YtWr4LREREYEJ3vQNKfpRSXNGh
PaBMBIb+ebA+Tz/wZPDE0ZMjgiAaBHb919jd/gvLk2YJrn7DBgAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
windowIcon
	"Private - Generated method"
	^ Icons
			at: #'window'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self windowIconContents readStream) ].! !

!MenuIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
windowIconContents
	"Private - Method generated with the content of the file /home/dgd/window.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABwAAAAcCAYAAAByDd+UAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAAB5UlEQVR4nO2WP2gTURzHP/fuEqMpZ1vUKBqq
FHFTB/+0XVSKRSxCBUVHQXHoUHeh4thFVwcnFwWdNFBErWgVVBIXBRGs1pZEjamtucvl7nKX
O4fkoPXPkHqCw32m977vz4f3ePB7EBEyUtDoGzrbLRDpMDeX63XjceZqDvCDTAHoP3HuwsHd
uy5uVNukuXQXruSR8ORlSaqyS6IuYwqX79MFfKG8mLx9pWeJcNv2HSOnx69Lq18+Z+zRJHmj
xNEt+5Al0ZJs3tZ4kM/SrW7ivZant7+Xzx9n9n79NHDkbfbeXcBRAN69eq3cHzzJ+sPHWGsn
SMopSvlCy6fz8NmqpOiwYgglxdybaWanpjArCzuBBeCpAmCZVZ4Uiwzs30NXpdRcXm5ZCLAO
AJ2U6/Iwl8N1nGCoA5pXGospjI0Oo7YllyX5E4cO9HD8zHlmF2UCYE1nuwhbBhCPx9ic3rAk
a+1VhEAkjISR8D8RGlXT9zzvnwjKuvGrsKxXStdujmPZtdBEtZrDrTsTfJgpUDMqepBLAH2D
p4aFiF+WJGlFaMYGvmVoz7ITNy4BDpAJvhirVibVoaTaqYZps23L1ue/BHXOATJKs2OahvbN
NDQrTOFPFGHRJwqQaRRJ6bfT/w6XRsWPCJ8feQeiSATBXJcAAAAASUVORK5CYII='! !


!MorphHierarchy methodsFor: 'accessing' stamp: 'dgd 9/26/2004 18:29'!
roots
	"Answer the roots for the Object Hierarchy, that means answer the World"
	^ {MorphListItemWrapper with: World}! !

!MorphHierarchy methodsFor: 'accessing' stamp: 'dgd 9/26/2004 18:30'!
selected: aMorphListItemWrapper 
	"Change the selected object"
	| newSelection |
	aMorphListItemWrapper isNil
		ifTrue: [^ self].
	newSelection := aMorphListItemWrapper withoutListWrapper.
	newSelection == World selectedObject
		ifTrue: [newSelection removeHalo]
		ifFalse: [newSelection addHalo].
	self changed: #selected! !

!MorphHierarchy methodsFor: 'private' stamp: 'dgd 9/26/2004 18:28'!
asMorph
	"Answer the morph version of the receiver"
	| morph |
	morph := MorphHierarchyListMorph
				on: self
				list: #roots
				selected: nil
				changeSelected: #selected:.
	""
	^ morph inAContainer! !


!MorphHierarchy class methodsFor: 'opening' stamp: 'dgd 9/25/2004 21:50'!
openOrDelete
	| oldMorph |
	oldMorph := World submorphs
				detect: [:each | each hasProperty: #morphHierarchy]
				ifNone: [| newMorph | 
					newMorph := self new asMorph.
					newMorph bottomLeft: ActiveHand position.
					newMorph openInWorld.
					newMorph isFullOnScreen
						ifFalse: [newMorph goHome].
					^ self].
	""
	oldMorph delete! !


!MorphListItemWrapper methodsFor: 'accessing' stamp: 'dgd 9/26/2004 20:20'!
contents
	"Answer the receiver's contents"
	| submorphs |
	submorphs := Preferences noviceMode
				ifTrue: [""item submorphs
						reject: [:each | ""
							each isSystemWindow
								or: [each isDockingBar]
								or: [each isKindOf: HaloMorph]
								or: [each hasProperty: #morphHierarchy]
								or: [each isFlapOrTab]
								or: [each isObjectsTool]]]
				ifFalse: [""item submorphs
						reject: [:each | each isKindOf: HaloMorph]].
	^ submorphs
		collect: [:each | self class with: each]! !

!MorphListItemWrapper methodsFor: 'accessing' stamp: 'dgd 9/26/2004 18:22'!
icon
	"Answer a form to be used as icon"
	^ item iconOrThumbnailOfSize: 28! !

!MorphListItemWrapper methodsFor: 'converting' stamp: 'dgd 9/26/2004 18:26'!
asString
	"Answer the string representation of the receiver"
	^ item externalName! !


!ObjectExplorerWrapper methodsFor: 'accessing' stamp: 'dgd 9/26/2004 18:34'!
icon
	"Answer a form to be used as icon"
	^ Preferences visualExplorer
		ifTrue: [item iconOrThumbnailOfSize: 16]
		ifFalse: [nil]! !


!PasteUpMorph methodsFor: 'event handling' stamp: 'dgd 9/25/2004 21:40'!
mouseDown: evt
	"Handle a mouse down event."
	| grabbedMorph handHadHalos |

	(Preferences generalizedYellowButtonMenu
			and: [evt yellowButtonPressed])
		ifTrue: [^ self yellowButtonActivity: evt shiftPressed].

	grabbedMorph _ self morphToGrab: evt.
	grabbedMorph ifNotNil:[
		grabbedMorph isSticky ifTrue:[^self].
		self isPartsBin ifFalse:[^evt hand grabMorph: grabbedMorph].
		grabbedMorph _ grabbedMorph partRepresented duplicate.
		grabbedMorph restoreSuspendedEventHandler.
		(grabbedMorph fullBounds containsPoint: evt position) 
			ifFalse:[grabbedMorph position: evt position].
		"Note: grabbedMorph is ownerless after duplicate so use #grabMorph:from: instead"
		^ evt hand grabMorph: grabbedMorph from: self].

	(super handlesMouseDown: evt)
		ifTrue:[^super mouseDown: evt].

	handHadHalos _ evt hand halo notNil.

	evt hand removeHalo. "shake off halos"
	evt hand releaseKeyboardFocus. "shake of keyboard foci"

	self submorphs
		select:[:each | each hasProperty: #morphHierarchy]
		thenDo:[:each | each delete].

	Preferences noviceMode
		ifTrue:[
			self submorphs
				select:[:each | (each isKindOf: MenuMorph) and:[each stayUp not]]
				thenDo:[:each | each delete].
		].

	(evt shiftPressed not
			and:[ self isWorldMorph not ]
			and:[ Preferences easySelection not ])
	ifTrue:[
		"explicitly ignore the event if we're not the world and we'll not select,
		so that we could be picked up if need be"
		evt wasHandled: false.
		^ self.
	].

	( evt shiftPressed or: [ Preferences easySelection ] ) ifTrue:[
		"We'll select on drag, let's decide what to do on click"
		| clickSelector |

		clickSelector := nil.

		evt shiftPressed ifTrue:[
			clickSelector := #findWindow:.
		]
		ifFalse:[
			self isWorldMorph ifTrue:[
				clickSelector := handHadHalos
										ifTrue: [ #delayedInvokeWorldMenu: ]
										ifFalse: [ #invokeWorldMenu: ]
			]
		].

		evt hand 
				waitForClicksOrDrag: self 
				event: evt 
				selectors: { clickSelector. nil. nil. #dragThroughOnDesktop: }
				threshold: 5.
	]
	ifFalse:[
		"We wont select, just bring world menu if I'm the world"
		self isWorldMorph ifTrue:[
			handHadHalos
				ifTrue: [ self delayedInvokeWorldMenu: evt ]
				ifFalse: [ self invokeWorldMenu: evt ]
		]
	].
! !


!SimpleHierarchicalListMorph methodsFor: 'accessing' stamp: 'dgd 9/26/2004 18:23'!
roots
	"Answer the receiver's roots"
	^ scroller submorphs
		select: [:each | each indentLevel isZero]! !

!SimpleHierarchicalListMorph methodsFor: 'events' stamp: 'dgd 9/26/2004 18:24'!
expandRoots
	"Expand all the receiver's roots"
	self roots
		do: [:each |
			(each canExpand and: [each isExpanded not])
				ifTrue: [each toggleExpandedState]].
	self adjustSubmorphPositions! !


!MorphHierarchyListMorph methodsFor: 'initialization' stamp: 'dgd 9/26/2004 18:18'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel menu: getMenuSel keystroke: keyActionSel 
	super
		on: anObject
		list: getListSel
		selected: getSelectionSel
		changeSelected: setSelectionSel
		menu: getMenuSel
		keystroke: keyActionSel.
	""
	self borderWidth: 0.
	self autoDeselect: false.
	self enableDrag: false.
	self enableDrop: true.
	self hResizing: #spaceFill.
	self vResizing: #spaceFill.
self expandRoots! !

!MorphHierarchyListMorph methodsFor: 'selection' stamp: 'dgd 9/25/2004 21:28'!
setSelectedMorph: aMorph 
	super setSelectedMorph: aMorph.
self owner isNil ifFalse:[self owner delete]! !

!MorphHierarchyListMorph methodsFor: 'private' stamp: 'dgd 9/26/2004 18:57'!
createContainer
	"Private - Create a container"
	| container |
	container := BorderedMorph new.
	container extent: (World extent * (1 / 4 @ (2 / 3))) rounded.
	container layoutPolicy: TableLayout new.
	container hResizing: #rigid.
	container vResizing: #rigid.
	container
		setColor: Preferences menuColor
		borderWidth: Preferences menuBorderWidth
		borderColor: Preferences menuBorderColor.
	container layoutInset: 0.
	"container useRoundedCorners."
	""
	container setProperty: #morphHierarchy toValue: true.
	container setNameTo: 'Objects Hierarchy' translated.
	""
	^ container! !

!MorphHierarchyListMorph methodsFor: 'private' stamp: 'dgd 9/26/2004 18:27'!
inAContainer
	"Answer the receiver contained in a proper container"
	| container |
	container := self createContainer.
	container addMorphBack: self.
	" 
	nasty hack to force the scroolbar recreation"
	self extent: container extent - container borderWidth.
	""
	^ container! !


!TheWorldMainDockingBar methodsFor: 'menu actions' stamp: 'dgd 9/25/2004 21:50'!
viewObjectsHierarchy
	"self world findWindow: nil"
	MorphHierarchy openOrDelete! !


!ObjectExplorerWrapper reorganize!
('accessing' contents hasContents icon)
('as yet unclassified' canBeDragged parent parent: selector setItem:name:model: setItem:name:model:parent:)
('converting' asString itemName)
('monitoring' refresh)
!


!FileDirectoryWrapper reorganize!
('as yet unclassified' balloonText: directoryNamesFor: setItem:name:model: settingSelector)
('converting' asString)
('accessing' balloonText contents hasContents icon)
!


!ListItemWrapper reorganize!
('accessing' balloonText contents hasContents highlightingColor icon preferredColor setItem: setItem:model:)
('as yet unclassified' acceptDroppingObject: canBeDragged handlesMouseOver: hasEquivalentIn: sendSettingMessageTo: settingSelector wantsDroppedObject:)
('converting' asString withoutListWrapper)
!

StringMorph subclass: #IndentingListItemMorph
	instanceVariableNames: 'indentLevel isExpanded complexContents firstChild container nextSibling icon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tools-Explorer'!

!IndentingListItemMorph reorganize!
('accessing' balloonText canExpand children firstChild hasIcon icon indentLevel isExpanded isExpanded: isFirstItem isSoleItem nextSibling nextSibling: userString)
('converting' withoutListWrapper)
('drag and drop' acceptDroppingMorph:event:)
('drawing' drawLineToggleToTextOn:lineColor:hasToggle: drawLinesOn:lineColor: drawLinesToFirstChildOn:lineColor: drawLinesToNextSiblingOn:lineColor:hasToggle: drawOn: drawToggleOn:in: unhighlight)
('enumeration' childrenDo:)
('halos and balloon help' boundsForBalloon)
('initialization' initWithContents:prior:forList:indentLevel: initialize)
('layout' minHeight minWidth)
('mouse events' inToggleArea:)
('private' hasToggle toggleBounds toggleRectangle withSiblingsDo:)
('private-container protocol' addChildrenForList:addingTo:withExpandedItems: complexContents highlight openPath: recursiveAddTo: recursiveDelete toggleExpandedState)
!


!Form reorganize!
('*ft2-fonts-debugging')
('accessing' bits bits: bitsSize center defaultCanvasClass depth depth: displayScreen extent form getCanvas hasBeenModified hasBeenModified: height nativeDepth offset offset: size width)
('analyzing' cgForPixelValue:orNot: colorsUsed dominantColor innerPixelRectFor:orNot: pixelCompare:with:at: primCountBits rectangleEnclosingPixelsNotOfColor: tallyPixelValues tallyPixelValuesInRect:into: xTallyPixelValue:orNot: yTallyPixelValue:orNot:)
('bordering' border:width:rule:fillColor: borderFormOfWidth:sharpCorners: borderWidth: borderWidth:color: borderWidth:fillColor: shapeBorder:width: shapeBorder:width:interiorPoint:sharpCorners:internal:)
('color mapping' balancedPatternFor: bitPatternFor: colormapFromARGB colormapIfNeededFor: colormapIfNeededForDepth: colormapToARGB makeBWForm: mapColor:to: mapColors:to: maskingMap newColorMap pixelValueFor: pixelWordFor: reducedPaletteOfSize: rgbaBitMasks)
('converting' as8BitColorForm asCursorForm asFormOfDepth: asGrayScale asMorph colorReduced copyWithColorsReducedTo: orderedDither32To16)
('copying' blankCopyOf:scaledBy: contentsOfArea: contentsOfArea:into: copy: copy:from:in:rule: copy:from:to:rule: copyBits:at:translucent: copyBits:from:at:clippingBox:rule:fillColor: copyBits:from:at:clippingBox:rule:fillColor:map: copyBits:from:at:colorMap: deepCopy veryDeepCopyWith:)
('display box access' boundingBox computeBoundingBox)
('displaying' displayInterpolatedIn:on: displayInterpolatedOn: displayOn:at:clippingBox:rule:fillColor: displayOn:transformation:clippingBox:align:with:rule:fillColor: displayOnPort:at: displayResourceFormOn: displayScaledOn: drawLine:from:to:clippingBox:rule:fillColor: paintBits:at:translucent:)
('editing' bitEdit bitEditAt:scale: edit morphEdit)
('encoding' addDeltasFrom: deltaFrom: deltaFrom:at: encodeForRemoteCanvas)
('fileIn/Out' comeFullyUpOnReload: hibernate objectForDataStream: printOn: readAttributesFrom: readBitsFrom: readFrom: readFromOldFormat: replaceByResource: store15To24HexBitsOn: store32To24HexBitsOn: storeBits:to:on: storeBitsOn:base: storeHexBitsOn: storeOn: storeOn:base: unhibernate writeAttributesOn: writeBMPfileNamed: writeBitsOn: writeJPEGfileNamed: writeJPEGfileNamed:progressive: writeOn: writeOnMovie: writeUncompressedOn:)
('filling' anyShapeFill bitPatternForDepth: convexShapeFill: eraseShape: fill:rule:fillColor: fillFromXColorBlock: fillFromXYColorBlock: fillFromYColorBlock: findShapeAroundSeedBlock: floodFill2:at: floodFill:at: floodFill:at:tolerance: floodFillMapFrom:to:mappingColorsWithin:to: shapeFill:interiorPoint: shapeFill:seedBlock:)
('image manipulation' replaceColor:withColor: smear:distance: stencil trimBordersOfColor:)
('initialize-release' allocateForm: finish flush fromDisplay: shutDown swapEndianness)
('other' fixAlpha formForColorCount: graphicForViewerTab primPrintHScale:vScale:landscape: relativeTextAnchorPosition setAsBackground)
('pixel access' colorAt: colorAt:put: isTransparentAt: pixelValueAt: pixelValueAt:put:)
('postscript generation' bitsPerComponent bytesPerRow decodeArray encodePostscriptOn: numComponents paddedWidth printPostscript:operator: rowPadding setColorspaceOn: storePostscriptHexOn:)
('resources' readNativeResourceFrom: readResourceFrom: resourceTag storeResourceOn:)
('scaling, rotation' flipBy:centerAt: magnify:by: magnify:by:smoothing: magnifyBy: rotateBy: rotateBy:centerAt: rotateBy:magnify:smoothing: rotateBy:smoothing: scaledIntoFormOfSize: scaledToSize: shrink:by:)
('testing' appearsToBeSameCostumeAs: hasNonStandardPalette isAllWhite isBigEndian isBltAccelerated:for: isDisplayScreen isExternalForm isFillAccelerated:for: isForm isLittleEndian isStatic isTranslucent shouldPreserveContents)
('transitions' fadeImage:at:indexAndMaskDo: fadeImageCoarse:at: fadeImageFine:at: fadeImageHor:at: fadeImageHorFine:at: fadeImageSquares:at: fadeImageVert:at: pageImage:at:corner: pageWarp:at:forward: slideImage:at:delta: wipeImage:at:clippingBox:rectForIndex: wipeImage:at:delta: wipeImage:at:delta:clippingBox: zoomIn:orOutTo:at:vanishingPoint: zoomInTo:at: zoomOutTo:at:)
('private' hackBits: initFromArray: privateFloodFillValue: setExtent:depth: setExtent:depth:bits: setResourceBits:)
('*Balloon3D-Kernel')
('thumbnail' iconOrThumbnailOfSize:)
!


!Color reorganize!
('access' alpha blue brightness green hue luminance red saturation)
('equality' = diff: hash)
('queries' basicType isBitmapFill isBlack isColor isGradientFill isGray isOpaque isOrientedFill isSolidFill isTranslucent isTranslucentColor isTransparent)
('transformations' * + - / adjustBrightness: adjustSaturation:brightness: alpha: alphaMixed:with: atLeastAsLuminentAs: atMostAsLuminentAs: blacker dansDarker darker duller lighter mixed:with: muchDarker muchLighter negated orColorUnlike: paler slightlyDarker slightlyLighter slightlyWhiter twiceDarker twiceLighter veryMuchLighter whiter)
('groups of shades' darkShades: lightShades: mix:shades: wheel:)
('printing' byteEncode: printOn: shortPrintString storeArrayOn: storeArrayValuesOn: storeOn:)
('other' colorForInsets display name newTileMorphRepresentative raisedColor rgbTriplet)
('conversions' asColor asColorref asHTMLColor asNontranslucentColor balancedPatternForDepth: bitPatternForDepth: closestPixelValue1 closestPixelValue2 closestPixelValue4 closestPixelValue8 dominantColor halfTonePattern1 halfTonePattern2 indexInMap: makeForegroundColor pixelValue32 pixelValueForDepth: pixelWordFor:filledWith: pixelWordForDepth: scaledPixelValue32)
('private' attemptToMutateError flushCache privateAlpha privateBlue privateGreen privateRGB privateRed setHue:saturation:brightness: setPrivateRed:green:blue: setRGB: setRed:green:blue: setRed:green:blue:range:)
('copying' veryDeepCopyWith:)
('Morphic menu' addFillStyleMenuItems:hand:from: changeColorIn:event:)
('*nebraska-Morphic-Remote' encodeForRemoteCanvas)
('*morphic-Postscript Canvases' encodePostscriptOn:)
('*Balloon3D-Kernel')
('thumbnail' iconOrThumbnailOfSize:)
!


!Object reorganize!
('*FSM-events')
('*connectors-debugging')
('*connectors-error handling')
('*connectors-events')
('*connectors-message handling')
('*monticello')
('*sunit-preload' sunitAddDependent: sunitChanged: sunitRemoveDependent:)
('*system-support' systemNavigation)
('*tools-browser' browse browseHierarchy)
('Breakpoint' break)
('accessing' addInstanceVarNamed:withValue: at: at:modify: at:put: basicAt: basicAt:put: basicSize bindWithTemp: doIfNotNil: ifNotNilDo: in: presenter readFromString: size yourself)
('associating' ->)
('binding' bindingOf:)
('casing' caseOf: caseOf:otherwise:)
('class membership' class inheritsFromAnyIn: isKindOf: isKindOf:orOf: isMemberOf: respondsTo: xxxClass)
('comparing' = closeTo: hash hashMappedBy: identityHashMappedBy: identityHashPrintString literalEqual: ~=)
('converting' adaptToFloat:andSend: adaptToFraction:andSend: adaptToInteger:andSend: as: asActionSequence asActionSequenceTrappingErrors asDraggableMorph asOrderedCollection asString asStringOrText complexContents mustBeBoolean mustBeBooleanIn: printDirectlyToDisplay withoutListWrapper)
('copying' clone copy copyAddedStateFrom: copyFrom: copySameFrom: copyTwoLevel deepCopy initialDeepCopierSize postCopy shallowCopy veryDeepCopy veryDeepCopySibling veryDeepCopyUsing: veryDeepCopyWith: veryDeepFixupWith: veryDeepInner:)
('creation' asMorph asStringMorph asTextMorph openAsMorph)
('dependents access' addDependent: breakDependents canDiscardEdits dependents evaluate:wheneverChangeIn: hasUnacceptedEdits myDependents myDependents: release removeDependent:)
('deprecated' beep: beepPrimitive)
('drag and drop' acceptDroppingMorph:event:inMorph: dragAnimationFor:transferMorph: dragPassengerFor:inMorph: dragTransferType dragTransferTypeForMorph: wantsDroppedMorph:event:inMorph:)
('error handling' assert: caseError confirm: confirm:orCancel: deprecated: deprecated:block: deprecated:explanation: deprecatedExplanation: doesNotUnderstand: dpsTrace: dpsTrace:levels: dpsTrace:levels:withContext: error: externalCallFailed halt halt: handles: notify: notify:at: notifyWithLabel: primitiveFailed shouldBeImplemented shouldNotImplement subclassResponsibility tryToDefineVariableAccess:)
('evaluating' value valueWithArguments:)
('events-accessing' actionForEvent: actionForEvent:ifAbsent: actionMap actionSequenceForEvent: actionsDo: createActionMap hasActionForEvent: setActionSequence:forEvent: updateableActionMap)
('events-registering' when:evaluate: when:send:to: when:send:to:with: when:send:to:withArguments:)
('events-removing' releaseActionMap removeAction:forEvent: removeActionsForEvent: removeActionsSatisfying: removeActionsSatisfying:forEvent: removeActionsWithReceiver: removeActionsWithReceiver:forEvent:)
('events-triggering' triggerEvent: triggerEvent:ifNotHandled: triggerEvent:with: triggerEvent:with:ifNotHandled: triggerEvent:withArguments: triggerEvent:withArguments:ifNotHandled:)
('filter streaming' byteEncode: drawOnCanvas: elementSeparator encodePostscriptOn: flattenOnStream: fullDrawPostscriptOn: printOnStream: putOn: storeOnStream: writeOnFilterStream:)
('finalization' actAsExecutor executor finalizationRegistry finalize retryWithGC:until: toFinalizeSend:to:with:)
('flagging' isThisEverCalled isThisEverCalled: logEntry logExecution logExit)
('graph model' addModelYellowButtonMenuItemsTo:forMorph:hand: hasModelYellowButtonMenuItems)
('inspecting' basicInspect inspect inspectorClass)
('locales' localeChanged)
('macpal' codeStrippedOut: contentsChanged currentEvent currentHand currentVocabulary currentWorld flash ifKindOf:thenDo: instanceVariableValues isUniversalTiles objectRepresented playSoundNamed: refusesToAcceptCode scriptPerformer slotInfo)
('message handling' perform: perform:orSendTo: perform:with: perform:with:with: perform:with:with:with: perform:withArguments: perform:withArguments:inSuperclass: withArgs:executeMethod:)
('objects from disk' comeFullyUpOnReload: convertToCurrentVersion:refStream: indexIfCompact objectForDataStream: readDataFrom:size: saveOnFile storeDataOn:)
('parts bin' descriptionForPartsBin)
('printing' fullPrintString isLiteral longPrintOn: longPrintOn:limitedTo:indent: longPrintString nominallyUnsent: printOn: printString printStringLimitedTo: propertyList reportableSize storeOn: storeString stringForReadout stringRepresentation)
('scripting' adaptedToWorld: contentsGetz: defaultFloatPrecisionFor: evaluateUnloggedForSelf: methodInterfacesForCategory:inVocabulary:limitClass: methodInterfacesForInstanceVariablesCategoryIn: methodInterfacesForScriptsCategoryIn: selfWrittenAsIll selfWrittenAsIm selfWrittenAsMe selfWrittenAsMy selfWrittenAsThis)
('scripts-kernel' universalTilesForGetterOf: universalTilesForInterface:)
('system primitives' asOop becomeForward: becomeForward:copyHash: className creationStamp instVarAt: instVarAt:put: instVarNamed: instVarNamed:put: oopString primitiveChangeClassTo: rootStubInImageSegment: someObject)
('testing' basicType beViewed costumes haltIfNil haveFullProtocolBrowsed haveFullProtocolBrowsedShowingSelector: isBehavior isBlock isBlockClosure isCharacter isCollection isColor isColorForm isCompiledMethod isComplex isFloat isForm isFraction isHeap isInteger isInterval isMessageSend isMorph isMorphicEvent isMorphicModel isNumber isPoint isPseudoContext isStream isString isSymbol isSystemWindow isText isTransparent isVariableBinding isWebBrowser knownName name nameForViewer notNil openInstanceBrowserWithTiles renameTo: showDiffs stepAt:in: stepIn: stepTime stepTimeIn: vocabularyDemanded wantsDiffFeedback wantsSteps wantsStepsIn:)
('translation support' inline: var:declareC:)
('undo' capturedState commandHistory purgeAllCommands redoFromCapturedState: refineRedoTarget:selector:arguments:in: refineUndoTarget:selector:arguments:in: rememberCommand: rememberUndoableAction:named: undoFromCapturedState:)
('updating' changed changed: changed:with: handledListVerification noteSelectionIndex:for: okToChange update: update:with: updateListsAndCodeIn: windowIsClosing)
('user interface' addModelItemsToWindowMenu: addModelMenuItemsTo:forMorph:hand: asExplorerString beep defaultBackgroundColor defaultLabelForInspector eToyStreamedRepresentationNotifying: explore fullScreenSize hasContentsInExplorer inform: initialExtent inspectWithLabel: launchPartVia: launchPartVia:label: launchTileToRefer modelSleep modelWakeUp modelWakeUpIn: mouseUpBalk: newTileMorphRepresentative notYetImplemented windowActiveOnFirstClick windowReqNewLabel:)
('viewer' assureUniClass belongsToUniClass browseOwnClassSubProtocol categoriesForViewer: categoriesForVocabulary:limitClass: chooseNewNameForReference defaultLimitClassForVocabulary: defaultNameStemForInstances elementTypeFor:vocabulary: externalName graphicForViewerTab hasUserDefinedSlots infoFor:inViewer: initialTypeForSlotNamed: isPlayerLike methodInterfacesInPresentationOrderFrom:forCategory: newScriptorAround: offerViewerMenuFor:event: offerViewerMenuForEvt:morph: renameScript: tilePhrasesForCategory:inViewer: tilePhrasesForMethodInterfaces:inViewer: tilePhrasesForSelectorList:inViewer: tileToRefer uniqueInstanceVariableNameLike:excluding: uniqueNameForReference uniqueNameForReferenceFrom: uniqueNameForReferenceOrNil updateThresholdForGraphicInViewerTab usableMethodInterfacesIn:)
('world hacking' couldOpenInMorphic)
('private' errorImproperStore errorNonIntegerIndex errorNotIndexable errorSubscriptBounds: primitiveError: species storeAt:inTempFrame:)
('thumbnail' iconOrThumbnailOfSize:)
!

